//LICENSE A

//
//  Main configuration parameters and macros for working with them
//
#ifndef ICONFIGURE_H
#define ICONFIGURE_H

//
//  Supported extensions
//
#define IEXTENSION_NONE		0
#define IEXTENSION_MV		0x80000000

#include "iextensiondefines.h"

//
//  Supported shells
//
#define ISHELL_OS			1
#define ISHELL_CL			2
#define ISHELL_GG			0xFFFFFFFC
#define ISHELL_QT			4

//
//  Supported scripts
//
#define ISCRIPT_PYTHON		1

//
//  Multiple extensions can be included, they are not exclusive
//
#define IEXTENSION_INCLUDED(_Type_)  ((IEXTENSION & _Type_) != 0)

//
//  Multiple shells can be included, they are not exclusive
//
#define ISHELL_INCLUDED(_Type_)  ((ISHELL & _Type_) != 0)

//
//  Multiple scripts can be included, they are not exclusive
//
#define ISCRIPT_INCLUDED(_Type_)  ((ISCRIPT & _Type_) != 0)

//
//  ******************************************************************************
//
//  Set the parameters that define shell and extension.
//
#ifdef I_EXTERNAL_CONFIGURATION
#include "iconfiguresettings.ext.h"
#else
#define IEXTENSION	0xFFFFFFFF
#define ISHELL		0xFFFFFFFF 
#define ISCRIPT		1
#endif
//
//  ******************************************************************************
//

#if !defined(IEXTENSION) 
#error Misconfiguration: extension (IEXTENSION) is not set.
!TERMINATE!
#endif

#if !defined(ISHELL) || (ISHELL == 0)
#error Misconfiguration: shell (ISHELL) is not set.
!TERMINATE!
#endif

#if !defined(ISCRIPT)
#error Misconfiguration: script (ISCRIPT) is not set.
!TERMINATE!
#endif

#endif // ICONFIGURE_H
