//LICENSE A


#include "iabstractextension.h"


#include "icrosssectionviewsubject.h"
#include "ierror.h"
#include "iobjectfactory.h"
#include "iparticleviewsubject.h"
#include "isurfaceviewsubject.h"
#include "itensorfieldviewsubject.h"
#include "ivectorfieldviewsubject.h"
#include "ivolumeviewsubject.h"


int iAbstractExtension::DefineToId(int n)
{
	int id = -1;
	unsigned int k = (unsigned int)n;
	while(k != 0U)
	{
		id++;
		k = k >> 1;
	}
	return id;
}


iAbstractExtension::iAbstractExtension(int n, const iString& name) : mId(iAbstractExtension::DefineToId(n)), mName(name), mSubjectCounter(0)
{
	//
	//  Check that we configured correctly
	//
	if(n != (1<<mId))
	{
		IBUG_FATAL("Incorrectly configured extension.")
	}

	iObjectFactory::AttachExtension(this);
}


iCrossSectionViewSubject* iAbstractExtension::CreateCrossSectionSubject(iViewObject *, int) const
{
	return 0;
}


iParticleViewSubject* iAbstractExtension::CreateParticleSubject(iViewObject *, int) const
{
	return 0;
}


iSurfaceViewSubject* iAbstractExtension::CreateSurfaceSubject(iViewObject *, int) const
{
	return 0;
}


iTensorFieldViewSubject* iAbstractExtension::CreateTensorFieldSubject(iViewObject *, int) const
{
	return 0;
}


iVectorFieldViewSubject* iAbstractExtension::CreateVectorFieldSubject(iViewObject *, int) const
{
	return 0;
}


iVolumeViewSubject* iAbstractExtension::CreateVolumeSubject(iViewObject *, int) const
{
	return 0;
}


iViewObject* iAbstractExtension::CreateSpecialObject(iViewModule*, const iString &) const
{
	return 0;
}


iPickerExtension* iAbstractExtension::CreatePickerExtension(iPicker * ) const
{
	return 0;
}


iViewModuleExtension* iAbstractExtension::CreateViewModuleExtension(iViewModule * ) const
{
	return 0;
}




//
// Creator helpers
//
iCrossSectionViewSubject* iAbstractExtension::NewCrossSectionSubject(iViewObject *obj, const iDataType& type) const
{
	return iCrossSectionViewSubject::New(obj,type);
}


iParticleViewSubject* iAbstractExtension::NewParticleSubject(iViewObject *obj, const iDataType& type, const iColor& color) const
{
	return iParticleViewSubject::New(obj,type,color);
}


iSurfaceViewSubject* iAbstractExtension::NewSurfaceSubject(iViewObject *obj, const iDataType& type) const
{
	return iSurfaceViewSubject::New(obj,type);
}


iTensorFieldViewSubject* iAbstractExtension::NewTensorFieldSubject(iViewObject *obj, const iDataType& type, const iDataType& stype) const
{
	return iTensorFieldViewSubject::New(obj,type,stype);
}


iVectorFieldViewSubject* iAbstractExtension::NewVectorFieldSubject(iViewObject *obj, const iDataType& type, const iDataType& stype) const
{
	return iVectorFieldViewSubject::New(obj,type,stype);
}


iVolumeViewSubject* iAbstractExtension::NewVolumeSubject(iViewObject *obj, const iDataType& type) const
{
	return iVolumeViewSubject::New(obj,type);
}

