//LICENSE A

//
//  A simple collection of iActors
//
#ifndef IACTORCOLLECTION_H
#define IACTORCOLLECTION_H


#include <vtkObject.h>


#include "iarray.h"

class iActor;


class iActorCollection : public vtkObject
{

public:

	vtkTypeMacro(iActorCollection,vtkObject);
	static iActorCollection* New();

	void SetVisibility(int s);
	
	inline void VisibilityOn(){ this->SetVisibility(1); }
	inline void VisibilityOff(){ this->SetVisibility(0); }

	void AddActor(iActor *a);
	void RemoveActor(iActor *a);

protected:
	
	virtual ~iActorCollection();

private:
	
	iActorCollection();

	iLookupArray<iActor*> mActors;
};

#endif  // IACTORCOLLECTION_H


