//LICENSE A


#ifndef IAXIS_H
#define IAXIS_H


#include "igenericprop.h"
#include <vtkAxisActor2D.h>


#include "ipointermacro.h"

class iOverlayHelper;
class iRenderTool;


class iAxis: public iGenericProp<vtkAxisActor2D>
{
	
	IPOINTER_AS_USER(OverlayHelper);

public:
	
	vtkTypeMacro(iAxis,vtkAxisActor2D);
	static iAxis* New(iRenderTool *rt = 0);
	
protected:

	iAxis(iRenderTool *rt);
	virtual ~iAxis();

	virtual void UpdateGeometry(vtkViewport *vp);
	virtual void UpdateOverlay(vtkViewport *vp);

private:
	
	struct Pos
	{
		float X;
		float Y;
		Pos& operator=(const double *ptr);   // impl-shared copy
 	};

	float mLineWidth;
	int mTickLength;
	Pos mPos1, mPos2, mPosT;
	iArray<Pos> mPosL;
};

#endif // IAXIS_H
