//LICENSE A


#ifndef IBOUNDEDDISKSOURCE_H
#define IBOUNDEDDISKSOURCE_H


#include "iboundedpolydatasource.h"


class vtkAppendPolyData;
class vtkArrowSource;
class vtkDiskSource;
class vtkPolyDataNormals;
class vtkTransformPolyDataFilter;


class iBoundedDiskSource : public iBoundedPolyDataSource
{

public:
	
	vtkTypeMacro(iBoundedDiskSource,iBoundedPolyDataSource);
	static iBoundedDiskSource* New(iDataConsumer *consumer = 0);

	void SetWithArrow(bool s);
	inline bool GetWithArrow() const { return mWithArrow; }

protected:
	
	iBoundedDiskSource(iDataConsumer *consumer);
	virtual ~iBoundedDiskSource();

	virtual void UpdateBoundaryConditions();
	virtual void UpdateSourceResolution();
	virtual void AddObserverToSource(unsigned long e, vtkCommand *c, float priority);
	virtual float GetSourceMemorySize() const;

private:

	//
	//  VTK stuff
	//
	vtkDiskSource *mSource;
	vtkPolyDataNormals *mPointNormals;
	vtkAppendPolyData *mAppendPolyData;
	vtkArrowSource *mArrowSource;
	vtkTransformPolyDataFilter *mTransformPolyDataFilter;

	bool mWithArrow;
};

#endif // IBOUNDEDDISKSOURCE_H

