//LICENSE A


#include "iboundedplanesource.h"


#include "ierror.h"

#include <vtkPlaneSource.h>
#include <vtkPolyData.h>
#include <vtkTransformPolyDataFilter.h>


//
// iBoundedPlaneSource class
//
iBoundedPlaneSource* iBoundedPlaneSource::New(iDataConsumer *consumer)
{
	IASSERT(consumer);
	return new iBoundedPlaneSource(consumer);
}


iBoundedPlaneSource::iBoundedPlaneSource(iDataConsumer *consumer) : iBoundedPolyDataSource(consumer,true,false)
{
	mSource = vtkPlaneSource::New(); IERROR_CHECK_MEMORY(mSource);

	mSource->SetOrigin(0.0,0.0,0.0);
	mSource->SetPoint1(7.0,0.0,0.0);
	mSource->SetPoint2(0.0,7.0,0.0);
	mSource->SetCenter(0.0,0.0,0.0);

	mFilter->SetInputConnection(mSource->GetOutputPort());
}


iBoundedPlaneSource::~iBoundedPlaneSource()
{
	mSource->Delete();
}


void iBoundedPlaneSource::AddObserverToSource(unsigned long e, vtkCommand *c, float p)
{
	mSource->AddObserver(e,c,p);
}


void iBoundedPlaneSource::UpdateSourceResolution()
{
	mSource->SetResolution(mResolution,mResolution);
}


float iBoundedPlaneSource::GetSourceMemorySize() const
{
	float s = 0.0;
	s += mSource->GetOutput()->GetActualMemorySize();
	return s;
}


void iBoundedPlaneSource::UpdateBoundaryConditions()
{
}

