//LICENSE A


#ifndef IBOUNDEDSPHERESOURCE_H
#define IBOUNDEDSPHERESOURCE_H


#include "iboundedpolydatasource.h"


class iSphereSource;

class vtkAppendPolyData;


class iBoundedSphereSource : public iBoundedPolyDataSource
{

public:
	
	vtkTypeMacro(iBoundedSphereSource,iBoundedPolyDataSource);
	static iBoundedSphereSource* New(iDataConsumer *consumer = 0);

protected:
	
	iBoundedSphereSource(iDataConsumer *consumer);
	virtual ~iBoundedSphereSource();

	virtual void UpdateBoundaryConditions();
	virtual void UpdateSourceResolution();
	virtual void AddObserverToSource(unsigned long e, vtkCommand *c, float priority);
	virtual float GetSourceMemorySize() const;

private:

	//
	//  VTK stuff
	//
	vtkAppendPolyData *mAppend;
	iSphereSource *mSource[8]; // 8 of them for periodic BC
};

#endif // IBOUNDEDSPHERESOURCE_H

