//LICENSE A


#ifndef IBOUNDINGBOX_H
#define IBOUNDINGBOX_H


#include "iviewmoduletool.h"


#include "istring.h"

class iActor;
class iActorCollection;
class iCubeAxesActor;


namespace iParameter
{
	namespace BoundingBoxType
	{
		const int Default =		0;
		const int Classic =		1;
		const int HairThin =	2;
		const int Axes =		3;

		inline bool IsValid(int m){ return m>=0 && m<=3; }
	};
};


class iBoundingBox : public iViewModuleTool
{
	
public:

	vtkTypeMacro(iBoundingBox,iViewModuleTool);
	static iBoundingBox* New(iViewModule *vm = 0);
		
	iObjectPropertyMacro1S(Type,Int);
	iObjectPropertyMacro2V(AxesRanges,Float);
	iObjectPropertyMacro1V(AxesLabels,String,3);

	void SetMagnification(int m);
	void SetColor(const iColor &c);

protected:

	virtual ~iBoundingBox();

private:
	
	iBoundingBox(iViewModule *vm, const iString &fname, const iString &sname);

	virtual bool ShowBody(bool s);

	//
	//  Actors displayed by this class
	//
	iActor *mBox0Actor, *mBox2Actor;
	iActorCollection *mBox1Actor, *mBox3Actor;
	iCubeAxesActor *mBox3AxesLabels;
};

#endif // IBOUNDINGBOX_H

