//LICENSE A


#ifndef IBUFFER_H
#define IBUFFER_H

//
//  Adjustable buffer (piece of memory) of type T. There is no out-of-boundary checking
//  like in iArray
//

template<class T>
class iBuffer
{

public:

	iBuffer();
	~iBuffer();

	void Reset(bool fill0);
	void Extend(int s);
	void Fill(const T* ptr, int size);  // fast fill

	T& operator[](int i);
	inline const T& operator[](int i) const { return this->mArr[i]; }

	inline operator T*() const { return this->mArr; }

private:

	T* mArr;
	int mLen;
};

#endif // IBUFFER_H

