//LICENSE A

//
//  A small actor that shows camera orientation when it is orthogonal
//
#ifndef ICAMERAORTHOACTOR_H
#define ICAMERAORTHOACTOR_H


#include "igenericprop.h"
#include <vtkActor2D.h>


#include "ipointermacro.h"

class iTextActor;
class iOverlayHelper;
class iRenderTool;

class vtkAxisActor2D;
class vtkCamera;


class iCameraOrthoActor : public iGenericProp<vtkActor2D>
{

	IPOINTER_AS_USER(OverlayHelper);

public:

	vtkTypeMacro(iCameraOrthoActor,vtkActor2D);
	static iCameraOrthoActor* New(iRenderTool *rt = 0);

protected:

	virtual ~iCameraOrthoActor();

	virtual void UpdateGeometry(vtkViewport *vp);

private:

	iCameraOrthoActor(iRenderTool *rv);

	vtkAxisActor2D *mActors[2];
	iTextActor *mLabels[2];
};

#endif

