//LICENSE A


#ifndef ICAPTION_H
#define ICAPTION_H


#include "iframedtextactor.h"


class iActor;

class vtkCoordinate;
class vtkPolyData;


class iCaption: public iFramedTextActor
{
	
public:
	
	vtkTypeMacro(iCaption,iFramedTextActor);
	static iCaption* New(iRenderTool *rt = 0);
	
	void SetAttachmentPoint(double x[3]);
	const double* GetAttachmentPoint();

	static bool Transparent;

protected:
	
	virtual ~iCaption();
	
	virtual void UpdateGeometry(vtkViewport *vp);

private:
	
	iCaption(iRenderTool *rv);

	vtkCoordinate *mAttachmentPoint;

	float mUnmagx1[2], mUnmagx2[2];

	//
	//  Leader
	//
	vtkPolyData *mLeaderInput;
	iActor      *mLeaderActor;
};

#endif // ICAPTION_H
