//LICENSE A


#ifndef ICAPTIONINTERACTORSTYLE_H
#define ICAPTIONINTERACTORSTYLE_H


#include <vtkInteractorStyleTrackballActor.h>
#include "iviewmodulecomponent.h"


class iMarkerInstance;

class vtkActor2D;


class iCaptionInteractorStyle: public vtkInteractorStyleTrackballActor, public iViewModuleComponent
{
	
public:
	
	vtkTypeMacro(iCaptionInteractorStyle,vtkInteractorStyleTrackballActor);
	static iCaptionInteractorStyle* New(iViewModule *vm = 0);
	
	void Launch(vtkInteractorStyle *next);

	void FindPickedActor(int x, int y);
	
	virtual void Rotate(); 
	virtual void OnLeftButtonUp();
	virtual void OnLeftButtonDown();
	
	//
	//  Disable all interactions except left mouse moving the caption around
	//
	virtual void Spin(){} 
	virtual void Pan(){}
	virtual void Dolly(){} 
	virtual void UniformScale(){}
	
	virtual void OnLeave(){ this->Finish(); }
	virtual void OnChar(){ this->Finish(); }
	virtual void OnMiddleButtonDown(){ this->Finish(); }
	virtual void OnMiddleButtonUp(){}
	virtual void OnRightButtonDown(){ this->Finish(); }
	virtual void OnRightButtonUp(){}

protected:
	
	virtual ~iCaptionInteractorStyle();

private:

	iCaptionInteractorStyle(iViewModule *vm);

	void Finish();

	iMarkerInstance *mInteractionMarker;
	vtkActor2D *mScreen;

	vtkInteractorStyle *wNextStyle;
	bool wTransparentCaptions;
};

#endif // ICAPTIONINTERACTORSTYLE_H
