//LICENSE A

//
//  A vtkPlaneCollection with a glass plane representation
//
#ifndef ICLIPPLANE_H
#define ICLIPPLANE_H


#include <vtkPlaneCollection.h>
#include "iviewmoduletool.h"


#include "iarray.h"

class iClipPlaneInstance;
class vtkPlaneCollection;


class iClipPlane : public iViewModuleTool
{
	
public:

	vtkTypeMacro(iClipPlane,iViewModuleTool);
	static iClipPlane* New(iViewModule *vm = 0);

	iObjectPropertyMacro2V(Position,Vector);
	iObjectPropertyMacro2V(Direction,Vector);

	iObjectPropertyMacro2S(Number,Int);
	iPropertyAction1<iType::Int> Remove;
	iPropertyAction Create;	

	inline vtkPlaneCollection* GetPlanes() const { return mPlanes; }

protected:

	virtual ~iClipPlane();

private:
	
	iClipPlane(iViewModule *vm, const iString &fname, const iString &sname);

	bool CallCreate();
	bool CallRemove(int i);

	virtual bool ShowBody(bool s);

	//
	//  Actors displayed by this class
	//
	iArray<iClipPlaneInstance*> mInstances;
	vtkPlaneCollection* mPlanes;
};

#endif // ICLIPPLANE_H

