//LICENSE A


#ifndef ICOMMONDATADISTRIBUTORS_H
#define ICOMMONDATADISTRIBUTORS_H


#include "iviewsubjectpipelinedatamanager.h"


#include "iarray.h"

#include <vtkSetGet.h>

class iAppendImageDataFilter;
class iAppendPolyDataFilter;

class vtkImageData;


class iFieldDataDistributor : public iViewSubjectPipelineDataDistributor
{

public:

	vtkTypeMacro(iFieldDataDistributor,iViewSubjectPipelineDataDistributor);
	iFieldDataDistributor(iViewSubjectPipelineDataManager *manager, const iString &type);

	inline int GetSplitDimension() const { return mSplitDim; }
	inline const iArray<double>& GetEdges() const { return mEdges; }

protected:

	int mSplitDim;
	iArray<double> mEdges;
};


class iImageDataDistributor : public iFieldDataDistributor
{

public:

	vtkTypeMacro(iImageDataDistributor,iFieldDataDistributor);
	iImageDataDistributor(iViewSubjectPipelineDataManager *manager);

protected:

	virtual bool DistributeDataBody(vtkDataSet *globalInput, iArray<vtkDataSet*> &localInputs);
};


class iImageDataCollector : public iViewSubjectPipelineDataCollector
{

public:

	vtkTypeMacro(iImageDataCollector,iViewSubjectPipelineDataCollector);
	iImageDataCollector(iViewSubjectPipelineDataManager *manager);

protected:

	virtual ~iImageDataCollector();

	virtual bool CollectDataBody(iArray<vtkDataSet*> &localOutputs, vtkDataSet *globalOutput);

	iAppendImageDataFilter *mCollector;
};


class iPolyDataDistributor : public iViewSubjectPipelineDataDistributor
{

public:

	vtkTypeMacro(iPolyDataDistributor,iViewSubjectPipelineDataDistributor);
	iPolyDataDistributor(iViewSubjectPipelineDataManager *manager);

protected:

	virtual bool DistributeDataBody(vtkDataSet *globalInput, iArray<vtkDataSet*> &localInputs);
};


class iPolyDataCollector : public iViewSubjectPipelineDataCollector
{

public:

	vtkTypeMacro(iPolyDataCollector,iViewSubjectPipelineDataCollector);
	iPolyDataCollector(iViewSubjectPipelineDataManager *manager, iFieldDataDistributor *distributor = 0);

	void FixStiches(bool s){ mFixStiches = s; }

protected:

	virtual ~iPolyDataCollector();

	virtual bool CollectDataBody(iArray<vtkDataSet*> &localOutputs, vtkDataSet *globalOutput);

	bool mFixStiches;
	iFieldDataDistributor *mDistributor;
	iAppendPolyDataFilter *mCollector;
};

#endif  // ICOMMONDATADISTRIBUTORS_H
