//LICENSE A


#ifndef ICONTOURFILTER_H
#define ICONTOURFILTER_H


#include "igenericfilter.h"
#include <vtkDataSetAlgorithm.h>


class vtkPolyDataAlgorithm;


class iContourFilter : public iGenericFilter<vtkDataSetAlgorithm,vtkImageData,vtkPolyData>
{
	
	iGenericFilterTypeMacro(iContourFilter,vtkDataSetAlgorithm);

public:

	inline int GetMethod() const { return mCurVar; }
	void SetMethod(int n);

	inline int GetCurrentVar() const { return mCurVar; }
	void SetCurrentVar(int n);
	
	float GetLevel() const;
	void SetLevel(float);

protected:

	virtual ~iContourFilter();

	virtual void ProvideOutput();

private:

	int mCurVar, mMethod;
	vtkPolyDataAlgorithm *mWorkers[2];
};

#endif // ICONTOURFILTER_H

