//LICENSE A


#ifndef ICROSSSECTIONPIPELINE_H
#define ICROSSSECTIONPIPELINE_H


#include "iviewsubjectpipeline.h"


class iCrossSectionViewInstance;
class iOrthoPolygonPlaneFilter;
class iOrthoSlicer;
class iOrthoTexturePlaneFilter;

class vtkImageData;


class iCrossSectionPipeline : public iViewSubjectPipeline
{

	friend class iCrossSectionViewInstance;
	
public:
	
	vtkTypeMacro(iCrossSectionPipeline,iViewSubjectPipeline);

	iPipelineKeyDeclareMacro(iCrossSectionPipeline,Method);
	iPipelineKeyDeclareMacro(iCrossSectionPipeline,Location);
	iPipelineKeyDeclareMacro(iCrossSectionPipeline,Painting);
	iPipelineKeyDeclareMacro(iCrossSectionPipeline,Direction);
	iPipelineKeyDeclareMacro(iCrossSectionPipeline,SampleRate);
	iPipelineKeyDeclareMacro(iCrossSectionPipeline,InterpolateData);

protected:
	
	iCrossSectionPipeline(iCrossSectionViewInstance *owner);
	virtual ~iCrossSectionPipeline();

	virtual void ProvideOutput();
	virtual void UpdateReplicas();

	void SetTextureOffset(vtkImageData *input);

	iCrossSectionViewInstance *mOwner;

	//
	//  VTK stuff
	//
	iOrthoSlicer *mSlicer;
	iOrthoPolygonPlaneFilter *mPolygonConverter;
	iOrthoTexturePlaneFilter *mTextureConverter;
};

#endif // ICROSSSECTIONPIPELINE_H

