//LICENSE A


#ifndef IDATAFORMATTER_H
#define IDATAFORMATTER_H


#include <vtkObjectBase.h>
#include "iviewmodulecomponent.h"


#include "iarray.h"
#include "istring.h"

class iDataLimits;


class iDataFormatter : public vtkObjectBase, public iViewModuleComponent
{

public:

	static iDataFormatter* New(iViewModule *vm = 0);

	inline int GetNumReportLines() const { return mVarNameLines.Size(); }
	void GetReport(int i, iString& varName, iString &varData, iString &varUnit) const;

	void AddOneLine(const iString &name, const iString &data, const iString &unit);

	void ClearReport();
	void FormatScalarData(iDataLimits *lim, int n, float *v, bool useRank = false);
	void FormatVectorData(iDataLimits *lim, int ivar, float *v, float *div = 0, float *vort = 0);
	void FormatTensorData(iDataLimits *lim, int ivar, float *v, bool compressed = false);

protected:

	virtual ~iDataFormatter();

private:

	iDataFormatter(iViewModule *vm);

	iArray<iString> mVarNameLines, mVarDataLines, mVarUnitLines;
	iString mFormatHelper;
};

#endif  // IDATAFORMATTER_H
