//LICENSE A


#include "idatahandler.h"


#include "idataconsumer.h"
#include "idatasubject.h"
#include "ierror.h"
#include "ishell.h"
#include "iviewmodule.h"


iDataHandler::iDataHandler(iDataConsumer *consumer) : iViewModuleComponent((consumer==0)?0:consumer->GetViewModule())
{
	IASSERT(consumer);

	mConsumer = consumer;
	mConsumer->RegisterDataHandler(this);

	this->GetViewModule()->GetShell()->OnInitAtom();
}


iDataHandler::~iDataHandler()
{
	//
	//  On exit, garbare collector may delete consumer first; 
	//  then mConsumer would set to 0 by iDataConsumer destructor.
	//
	if(mConsumer != 0) mConsumer->UnRegisterDataHandler(this);
}


bool iDataHandler::IsOptimizedForSpeed() const
{
	return mConsumer->IsOptimizedForSpeed();
}


bool iDataHandler::IsOptimizedForMemory() const
{
	return mConsumer->IsOptimizedForMemory();
}


bool iDataHandler::IsOptimizedForQuality() const
{
	return mConsumer->IsOptimizedForQuality();
}


iDataLimits* iDataHandler::GetLimits() const
{
	return mConsumer->GetLimits();
}


void iDataHandler::GetPeriodicities(bool per[3]) const
{
	int i;

	for(i=0; i<3; i++) per[i] = mConsumer->GetSubject()->IsDirectionPeriodic(i);
}


bool iDataHandler::SyncWithLimits(int var, int mode)
{
	return true;
}

