//LICENSE A


#ifndef IDATAHANDLER_H
#define IDATAHANDLER_H


#include "iviewmodulecomponent.h"


class iDataConsumer;
class iDataLimits;


class iDataHandler : public iViewModuleComponent
{

	friend class iDataConsumer;

public:

	bool IsOptimizedForSpeed() const;
	bool IsOptimizedForMemory() const;
	bool IsOptimizedForQuality() const;

	iDataLimits* GetLimits() const;
	void GetPeriodicities(bool per[3]) const; // helper function

	virtual float GetMemorySize() = 0;
	virtual void RemoveInternalData() = 0;

protected:

	iDataHandler(iDataConsumer *consumer);
    virtual ~iDataHandler();

	iDataConsumer* Consumer() const { return mConsumer; }

	virtual bool SyncWithLimits(int var, int mode);

private:

	iDataConsumer *mConsumer;
};

#endif // IVISUALMODULEDATAHANDLER_H
