//LICENSE A

//
//  DataReader observer (this is not an EventObserver), just a callback class
//

#ifndef IDATAREADEROBSERVER_H
#define IDATAREADEROBSERVER_H


#include "ishellcomponent.h"


class iDataInfo;
class iDataType;
class iString;


class iDataReaderObserver : public iShellComponent
{
	
public:
	
	void StartSet();
	void StartFile(const iString &fname, const iDataType &type);
	void FinishFile(const iString &fname, const iDataInfo &info);
	void FinishSet(bool error);

	virtual bool AllowReload();

protected:

	iDataReaderObserver(iShell *s);

	virtual void OnSetStart();
	virtual void OnSetFinish(bool error);
	virtual void OnFileStart(const iString &fname, const iDataType &type) = 0;
	virtual void OnFileFinish(const iString &fname, const iDataInfo &info);

private:

	bool mStarted;
};

#endif // IDATAREADEROBSERVER_H

