//LICENSE A

//
//  Base classes for event observers
//

#ifndef IEVENTOBSERVER_H
#define IEVENTOBSERVER_H


#include <vtkCommand.h>


#include <vtkSetGet.h>


class iEventObserver : public vtkCommand
{

public:

	vtkTypeMacro(iEventObserver,vtkCommand);

	static void BlockAllEventObservers(bool s){ mAllAreBlocked = s; }

	void Block(bool s){ mIsBlocked = s; }

	virtual void Execute(vtkObject *caller, unsigned long event, void *data);

protected:

	iEventObserver();
	virtual ~iEventObserver();

	void SetLockedExecute(bool s){ mLockedExecute = s; }
	virtual void ExecuteBody(vtkObject *caller, unsigned long event, void *data) = 0;

private:

	static bool mAllAreBlocked;
	bool mIsBlocked, mLockedExecute;
};

#endif // IEVENTOBSERVER_H

