//LICENSE A


#ifndef IFIELDGLYPHPIPELINE_H
#define IFIELDGLYPHPIPELINE_H


#include "ireplicatedviewsubjectpipeline.h"


class iFieldViewInstance;
class iResampleImageDataFilter;


class iFieldGlyphPipeline : public iReplicatedViewSubjectPipeline
{

public:
	
	vtkTypeMacro(iFieldGlyphPipeline,iReplicatedViewSubjectPipeline);

	iPipelineKeyDeclareMacro(iFieldGlyphPipeline,GlyphSize);
	iPipelineKeyDeclareMacro(iFieldGlyphPipeline,GlyphSampleRate);

protected:
	
	iFieldGlyphPipeline(iFieldViewInstance *owner);
	virtual ~iFieldGlyphPipeline();

	virtual bool PrepareInput();

	virtual void SetGlyphFilterInput(vtkDataSet *input) = 0;
	virtual void SetGlyphFilterScale(double s) = 0;

	//
	//  Our members
	//
	iFieldViewInstance *mOwner;
	iResampleImageDataFilter *mResampleFilter;
};

#endif // IFIELDGLYPHPIPELINE_H

