//LICENSE A


#ifndef IFIELDVIEWSUBJECT_H
#define IFIELDVIEWSUBJECT_H


#include "ipaintedviewsubject.h"


class iFieldViewSubject;
class iMergeDataFilter;
class iViewModule;


class iFieldViewInstance : public iPaintedViewInstance
{

	friend class iFieldViewSubject;
	
public:
	
	iDataConsumerTypeMacro(iFieldViewInstance,iPaintedViewInstance);
		
	iObjectSlotMacro1SV(GlyphSize,float);
	iObjectSlotMacro1SV(GlyphSampleRate,int);

protected:
	
	iFieldViewInstance(iFieldViewSubject *owner, int numactors);
	virtual ~iFieldViewInstance();

	iFieldViewSubject* Owner() const;

	virtual bool IsConnectedToPaintingData() const;

	virtual void UpdateGlyphSize() = 0;
	virtual void UpdateGlyphSampleRate() = 0;
	virtual void ResetPipelineInput(vtkDataSet *input) = 0;

	iMergeDataFilter *mMergeDataFilter;
};


class iFieldViewSubject : public iPaintedViewSubject
{
	
public:
	
	iDataConsumerTypeMacroPass(iFieldViewSubject,iPaintedViewSubject);

	iType::vsp_float GlyphSize;
	iType::vsp_int GlyphSampleRate;

	iObjectPropertyMacro2Q(IsConnectedToScalars,Bool); 

protected:
	
	iFieldViewSubject(iObject *parent, const iString &fname, const iString &sname, iViewModule *vm, const iDataType &type, const iDataType &sdt, unsigned int flags);
	virtual ~iFieldViewSubject();
};

#endif // IFIELDVIEWSUBJECT_H

