//LICENSE A


#ifndef IHISTOGRAM_H
#define IHISTOGRAM_H


#include "iarray.h"


class iHistogram
{
	
	friend class iHistogramMaker;

public:
	
	static const iHistogram& Null();

	~iHistogram();

	inline int NumBins() const { return mValues.Size(); }
	inline int StretchId() const { return mStretchId; }

	float GetMin() const;
	float GetMax() const;
	void GetRange(float range[2]) const;

	float GetBinMin(int i) const;
	float GetBinMax(int i) const;
	void GetBinRange(int i, float range[2]) const;

	int Bin(float v) const;
	float Value(int i) const;

	//void Copy(const iHistogram &h);

private:

	iHistogram();

	void Clear();
	void Reset(int nbins, float min, float max, int sid);

#ifdef I_CHECK
	void Check() const;
#endif

	int mStretchId;
	float mStretchedMin, mStretchedMax, mValueToBinScale;
	iArray<float> mValues;
	iArray<float> mBins;
};

#endif

