//LICENSE A


#include "ikeyboardinteractorstyle.h"


#include <vtkRenderWindowInteractor.h>


iKeyboardInteractorStyle* iKeyboardInteractorStyle::New()
{
	return new iKeyboardInteractorStyle;
}


iKeyboardInteractorStyle::iKeyboardInteractorStyle()
{
}


iKeyboardInteractorStyle::~iKeyboardInteractorStyle()
{
}


void iKeyboardInteractorStyle::OnChar() 
{
	//
	//  Are these universal???
	//
	const char _Left = 18;
	const char _Down = 21;
	const char _Up = 19;
	const char _Right = 20;

	// catch keycodes
	switch (Interactor->GetKeyCode())
	{
    case 'a':
    case 'A': 
		{ 
			MotionFactor *= 0.5;
			break;
		}
    case 'z':
    case 'Z':
		{ 
			MotionFactor *= 2.0;
			break;
		}
    case '+':
		{
			this->DoZoom(0,1);
			break;
		}
    case '-':
		{
			this->DoZoom(0,-1);
			break;
		}
    case 'h':
    case 'H':
	case _Left:
		{
			this->DoMove(-1,0);
			break;
		}
    case 'j':
    case 'J':
	case _Down:
		{
			this->DoMove(0,-1);
			break;
		}
    case 'k':
    case 'K':
	case _Up:
		{
			this->DoMove(0,1);
			break;
		}
    case 'l':
    case 'L':
	case _Right:
		{
			this->DoMove(1,0);
			break;
		}
	default:
		{
			vtkInteractorStyleTrackballCamera::OnChar();
		}
	}

	Interactor->Render();
}


void iKeyboardInteractorStyle::FakeEvent(int dx, int dy)
{
	int x, y;
	Interactor->GetMousePosition(&x,&y);
	Interactor->SetEventPosition(x-dx,y-dy);
	Interactor->SetEventPosition(x,y);
	this->FindPokedRenderer(x,y);
}


void iKeyboardInteractorStyle::DoZoom(int dx, int dy)
{
	this->FakeEvent(dx,dy);

	this->Dolly();
}


void iKeyboardInteractorStyle::DoMove(int dx, int dy)
{
	this->FakeEvent(dx,dy);

	if(Interactor->GetShiftKey())
	{
		this->Pan();
	}
	else if(Interactor->GetControlKey())
	{
		this->Spin();
	}
	else
	{
		this->Rotate();
	}
}

