//LICENSE A


#ifndef ILEGEND_H
#define ILEGEND_H


#include "igenericprop.h"
#include <vtkLegendBoxActor.h>


#include "ipointermacro.h"

class iOverlayHelper;
class iRenderTool;


class iLegend: public iGenericProp<vtkLegendBoxActor>
{
	
	IPOINTER_AS_USER(OverlayHelper);

public:
	
	vtkTypeMacro(iLegend,vtkLegendBoxActor);
	static iLegend* New(iRenderTool *rv = 0);

protected:

	virtual ~iLegend();

	virtual void UpdateGeometry(vtkViewport *vp);
	virtual void UpdateOverlay(vtkViewport *vp);
	virtual void Reset();

private:
	
	iLegend(iRenderTool *rv);
	
	float mUnmagx1[2], mUnmagx2[2];
};

#endif // ILEGEND_H
