//LICENSE A


#ifndef ILIGHTS_H
#define ILIGHTS_H


#include <vtkLightKit.h>
#include "iobject.h"
#include "iviewmodulecomponent.h"


class iLights;

class vtkRenderer;


class iLightKit : public vtkLightKit
{

	friend class iLights;

public:

	void SetAngles(double a[2]);
	inline void GetAngles(double a[2]) const { a[0] = mAngles[0]; a[1] = mAngles[1]; }

	void SetIntensities(float i[3]);
	void GetIntensities(float i[3]) const;

protected:

	virtual ~iLightKit();

private:

	iLightKit(vtkRenderer *renderer);

	void UpdateAngles();

	//
	//  Hide setting directions for individual lights
	//
	void SetKeyLightAngle(double elevation, double azimuth){}
	void SetKeyLightAngle(double angle[2]){}
	void SetKeyLightElevation(double x){}
	void SetKeyLightAzimuth(double x){}

	void SetFillLightAngle(double elevation, double azimuth){}
	void SetFillLightAngle(double angle[2]){}
	void SetFillLightElevation(double x){}
	void SetFillLightAzimuth(double x){}

	void SetBackLightAngle(double elevation, double azimuth){}
	void SetBackLightAngle(double angle[2]){}
	void SetBackLightElevation(double x){}
	void SetBackLightAzimuth(double x){}

	double mAngles[2];
};


class iLights : public iObject, public iViewModuleComponent
{
	
public:

	vtkTypeMacro(iLights,iObject);
	static iLights* New(iViewModule *vm = 0);

	iObjectPropertyMacro1S(Direction,Vector);
	iObjectPropertyMacro2V(Intensities,Float);
	iObjectPropertyMacro2S(TwoSided,Bool);

	inline iLightKit* GetLightKit() const { return mLightKit; }

protected:

	virtual ~iLights();

private:
	
	iLights(iViewModule *vm, const iString &fname, const iString &sname);

	iLightKit *mLightKit;
};

#endif  // ILIGHTS_H
