//LICENSE A


#ifndef ILOOKUPTABLE_H
#define ILOOKUPTABLE_H


#include <vtkLookupTable.h>


class iColor;


class iLookupTable : public vtkLookupTable
{

public:

	static iLookupTable* New();

	void SetStretchId(int s);
	void SetPaletteId(int n);
	void SetReversed(bool s);
	void SetColor(const iColor &c);

	virtual void ForceBuild();

	virtual unsigned long GetMTime(); 
	virtual void MapScalarsThroughTable2(void *input, unsigned char *output, int inputDataType, int numberOfValues, int inputIncrement, int outputFormat);

protected:

	virtual ~iLookupTable();

private:

	iLookupTable();

	int mPaletteId;
};

#endif // ILOOKUPTABLE_H
