//LICENSE A

//
// An object that controls materil for props 
//

#ifndef IMATERIAL_H
#define IMATERIAL_H


#include "iobject.h"


#include "iarray.h"

class iMaterialObject;

class vtkProperty;
class vtkVolumeProperty;


class iMaterial : public iObject
{

public:

	vtkTypeMacro(iMaterial,iObject);
	static iMaterial* New(iMaterialObject *parent = 0);

	iObjectPropertyMacro1S(ShadingMode,Int);
	iObjectPropertyMacro1S(Ambient,Float);
	iObjectPropertyMacro1S(Diffuse,Float);
	iObjectPropertyMacro1S(Specular,Float);
	iObjectPropertyMacro1S(SpecularPower,Float);

	void SetShading(bool s);

	void AddProperty(vtkProperty *prop);
	void AddProperty(vtkVolumeProperty *prop);
	
	void RemoveProperty(vtkProperty *prop);
	void RemoveProperty(vtkVolumeProperty *prop);

protected:
	
	virtual ~iMaterial();
	iMaterial* Self(){ return this; }  // needed to avoid compiler warning


private:

	iMaterial(iMaterialObject *parent, const iString &fname, const iString &sname);

	void UpdateProperties();

	iLookupArray<vtkProperty*> mActorProperties;
	iLookupArray<vtkVolumeProperty*> mVolumeProperties;
	iMaterialObject *mRealParent;
};

#endif // IMATERIAL_H

