//LICENSE A


#include "imaterialobject.h"


#include "ierror.h"
#include "ilegend.h"
#include "imaterial.h"

#include <vtkProperty.h>
#include <vtkVolumeProperty.h>


using namespace iParameter;


//
// Main class
//
iMaterialObject::iMaterialObject(iObject *parent, const iString &fname, const iString &sname, int level) : iObject(parent,fname,sname,level)
{
	mMaterial = iMaterial::New(this); IERROR_CHECK_MEMORY(mMaterial);
}


iMaterialObject::~iMaterialObject()
{
	mMaterial->Delete();
}

	
void iMaterialObject::UpdateAutomaticShading()
{
	if(mMaterial->GetShadingMode() == 0)
	{
		this->UpdateAutomaticShadingBody();
	}
}


void iMaterialObject::UpdateAutomaticShadingBody()
{
	//
	//  By default set shading
	//
	mMaterial->SetShading(true);
}
