//LICENSE A

//
//  Object that has material properties. This is a separate class as it serves as a parent to Material object.
//  It also isolated material interface so that it can be modified in the future.
//
#ifndef IMATERIALOBJECT_H
#define IMATERIALOBJECT_H


#include "iobject.h"


class iMaterial;


class iMaterialObject : public iObject
{
	
	friend class iMaterial;

public:
	
	vtkTypeMacro(iMaterialObject,iObject);

	iMaterial* GetMaterial() const { return mMaterial; }

	void UpdateAutomaticShading();

protected:
	
	iMaterialObject(iObject *parent, const iString &fname, const iString &sname, int level = 0);
	virtual ~iMaterialObject();

	virtual void UpdateAutomaticShadingBody();

private:

	iMaterial *mMaterial;
};

#endif // IMATERIALOBJECT_H

