//LICENSE A


#include "imath.h"


#include "ierror.h"

#include <vtkMath.h>
#include <vtkMinimalStandardRandomSequence.h>


namespace iMath
{
	bool Intersect3Planes(double *p1, double *p2, double *p3, double *x)
	{
		int i;
		double atmp[9], *a[3];

		a[0] = atmp + 0;
		a[1] = atmp + 3;
		a[2] = atmp + 6;

		for(i=0; i<3; i++)
		{
			a[0][i] = p1[i];
			a[1][i] = p2[i];
			a[2][i] = p3[i];
		}
		x[0] = -p1[3];
		x[1] = -p2[3];
		x[2] = -p3[3];

		return (vtkMath::SolveLinearSystem(a,x,3) != 0);
	}

	Random::Random(int seed)
	{
		mGenerator = vtkMinimalStandardRandomSequence::New(); IERROR_CHECK_MEMORY(mGenerator);
		mGenerator->SetSeed(seed);
	}

	Random::~Random()
	{
		mGenerator->Delete();
	}
	
	double Random::NextValue()
	{
		mGenerator->Next();
		return mGenerator->GetValue();
	}
};

