//LICENSE A


#ifndef IMERGEDATAFILTER_H
#define IMERGEDATAFILTER_H


#include "igenericfilter.h"
#include <vtkDataSetAlgorithm.h>


class vtkDataSet;


class iMergeDataFilter : public iGenericFilter<vtkDataSetAlgorithm,vtkDataSet,vtkDataSet>
{

	iGenericFilterTypeMacro(iMergeDataFilter,vtkDataSetAlgorithm);
	
public:

	inline int GetRank() const { return mRank; }
	void SetRank(int rank);
	bool HasData(int rank);

protected:
	
	int FillInputPortInformation(int port, vtkInformation* info);

	virtual void ProvideInfo();
	virtual void ProvideOutput();

private:

	bool AreDataSetsCompatible(vtkDataSet *ds1, vtkDataSet *ds2) const;

	int mRank;
};

#endif


