//LICENSE A


//
//  A helper class that monitors execution of many IFrIT components
//  (starts and finishes execution observer automatically, reports
//  error and abort statuses, etc). It is created by value as a 
//  local variable, with most of th work done by constructor  and
//  destructor as the monitor goes in and out of scope.
//
#ifndef IMONITOR_H
#define IMONITOR_H


class iExecutionEventObserver;
class iShellComponent;
class iString;


class iMonitor
{

public:

	iMonitor(const iShellComponent *user);
	iMonitor(const iShellComponent *user, const iString& label, double length);
	~iMonitor();

	void SetInterval(const iString& label, double start, double length);
	void SetInterval(double start, double length);
	void SetProgress(double prog);

	void PostError(const iString &text);
	void Reset();

	const iString& LastErrorMessage() const;

	bool IsStopped() const;
	bool IsAborted() const;

private:

	iExecutionEventObserver* mObserver;
};

#endif  // IMONITOR_H

