//LICENSE A


#include "imultiviewsubject.h"


#include "imath.h"
#include "iviewmodule.h"

//
//  Templates
//
#include "iarray.tlh"
#include "iproperty.tlh"


using namespace iParameter;


//
//  Single instance class
//
iMultiViewInstance::iMultiViewInstance(iMultiViewSubject *owner, int numactors, int numpaintedactors, int priority, bool alwayspainted) : iPaintedViewInstance(owner,numactors,1.0,numpaintedactors,priority,alwayspainted)
{
}


iMultiViewInstance::~iMultiViewInstance()
{
}


bool iMultiViewInstance::IsConnectedToPaintingData() const
{
	return this->IsThereData();
}


//
// Main class
//
iMultiViewSubject::iMultiViewSubject(iObject *parent, const iString &fname, const iString &sname, iViewModule *vm, const iDataType &type, unsigned int flags, int minsize) : iPaintedViewSubject(parent,fname,sname,vm,type,type,flags,minsize,iMath::_IntMax),
	Number(iObject::Self(),static_cast<iType::ps_int::SetterType>(&iViewSubject::SetNumberOfInstances),static_cast<iType::ps_int::GetterType>(&iViewSubject::GetNumberOfInstances),"Number","num",9),
	Create(iObject::Self(),static_cast<iPropertyAction::CallerType>(&iViewSubject::CreateInstance),"New","new"),
	Remove(iObject::Self(),static_cast<iPropertyAction1<iType::Int>::CallerType>(&iViewSubject::RemoveInstance),"Delete","dlt")
{
	Remove.AddFlag(iProperty::_FunctionsAsIndex);
}


iMultiViewSubject::~iMultiViewSubject()
{
}

