//LICENSE A

//
//  A ViewSubject that uses scalar data and has several instances
//
#ifndef IMULTIVIEWSUBJECT_H
#define IMULTIVIEWSUBJECT_H


#include "ipaintedviewsubject.h"


class iMultiViewSubject;


class iMultiViewInstance : public iPaintedViewInstance
{
	
	friend class iMultiViewSubject;

public:
	
	iDataConsumerTypeMacroPass(iMultiViewInstance,iPaintedViewInstance);

protected:
	
	iMultiViewInstance(iMultiViewSubject *owner, int numactors, int numpaintedactors, int priority, bool alwayspainted);
	virtual ~iMultiViewInstance();

	virtual bool IsConnectedToPaintingData() const;
};


class iMultiViewSubject : public iPaintedViewSubject
{
	
public:
	
	iDataConsumerTypeMacroPass(iMultiViewSubject,iPaintedViewSubject);

	iType::ps_int Number;
	iPropertyAction Create;
	iPropertyAction1<iType::Int> Remove;

protected:
	
	iMultiViewSubject(iObject *parent, const iString &fname, const iString &sname, iViewModule *vm, const iDataType &type, unsigned int flags, int minsize);
	virtual ~iMultiViewSubject();
};

#endif // IMULTIVIEWSUBJECT_H

