//LICENSE A


#ifndef IOBJECTFACTORY_H
#define IOBJECTFACTORY_H


class iAbstractExtension;
class iAbstractExtensionPointer;
class iDataReader;
template<class T> class iArray;
class iPicker;
class iString;
class iViewModule;
class iViewObject;
class iViewObjectParent;


class iObjectFactory
{
	
	friend class iAbstractExtension;

public:
		
	static iViewObject*	CreateViewObject(iViewModule *parent, const iString& name);

	//
	//  Extensions for extendable objects
	//
	static void	InstallExtensions(iDataReader *reader);
	static void	InstallExtensions(iPicker *picker);
	static void	InstallExtensions(iViewModule *vm);

private:
		
	static void AttachExtension(iAbstractExtension *ext);
	static iArray<iAbstractExtensionPointer>& Extensions();
};

#endif // IOBJECTFACTORY_H
