//LICENSE A


#ifndef IORTHOSLICER_H
#define IORTHOSLICER_H


#include "igenericfilter.h"
#include <vtkImageAlgorithm.h>


class iOrthoSlicer : public iGenericImageDataFilter<vtkImageAlgorithm>
{

	iGenericFilterTypeMacro(iOrthoSlicer,vtkImageAlgorithm);

public: 

	void SetCurrentVar(int n);
	inline int GetCurrentVar() const { return mCurVar; }

    void SetDir(int d);
    inline int GetDir() const { return mDir; }

	void SetPos(double p);
	inline double GetPos() const { return mPos[mDir]; }
    
	void SetInterpolation(bool s);
	inline bool GetInterpolation() const { return mInterpolate; }

	void SetSampleRate(int r){ mSampleRate = r; Modified(); }
	inline int GetSampleRate() const { return mSampleRate; }
	
	static void GetUV(int Axis, int &Uidx, int &Vidx);

protected:

	virtual ~iOrthoSlicer();

	virtual void ProvideOutput();

private:

	int mCurVar;
	double mPos[3];
    int mDir, mSampleRate;
	bool mInterpolate;
};

#endif // IORTHOSLICER_H
