//LICENSE A

//
//  Class for outputing textual information. It is static, so it is available globally.
//  It uses a stack of iOutputChannel(s) to handle the output. Shells can add or remove
//  channels to redirect output where they like.
//
#ifndef IOUTPUT_H
#define IOUTPUT_H


class iOutputChannel;
class iString;


namespace iParameter
{
	namespace MessageType
	{
		const int Error = 0;
		const int Warning = 1;
		const int Information = 2;
#ifdef I_DEBUG
		const int DebugMessage = 3;
#endif
	};
};


class iOutput
{

public:

	static void Display(int type, const iString &text);

	static void ReportBug(const char* text, const char* file, int line, int severity);
	static void ReportBug(const iString& text, const char* file, int line, int severity);

	static void LogError(const iString &text);

	static void AddChannel(iOutputChannel *channel);
	static void RemoveChannel(iOutputChannel *channel);

#ifdef I_DEBUG
	static void DisplayDebugMessage(const iString& text);
#endif
};

#endif  // IOUTPUT_H
