//LICENSE A


#include "ioutputchannel.h"


#include "ierror.h"
#include "ishell.h"

#include <vtkCriticalSection.h>


using namespace iParameter;


iOutputChannel::iOutputChannel(iShell *s) : iShellComponent(s)
{
	mInDisplay = false;

	mMutex = vtkCriticalSection::New(); IASSERT(mMutex);
}


iOutputChannel::~iOutputChannel()
{
	mMutex->Delete();
}


void iOutputChannel::Display(int type, const iString &text)
{
	if(mInDisplay) return;
	mMutex->Lock();
	mInDisplay = true;

	this->DisplayBody(type,text);

	if(type == MessageType::Error)
	{
		iOutput::LogError(text);
	}

	mMutex->Unlock();
	mInDisplay = false;
}


void iOutputChannel::DisplayBody(int type, const iString &text)
{
	iString s = text + "\n";

	switch(type)
	{
		case MessageType::Error:
		{
			cerr << s.ToCharPointer();
			cerr.flush();
			break;
		}
		default:
		{
			cout << s.ToCharPointer();
			cout.flush();
		}
	}
}
