//LICENSE A

//
//  Method for outputing messages
//
#ifndef IOUTPUTCHANNEL_H
#define IOUTPUTCHANNEL_H


#include <vtkObjectBase.h>
#include "ishellcomponent.h"


#include <vtkSetGet.h>

class iShell;
class iString;

class vtkCriticalSection;


class iOutputChannel : public vtkObjectBase, public iShellComponent
{
	
	friend class iShell;

public:
	
	vtkTypeMacro(iOutputChannel,vtkObjectBase);

	//
	//  Use this function to report errors and display text
	//
	void Display(int type, const iString &text);

protected:
	
	iOutputChannel(iShell *s);
	virtual ~iOutputChannel();

	virtual void DisplayBody(int type, const iString &text) = 0;

private:

	bool mInDisplay;
	vtkCriticalSection *mMutex;
};

#endif  // IOUTPUTCHANNEL_H
