//LICENSE A


#ifndef IPAINTEDVIEWSUBJECT_H
#define IPAINTEDVIEWSUBJECT_H


#include "iactorviewsubject.h"


class iDataLimits;
class iPaintedViewSubject;


class iPaintedViewInstance : public iActorViewInstance
{

	friend class iPaintedViewSubject;
	
public:
	
	iDataConsumerTypeMacro(iPaintedViewInstance,iActorViewInstance);
		
	iObjectSlotMacro1SV(Palette,int);
	iObjectSlotMacro1SV(PaintVar,int);

protected:
	
	iPaintedViewInstance(iPaintedViewSubject *owner, int numactors, float maxopacity, int numpaintedactors, int priority, bool alwayspainted);
	virtual ~iPaintedViewInstance();

	iPaintedViewSubject* Owner() const;

	virtual void UpdatePainting();
	virtual void UpdateColorBars();

	virtual bool IsPainted() const;
	virtual iDataLimits* GetPaintingLimits() const;
	virtual bool SyncWithLimitsBody(int var, int mode);

	virtual bool IsConnectedToPaintingData() const = 0;

	int mPaintOffset;

private:

	const int mNumPaintedActors, mColorBarPriority;
	const bool mAlwaysPainted;
};


class iPaintedViewSubject : public iActorViewSubject
{
	
public:
	
	iDataConsumerTypeMacroPass(iPaintedViewSubject,iActorViewSubject);

	iType::vsp_int Palette;
	iType::vsp_int PaintVar;

	const iDataType& GetPaintingDataType() const { return mPaintingDataType; }

protected:
	
	iPaintedViewSubject(iObject *parent, const iString &fname, const iString &sname, iViewModule *vm, const iDataType &type, const iDataType &pdt, unsigned int flags, int minsize, int maxsize);
	virtual ~iPaintedViewSubject();

	const iDataType &mPaintingDataType;
};

#endif // IPAINTEDVIEWSUBJECT_H

