//LICENSE A


#ifndef IPAIR_H
#define IPAIR_H


//
//  A first-value-ordered pair of values for various uses
//
struct iPair
{
	union
	{
		float X;
		float Min;
	};
	union
	{
		float Y;
		float Max;
	};

	iPair(float x = 0.0, float y = 0.0)
	{ 
		X = x;
		Y = y;
	}

	iPair(const iPair &p)
	{ 
		X = p.X;
		Y = p.Y;
	}

	void operator=(const iPair &p)
	{
		X = p.X;
		Y = p.Y;
	}

	bool operator==(const iPair &p) const {	return (X == p.X); }

	inline float operator[](int i) const { return (i==0) ? X : Y; }
	inline float& operator[](int i) { return (i==0) ? X : Y; }
};


struct iOrderedPair : public iPair
{
	iOrderedPair(float x = 0.0, float y = 0.0) : iPair(x,y){}
	iOrderedPair(const iPair &p) : iPair(p){}

	bool operator<(const iOrderedPair &p) const
	{
		return (X < p.X);
	}
};

#endif  // IPAIR_H
