//LICENSE A


#ifndef IPALETTECOLLECTION_H
#define IPALETTECOLLECTION_H


#include "iobjectcollection.h"
#include "ipalette.h"
#include "ishellcomponent.h"


class vtkColorTransferFunction;
class vtkImageData;
class vtkLookupTable;


//
//  We inherit from iObject to get access to state saving
//
class iPaletteCollection : public iObjectCollectionFixed<iPalette>, public iShellComponent
{

	friend class iShell;

public:

	vtkTypeMacro(iPaletteCollection,iObjectCollectionFixed<iPalette>);
	static iPaletteCollection* New(iShell *s = 0);
	
	iPropertyAction Create;

	//
	//  Global set, available everywhere
	//
	static const iPaletteCollection* Global(){ return mGlobal; }

	iPalette* GetPalette(int n) const;
	vtkImageData* GetImageData(int id) const;
	vtkLookupTable* GetLookupTable(int id) const;
	vtkColorTransferFunction* GetColorTransferFunction(int id) const;

protected:

	virtual ~iPaletteCollection();

	virtual iPalette* NewObject();

private:

	iPaletteCollection(iShell *s, const iString &fname, const iString &sname);

	void CreateDefaultPalettes();
	static void WritePaletteImages(iShell *s, const iString& dirname);

	static iPaletteCollection* mGlobal;
};

#endif  // IPALETTECOLLECTION_H
