//LICENSE A


#ifndef IPARALLEL_H
#define IPARALLEL_H


//
//  Misc parallelization tools
//

namespace iParallel
{
	const unsigned long InformationEvent = 1001;

	struct ProcessorInfo
	{
		int NumProcs;
		int ThisProc;
		ProcessorInfo(){ ThisProc = 0; NumProcs = 1; }  // Must initialize to serial state!!!
		inline bool IsMaster() const { return (ThisProc == 0); }
	};

	//
	//  Helpers
	//
	template<class T>
	inline void SplitRange(ProcessorInfo &p, T n, T &lbeg, T &lend, T &lstp)
	{
		lstp = (n+p.NumProcs-1)/p.NumProcs;
		lbeg = lstp*p.ThisProc;
		lend = lbeg + lstp;
		if(p.ThisProc+1 == p.NumProcs) { lend = n; lstp = lend - lbeg; }
	}
};

#endif  // IPARALLEL_H
