//LICENSE A


#ifndef IPARALLELFFT_H
#define IPARALLELFFT_H


#include "iparallelworker.h"


class iParallelFFT : protected iParallelWorker
{

public:

	static iParallelFFT* New(iParallelManager *pp);
	virtual void Delete(){ delete this; }

	//
	// data must be a float arrays with dimensions n1*n2*n3
	// FFT component #icomp with ncomp altogether
	// dnyq (Nyquist frequency) must be a float arrays with dimensions 2*n2*n3
	// Memory allocation is not checked.
	//
	int Transform(bool forward, int comp, int ncomp, int n1, int n2, int n3, float *data, float *dnyq);

protected:

	virtual ~iParallelFFT();

private:

	iParallelFFT(iParallelManager *pp);

	virtual int ExecuteStep(int step, iParallel::ProcessorInfo &p);

	void ExecuteForwardTransform1(iParallel::ProcessorInfo &p);
	void ExecuteForwardTransform2(iParallel::ProcessorInfo &p);
	void ExecuteForwardTransform3(iParallel::ProcessorInfo &p);
	void ExecuteInverseTransform3(iParallel::ProcessorInfo &p);
	void ExecuteInverseTransform2(iParallel::ProcessorInfo &p);
	void ExecuteInverseTransform1(iParallel::ProcessorInfo &p);

	float *mWork1, *mWork2, *mWork3, *mW1, *mZ1, *mData, *mDnyq;
	int mNC, mN1, mN2, mN3, mN12, mNumProcs;
	float mProg, mProgStart, mProgScale;
};

#endif  // IPARALLELFFT_H
