//LICENSE A


#ifndef IPARALLELMANAGER_H
#define IPARALLELMANAGER_H


#include <vtkObject.h>
#include "ishellcomponent.h"


class iParallelHelper;
class iParallelUpdateEventObserver;
class iParallelWorker;


class iParallelManager : public vtkObject, public iShellComponent
{

public:

	static iParallelManager* New(iShell *s);

	int ExecuteWorker(iParallelWorker *worker); 

	inline int GetMinNumberOfProcessors() const { return mMinNumProcs; }
	inline int GetMaxNumberOfProcessors() const { return mMaxNumProcs; }
	inline int GetNumberOfProcessors() const { return mNumProcs; }
	
	void SetNumberOfProcessors(int n);

	void StartCounters();
	void StopCounters();

	double GetProcessorExecutionTime(int n) const;
	double GetWallClockExecutionTime() const;

#ifdef I_DEBUG
	static int DebugSwitch;
#endif

protected:

	iParallelManager(iShell *s);
	virtual ~iParallelManager();

	virtual iParallelHelper* CreateHelper() const = 0;

private:

	void Define();

	int mNumProcs, mMinNumProcs, mMaxNumProcs;
	int mCount;

	iParallelHelper *mHelper;
};

#endif  // IPARALLELMANAGER_H
