//LICENSE A


#include "iparallelworker.h"


#include "ierror.h"
#include "iparallel.h"
#include "iparallelmanager.h"
#include "ishell.h"
#include "ishelleventobservers.h"
#include "iviewmodulecomponent.h"

#include <vtkAlgorithm.h>


using namespace iParallel;


iParallelWorker::iParallelWorker(iParallelManager *pm)
{
	mManager = pm; IASSERT(mManager);
	mSerial = false;
}


iParallelWorker::~iParallelWorker()
{
}


iParallelManager* iParallelWorker::GetManager() const
{
	return mManager;
}


int iParallelWorker::ParallelExecute(int step)
{
	int ret = 0;

	if(mSerial || mManager==0)
	{
		ProcessorInfo p;
		ret = this->ExecuteStep(step,p);
	}
	else
	{
		wStep = step;
		ret = mManager->ExecuteWorker(this);
	}

	if(ret != 0) IBUG_WARN("Failure in iParallelWorker::ParallelExecute.");
	return ret;
}


int iParallelWorker::ExecuteInternal(ProcessorInfo &p)
{
	//
	//  p is guaranteed to have the correct value for ThisProc and NumProcs (0<=ThisProc<NumProcs)
	//
	return this->ExecuteStep(wStep,p);
}
