//LICENSE A


#ifndef IPARALLELWORKER_H
#define IPARALLELWORKER_H


namespace iParallel
{
	struct ProcessorInfo;
};

class iParallelManager;
class iString;


class iParallelWorker
{

	friend class iParallelHelper;
	friend class iParallelManager;

public:

	iParallelManager* GetManager() const;

	void SetExecuteSerially(bool s){ mSerial = s; }
	inline bool GetExecuteSerially(){ return mSerial; }

	virtual int ParallelExecute(int step);

protected:

	iParallelWorker(iParallelManager *pp);
	virtual ~iParallelWorker();

	virtual int ExecuteStep(int step, iParallel::ProcessorInfo &p) = 0;

private:

	bool mSerial;
    iParallelManager *mManager;

	int wStep;  // work variable
	int ExecuteInternal(iParallel::ProcessorInfo &p);
};

#endif  // IPARALLELWORKER_H
