//LICENSE A

//
//  Ifrit data filter: takes PolyData data with only vertices specified and
//  changes the point symbol.
//  

#ifndef IPARTICLEDATACONVERTER_H
#define IPARTICLEDATACONVERTER_H


#include "igenericfilter.h"
#include <vtkPolyDataAlgorithm.h>


class iParticleViewInstance;
class iPointGlyph;
class iViewInstance;


class iParticleDataConverter: public iGenericPolyDataFilter<vtkPolyDataAlgorithm>
{

	vtkTypeMacro(iParticleDataConverter,vtkPolyDataAlgorithm);

public:

	static iParticleDataConverter* New(iViewInstance *owner = 0);

	int GetType() const;
	inline float GetSize() const { return mSize; }

	virtual void SetType(int t);
	virtual void SetSize(float s);

	virtual float GetMemorySize();

protected:
	
	iParticleDataConverter(iViewInstance *owner);
	virtual ~iParticleDataConverter();
	
	virtual void ProvideOutput();

private:

	float mSize;
	iPointGlyph *mPoint;
	iParticleViewInstance *mOwner;
};

#endif // IPARTICLEDATACONVERTER_H


