//LICENSE A


#include "iparticlepipeline.h"


#include "ierror.h"
#include "iparticledataconverter.h"
#include "iparticleviewsubject.h"
#include "ireplicatedpolydata.h"

//
//  Templates
//
#include "iarray.tlh"
#include "igenericfilter.tlh"
#include "iviewsubjectpipeline.tlh"


iPipelineKeyDefineMacro(iParticlePipeline,Type);
iPipelineKeyDefineMacro(iParticlePipeline,Scaling);
iPipelineKeyDefineMacro(iParticlePipeline,FixedSize);

	
//
// iParticlePipeline class
//
iParticlePipeline::iParticlePipeline(iParticleViewInstance *owner) : iReplicatedViewSubjectPipeline(owner,1)
{
	mOwner = owner;

	//
	//  Do VTK stuff
	//	
	mDataConverter = this->CreateFilter<iParticleDataConverter>();

	this->CompletePipeline(mDataConverter->GetOutputPort());
	this->UpdateContents();
}


iParticlePipeline::~iParticlePipeline()
{
}


bool iParticlePipeline::PrepareInput()
{
	vtkPolyData *input = vtkPolyData::SafeDownCast(this->InputData());
	if(input == 0)
	{
		IBUG_ERROR("iParticlePipeline is configured incorrectly.");
		return false;
	}

	if(mDataConverter->InputData() != input)
	{
		mDataConverter->SetInputData(input);
	}
	
	return true;
}


void iParticlePipeline::UpdateScaling()
{ 
	mDataConverter->Modified();
	this->Modified();
}


void iParticlePipeline::UpdateType()
{ 
	mDataConverter->SetType(mOwner->GetType());
	this->Modified();
}


void iParticlePipeline::UpdateFixedSize()
{ 
	mDataConverter->SetSize(mOwner->GetFixedSize());
	this->Modified();
}

