//LICENSE A


#ifndef IPARTICLEPIPELINE_H
#define IPARTICLEPIPELINE_H


#include "ireplicatedviewsubjectpipeline.h"


class iParticleDataConverter;
class iParticleViewInstance;

class vtkPolyData;


class iParticlePipeline : public iReplicatedViewSubjectPipeline
{

	friend class iParticleViewInstance;

public:
	
	vtkTypeMacro(iParticlePipeline,iReplicatedViewSubjectPipeline);

	iPipelineKeyDeclareMacro(iParticlePipeline,Type);
	iPipelineKeyDeclareMacro(iParticlePipeline,Scaling);
	iPipelineKeyDeclareMacro(iParticlePipeline,FixedSize);

protected:
	
	iParticlePipeline(iParticleViewInstance *owner);
	virtual ~iParticlePipeline();

	virtual bool PrepareInput();

	iParticleViewInstance *mOwner;
	iParticleDataConverter *mDataConverter;
};

#endif // IPARTICLEPIPELINE_H

