//LICENSE A

//
//  vtkPostScriptWriter with different paper formats
//

#ifndef IPOSTSCRIPTWRITER_H
#define IPOSTSCRIPTWRITER_H


#define NFORMATS	11


#include <vtkPostScriptWriter.h>



class iPostScriptWriter : public vtkPostScriptWriter
{

public:

	vtkTypeMacro(iPostScriptWriter,vtkPostScriptWriter);
	static iPostScriptWriter* New(){ return new iPostScriptWriter; }
	
	virtual void SetPaperFormat(int f);
	inline int GetPaperFormat(){ return mFormat; }
	
	virtual void SetOrientation(int o);
	inline int GetOrientation(){ return mOrient; }
	
	static const char* GetPaperFormatName(int n){ if(n>=0 && n<NFORMATS) return mPaper[n].Name; else return ""; }

protected:

	virtual ~iPostScriptWriter();

	virtual void WriteFileHeader(ofstream *os, vtkImageData *data);
	virtual void WriteFile(ofstream *file, vtkImageData *data, int extent[6]);

private:

	struct Paper
	{
		const char *Name;
		float Width, Height;
	};

	iPostScriptWriter();

	int mFormat, mOrient;
	static Paper mPaper[NFORMATS];
};

#endif  // IPOSTSCRIPTWRITER_H


