//LICENSE A

//
//  Optimized version of vtkProbeFilter for vtkPolyData input and vtkImageData source;
//  Also, vtkProbeFilter does not pass through normals of the input (for a good reason!).
//  This filter adds passing normals.
//

#ifndef IPROBEFILTER_H
#define IPROBEFILTER_H


#include "igenericfilter.h"
#include <vtkProbeFilter.h>


class vtkImageData;
class vtkPointSet;


class iProbeFilter : public iGenericFilter<vtkProbeFilter,vtkDataSet,vtkDataSet>
{

	iGenericFilterTypeMacro(iProbeFilter,vtkProbeFilter);

public:

	void RestrictToType(const char *name);

	vtkDataSet* SourceData();

protected:
	
	virtual int FillInputPortInformation(int port, vtkInformation *info);
	virtual int FillOutputPortInformation(int port, vtkInformation *info);

	virtual void ProvideOutput();

private:

	void ProduceOutputForImageData(vtkPointSet *input, vtkPointSet *output, vtkImageData *source);

	const char *mRestrictedType;

private:

	/* blocked */ vtkDataObject *GetSource(){ return this->vtkProbeFilter::GetSource(); }
};

#endif  // IPROBEFILTER_H


