//LICENSE A


#include "ipropertyposition.h"


#include "ierror.h"
#include "iobject.h"
#include "iposition.h"


//
//  Templates
//
#include "iarray.tlh"
#include "iproperty.tlh"


iPropertyScalarPosition::iPropertyScalarPosition(iObject *owner, iViewModule *vm, SetterType setter, GetterType getter, const iString &name, const iString &sname) : iPropertyScalar<iType::Vector>(owner,(iPropertyScalar<iType::Vector>::SetterType)setter,(iPropertyScalar<iType::Vector>::GetterType)getter,name,sname), iViewModuleComponent(vm)
{
	mSetter = setter; IASSERT(setter);
	mGetter = getter; IASSERT(getter);
}


const iVector3D& iPropertyScalarPosition::GetValue(int i) const
{
	return (this->Owner()->*mGetter)().BoxValue(); 
}


bool iPropertyScalarPosition::SetValue(int i, const iVector3D& v) const
{
	iPosition pos(this->GetViewModule());
	pos.SetBoxValue(v);
	if((this->Owner()->*mSetter)(pos))
	{
		this->RequestRender();
		return true;
	}
	else return false;
}


iPropertyScalarDistance::iPropertyScalarDistance(iObject *owner, iViewModule *vm, SetterType setter, GetterType getter, const iString &name, const iString &sname) : iPropertyScalar<iType::Double>(owner,(iPropertyScalar<iType::Double>::SetterType)setter,(iPropertyScalar<iType::Double>::GetterType)getter,name,sname), iViewModuleComponent(vm)
{
	mSetter = setter; IASSERT(setter);
	mGetter = getter; IASSERT(getter);
}


double iPropertyScalarDistance::GetValue(int i) const
{
	return (this->Owner()->*mGetter)().BoxValue(); 
}


bool iPropertyScalarDistance::SetValue(int i, double v) const
{
	iDistance d(this->GetViewModule());
	d.SetBoxValue(v);
	if((this->Owner()->*mSetter)(d))
	{
		this->RequestRender();
		return true;
	}
	else return false;
}
