//LICENSE A

//
//  Position-values property
//

#ifndef IPROPERTYPOSITION_H
#define IPROPERTYPOSITION_H


#include "iproperty.h"
#include "iviewmodulecomponent.h"


class iDistance;
class iPosition;

//
//  Index that automatically shifts by 1 for script indexing
//
class iPropertyScalarPosition : public iPropertyScalar<iType::Vector>, public iViewModuleComponent
{

public:

	typedef bool (iObject::*SetterType)(const iPosition& val);
	typedef const iPosition& (iObject::*GetterType)() const;

	iPropertyScalarPosition(iObject *owner, iViewModule *vm, SetterType setter, GetterType getter, const iString &name, const iString &sname);

protected:

	virtual const iVector3D& GetValue(int i) const;
	virtual bool SetValue(int i, const iVector3D& v) const;

private:

	SetterType mSetter;
	GetterType mGetter;
};


class iPropertyScalarDistance : public iPropertyScalar<iType::Double>, public iViewModuleComponent
{

public:

	typedef bool (iObject::*SetterType)(const iDistance& val);
	typedef const iDistance& (iObject::*GetterType)() const;

	iPropertyScalarDistance(iObject *owner, iViewModule *vm, SetterType setter, GetterType getter, const iString &name, const iString &sname);

protected:

	virtual double GetValue(int i) const;
	virtual bool SetValue(int i, double v) const;

private:

	SetterType mSetter;
	GetterType mGetter;
};



#endif // IPROPERTYPOSITION_H

