//LICENSE A


#include "ireducepolydatafilter.h"


#include "ierror.h"

#include <vtkDecimatePro.h>
#include <vtkTriangleFilter.h>

//
//  Templates
//
#include "igenericfilter.tlh"


iReducePolyDataFilter::iReducePolyDataFilter(iDataConsumer *consumer) : iGenericPolyDataFilter<vtkPolyDataAlgorithm>(consumer,1,true)
{
	mTriangulator = vtkTriangleFilter::New(); IERROR_CHECK_MEMORY(mTriangulator);
	mDecimator = vtkDecimatePro::New(); IERROR_CHECK_MEMORY(mDecimator);

	mDecimator->PreserveTopologyOn();
	mDecimator->BoundaryVertexDeletionOff();
	mDecimator->SetInputConnection(mTriangulator->GetOutputPort());
}
	

void iReducePolyDataFilter::SetTargetReduction(double v)
{
	mDecimator->SetTargetReduction(v);
	this->Modified();
}


double iReducePolyDataFilter::GetTargetReduction()
{
	return mDecimator->GetTargetReduction();
}


iReducePolyDataFilter::~iReducePolyDataFilter()
{
	mDecimator->Delete();
	mTriangulator->Delete();
}


void iReducePolyDataFilter::ProvideOutput()
{
	mTriangulator->SetInputData(this->InputData());
	mDecimator->Update();
	this->OutputData()->ShallowCopy(mDecimator->GetOutput());
}
