//LICENSE A


//
//  A background renderer for iRenderTool
//
#ifndef IRENDERTOOLBACKGROUND_H
#define IRENDERTOOLBACKGROUND_H


#include <vtkObjectBase.h>


#include "icolor.h"
#include "iimage.h"

#include <vtkSetGet.h>


class iRenderToolBackgroundImageMapper;

class vtkActor2D;
class vtkRenderer;

#define IRENDERTOOLBACKGROUND_BACK_LAYER		0
#define IRENDERTOOLBACKGROUND_FRONT_LAYER		1


class iRenderToolBackground : public vtkObjectBase
{

public:

	vtkTypeMacro(iRenderToolBackground,vtkObjectBase);
	static iRenderToolBackground* New();

	inline vtkRenderer* GetRenderer() const { return mRenderer; }

	void SetColor(const iColor &color);
	inline const iColor& GetColor() const { return mColor; }

	void SetImage(const iImage &image);
	inline const iImage& GetImage() const { return mImage; }
	void SetImageFixedAspect(bool s);
	void SetImageTile(const float tile[4]);

	void Copy(const iRenderToolBackground *source);

protected:
	
	virtual ~iRenderToolBackground();

private:

	iRenderToolBackground();

	iColor mColor;
	iImage mImage;

	vtkActor2D *mActor;
	iRenderToolBackgroundImageMapper *mMapper;
	vtkRenderer *mRenderer;
};

#endif // IRENDERTOOLBACKGROUND_H

