//LICENSE A


//
//  An actor that can be replicated periodically. This is a preferred way to replicate, since
//  we create no new data and re-use mappers.
//
#ifndef IREPLICATEDACTOR_H
#define IREPLICATEDACTOR_H


#include "iactor.h"
#include "ireplicatedelement.h"


class iReplicatedActorDevice;


class iReplicatedActor : public iActor, public iReplicatedElement
{
	
public:
	
	vtkTypeMacro(iReplicatedActor,iActor);
	static iReplicatedActor* New(iViewSubject *owner = 0);

	virtual double* GetBounds();
	virtual void Render(vtkRenderer *ren, vtkMapper *m);

protected:
	
	iReplicatedActor(iViewSubject *owner);
	virtual ~iReplicatedActor();
	
	virtual void UpdateReplicasBody();

private:

	iReplicatedActorDevice *mRealDevice;
	vtkTimeStamp mReplicatedBoundsMTime;
};

#endif // IREPLICATEDACTOR_H
