//LICENSE A


//
//  A class that can be replicated periodically in all 3 directions.
//
#ifndef IREPLICATEDELEMENT_H
#define IREPLICATEDELEMENT_H


class iViewSubject;


class iReplicatedElement
{

	friend class iViewSubject;

public:
	
	void SetReplicationFactors(const int n[6]);
	void GetReplicationFactors(int n[6]) const;

	inline bool IsReplicated() const { return mReplicationFactors[0]>0 || mReplicationFactors[1]>0 || mReplicationFactors[2]>0 || mReplicationFactors[3]>0 || mReplicationFactors[4]>0 || mReplicationFactors[5]>0; }

	void ReplicateAs(iViewSubject *parent);

protected:
	
	iReplicatedElement(bool isData);
	virtual ~iReplicatedElement();
	
	void UpdateReplicas(bool force = false);
	virtual void UpdateReplicasHead(){}
	virtual void UpdateReplicasBody() = 0;

	const bool mIsData;
	int mReplicationFactors[6], mOldReplicationFactors[6];
	iViewSubject *mParent;
};

#endif // IREPLICATEDELEMENT_H
