//LICENSE A

//
//  Takes StructuredPoints data of any type and replicates them periodically.
//
#ifndef IREPLICATEDGRIDDATA_H
#define IREPLICATEDGRIDDATA_H


#include "igenericfilter.h"
#include <vtkImageAlgorithm.h>
#include "iparallelworker.h"
#include "ireplicatedelement.h"


class iViewInstance;


class iReplicatedGridData : public iGenericImageDataFilter<vtkImageAlgorithm>, protected iParallelWorker, public iReplicatedElement
{

public:

	vtkTypeMacro(iReplicatedGridData,vtkImageAlgorithm);

	static iReplicatedGridData* New(iViewInstance *owner = 0);

	virtual float GetMemorySize();

protected:
	
	iReplicatedGridData(iViewInstance *owner);

	virtual void ProvideInfo();
	virtual void ProvideOutput();
	virtual void UpdateReplicasBody();

	virtual int ExecuteStep(int step, iParallel::ProcessorInfo &p);

private:

	//
	//  Work variables
	//
	int wDimsIn[3], wDimsOut[3], wExt[3];
	vtkIdType wSize, wSize0, wSize1;
	char *wPtrIn, *wPtrOut;
};

#endif  // IREPLICATEDGRIDDATA_H


