//LICENSE A

//
//  Takes PolyData data of any type and replicates them periodically.
//
#ifndef IREPLICATEDPOLYDATA_H
#define IREPLICATEDPOLYDATA_H


#include "igenericfilter.h"
#include <vtkPolyDataAlgorithm.h>
#include "ireplicatedelement.h"


class iViewInstance;


class iReplicatedPolyData : public iGenericPolyDataFilter<vtkPolyDataAlgorithm>, public iReplicatedElement
{

public:

	vtkTypeMacro(iReplicatedPolyData,iGenericPolyDataFilter<vtkPolyDataAlgorithm>);
	static iReplicatedPolyData* New(iViewInstance *owner = 0) { IERROR_CHECK_MEMORY(owner); return new iReplicatedPolyData(owner); }

	virtual float GetMemorySize();

	//
	//  Removes stitches between extensions in place
	//
	static void PatchStitches(vtkPolyData *input, int ndim, double *edges, vtkIdType nEdges);

protected:
	
	iReplicatedPolyData(iViewInstance *owner);

	virtual void ProvideOutput();
	virtual void UpdateReplicasBody();

private:

	void ExtendDirection(vtkPolyData *input, vtkPolyData *output, int dim, int extDown, int extUp);
};

#endif  // IREPLICATEDPOLYDATA_H


