//LICENSE A


#include "ireplicatedviewsubjectpipeline.h"


#include "ireplicatedpolydata.h"

//
//  Templates (needed for some compilers)
//
#include "iarray.tlh"
#include "igenericfilter.tlh"
#include "iviewsubjectpipeline.tlh"


//
//  generic iFieldGlyphPipeline class
//
iReplicatedViewSubjectPipeline::iReplicatedViewSubjectPipeline(iViewInstance *owner, int numInputs) : iViewSubjectPipeline(owner,numInputs)
{
	mOwner = owner;

	//
	//  Do VTK stuff
	//	
	mDataReplicated = this->CreateFilter<iReplicatedPolyData>();
}


iReplicatedViewSubjectPipeline::~iReplicatedViewSubjectPipeline()
{
}


void iReplicatedViewSubjectPipeline::CompletePipeline(vtkAlgorithmOutput *port)
{
	mDataReplicated->SetInputConnection(port);
}


void iReplicatedViewSubjectPipeline::ProvideOutput()
{
	if(this->PrepareInput())
	{
		//
		//  Update the pipeline
		//
		mDataReplicated->Update();
		this->OutputData()->ShallowCopy(mDataReplicated->OutputData());
	}
}


void iReplicatedViewSubjectPipeline::UpdateReplicas()
{
	mDataReplicated->Modified();
	this->Modified();
}

