//LICENSE A


#ifndef IRESAMPLEIMAGEDATAFILTER_H
#define IRESAMPLEIMAGEDATAFILTER_H


#include "igenericfilter.h"
#include <vtkImageAlgorithm.h>


class iResampleImageDataFilter : public iGenericImageDataFilter<vtkImageAlgorithm>
{
	
	iGenericFilterTypeMacro(iResampleImageDataFilter,vtkImageAlgorithm);

public:

	void SetResampleRate(int v);
	inline int GetResampleRate() const { return mResampleRate; }

protected:
	
	virtual void ProvideInfo();
	virtual void ProvideOutput();

	void ResampleArray();

private:

	void ComputeOutputShape(int dims[3], double spac[3], int outDims[3], double outSpac[3]);

	int mResampleRate;

	int wInDims[3], wOutDims[3];
};

#endif // IRESAMPLEIMAGEDATAFILTER_H

