//LICENSE A


#ifndef IRULER_H
#define IRULER_H


#include "iaxis.h"
#include "iviewmoduletool.h"


#include "istring.h"

class iRuler;


class iRulerActor: public iAxis, public iViewModuleComponent
{
	
	friend class iRuler;

public:
	
	vtkTypeMacro(iRulerActor,iAxis);
	
	void SetBaseScale(float s);

	void SetScale(float s);
	void SetTitle(const iString &title);

protected:

	virtual void UpdateGeometry(vtkViewport *vp);
	virtual void UpdateOverlay(vtkViewport *vp);

private:
	
	iRulerActor(iRuler *owner);
	
	iRuler *mOwner;
	bool mStarted;
	float mBaseScale;
};


class iRuler : public iViewModuleTool
{
	
public:

	vtkTypeMacro(iRuler,iViewModuleTool);
	static iRuler* New(iViewModule *vm = 0);
		
	iObjectPropertyMacro1S(Scale,Float);
	iObjectPropertyMacro1S(Title,String);

	inline iRulerActor* GetActor() const { return mActor; }

protected:

	virtual ~iRuler();

private:
	
	iRuler(iViewModule *vm, const iString &fname, const iString &sname);

	virtual bool ShowBody(bool s);

	//
	//  Actors displayed by this class
	//
	iRulerActor *mActor;
};

#endif // IRULER_H
