//LICENSE A


#ifndef IRUNNER_H
#define IRUNNER_H


class iShell;
class iString;

class vtkMultiThreader;


//
//  Interface for starting the code in various ways
//
class iRunner
{

	friend class iShell;

public:

	iRunner();
	virtual ~iRunner();

	inline iShell* GetShell() const { return mShell; }

	//
	//  The main driver that creates, runs, and deletes a shell in one call
	//  Event loop is implemented via iScript interface
	//
	void Run(int argc, const char **argv);

	//
	//  For external driving (launches but does not run an event loop in the extended mode).
	//  Launched shell needs to be stopped explicitly for thread safety.
	//
	bool Launch(int argc, const char **argv);
	void Stop();

private:

	iShell *mShell;
	vtkMultiThreader *mThreader;
	int mThreadId;
};

#endif  // IRUNNER_H
