//LICENSE A


#include "iscript.h"


//
//  Actual base class
//
iScript::iScript(const iString& name, iShell *s) : iShellComponent(s), mName(name)
{
	mIOHelper = 0;
	mObserver = 0;
}


iScript::~iScript()
{
}


void iScript::Delete()
{
	this->InstallIOHelper(0);
	this->InstallObserver(0);

	delete this;
}


void iScript::InstallObserver(iScriptObserver *obs)
{
	if(mObserver != obs)
	{
		if(mObserver != 0) delete mObserver;

		mObserver = obs;
		if(mObserver != 0) mObserver->mScript = this;
		this->OnInstallObserver();
	}
}


void iScript::InstallIOHelper(iScriptIOHelper *ioh)
{
	if(mIOHelper != ioh)
	{
		if(mIOHelper != 0) delete mIOHelper;

		mIOHelper = ioh;
		this->OnInstallIOHelper();
	}
}


void iScript::OnInstallObserver()
{
}


void iScript::OnInstallIOHelper()
{
}



//
//  Observer class
//
iScriptObserver::iScriptObserver()
{
	mScript = 0;
	mIsEnabled = true;
}


iScriptObserver::~iScriptObserver()
{
}


void iScriptObserver::Enable(bool s)
{
	mIsEnabled = s;
}


bool iScriptObserver::IsTerminated()
{
	if(mIsEnabled && mScript!=0) return this->IsTerminatedBody(); else return false;
}


void iScriptObserver::OnStart()
{
	if(mIsEnabled && mScript!=0) this->OnStartBody();
}


void iScriptObserver::OnStop(bool aborted)
{
	if(mIsEnabled && mScript!=0) this->OnStopBody(aborted);
}


void iScriptObserver::OnBeginLine(int line, const iString &file)
{
	if(mIsEnabled && mScript!=0) this->OnBeginLineBody(line,file);
}


void iScriptObserver::OnEndLine(int line, const iString &file)
{
	if(mIsEnabled && mScript!=0) this->OnEndLineBody(line,file);
}


/*
void iScriptObserver::OnFunctionCall(int line, const iString &file, const iString &fun)
{
	if(mIsEnabled && mScript!=0) this->OnFunctionCallBody(line,file,fun);
}


void iScriptObserver::OnVariableChange(int line, const iString &file, const iString &var)
{
	if(mIsEnabled && mScript!=0) this->OnVariableChangeBody(line,file,var);
}
*/

