//LICENSE A

//
//  A HEALPix sphere
//
#ifndef ISPHERESOURCE_H
#define ISPHERESOURCE_H


#include <vtkPolyDataAlgorithm.h>


class iSphereSource : public vtkPolyDataAlgorithm
{

public:

	vtkTypeMacro(iSphereSource,vtkPolyDataAlgorithm);
	static iSphereSource* New();

	void SetOrder(int order);
	inline int GetOrder() const { return mOrder; }
	void SetResolution(int res);

	void SetRadius(double v);
	inline double GetRadius() const { return mRadius; }

	void SetCenter(double pos[3]);
	void GetCenter(double pos[3]) const;
	inline const double* GetCenter() const { return mCenter; }

protected:

	iSphereSource();

	virtual int	RequestData(vtkInformation *request, vtkInformationVector **inputVector, vtkInformationVector *outputVector);

private:

	int mOrder;
	double mRadius, mCenter[3];
};

#endif // IORTHOPOLYGONPLANEFILTER_H
