//LICENSE A


#ifndef ISURFACEPIPELINE_H
#define ISURFACEPIPELINE_H


#include "ireplicatedviewsubjectpipeline.h"


class iBoundedPlaneSource;
class iBoundedSphereSource;
class iContourFilter;
class iFlipNormalsFilter;
class iOptimizePolyDataFilter;
class iProbeFilter;
class iReducePolyDataFilter;
class iReducePolyDataFilter2;
class iSmoothPolyDataFilter;
class iSurfaceViewInstance;


class iSurfacePipeline : public iReplicatedViewSubjectPipeline
{

	friend class iSurfaceViewInstance;

public:
	
	vtkTypeMacro(iSurfacePipeline,iReplicatedViewSubjectPipeline);

	iPipelineKeyDeclareMacro(iSurfacePipeline,Method);
	iPipelineKeyDeclareMacro(iSurfacePipeline,IsoVar);
	iPipelineKeyDeclareMacro(iSurfacePipeline,IsoLevel);
	iPipelineKeyDeclareMacro(iSurfacePipeline,IsoMethod);
	iPipelineKeyDeclareMacro(iSurfacePipeline,IsoPipeline);
	iPipelineKeyDeclareMacro(iSurfacePipeline,NormalsFlipped);
	iPipelineKeyDeclareMacro(iSurfacePipeline,SphereSize);
	iPipelineKeyDeclareMacro(iSurfacePipeline,SphereResolution);
	iPipelineKeyDeclareMacro(iSurfacePipeline,PlaneDirection);
	iPipelineKeyDeclareMacro(iSurfacePipeline,PlaneResolution);
	iPipelineKeyDeclareMacro(iSurfacePipeline,ObjectPosition);

protected:
	
	iSurfacePipeline(iSurfaceViewInstance *owner);
	virtual ~iSurfacePipeline();

	virtual bool PrepareInput();

	virtual vtkAlgorithm* GetIsoFilter() const; // for extensions' use

	iSurfaceViewInstance *mOwner;

	//
	//  VTK stuff
	//
	iContourFilter *mIsoFilter;
	iProbeFilter *mProbeFilter;

	iReducePolyDataFilter *mReduceFilter;
	iReducePolyDataFilter2 *mReduce2Filter;
	iSmoothPolyDataFilter *mSmoothFilter;
	iFlipNormalsFilter *mFlipNormalsFilter;
	iOptimizePolyDataFilter *mOptimizeFilter;

	iBoundedSphereSource *mSphereSource;
	iBoundedPlaneSource *mPlaneSource;

	int mSpecialVar;
};

#endif // ISURFACEPIPELINE_H

