//LICENSE A


#ifndef ITENSORFIELDGLYPHPIPELINE_H
#define ITENSORFIELDGLYPHPIPELINE_H


#include "ifieldglyphpipeline.h"


class iPointGlyph;
class iTensorGlyphFilter;
class iTensorFieldViewInstance;


class iTensorFieldGlyphPipeline : public iFieldGlyphPipeline
{

	friend class iTensorFieldViewInstance;

public:

	vtkTypeMacro(iTensorFieldGlyphPipeline,iFieldGlyphPipeline);

	iPipelineKeyDeclareMacro(iTensorFieldGlyphPipeline,Scaling);
	iPipelineKeyDeclareMacro(iTensorFieldGlyphPipeline,Painting);
	iPipelineKeyDeclareMacro(iTensorFieldGlyphPipeline,GlyphType);

protected:
	
	iTensorFieldGlyphPipeline(iTensorFieldViewInstance *owner);
	virtual ~iTensorFieldGlyphPipeline();

	virtual void SetGlyphFilterInput(vtkDataSet *input);
	virtual void SetGlyphFilterScale(double s);

	iTensorFieldViewInstance *mOwner;

	//
	//  VTK stuff
	//
	iPointGlyph *mGlyph;
	iTensorGlyphFilter *mGlyphFilter;
};

#endif // ITENSORFIELDGLYPHPIPELINE_H

