//LICENSE A


#ifndef ITENSORFIELDVIEWSUBJECT_H
#define ITENSORFIELDVIEWSUBJECT_H


#include "ifieldviewsubject.h"


class iPolyDataExtender;
class iTensorFieldViewSubject;
class iViewObject;


class iTensorFieldViewInstance : public iFieldViewInstance
{
	
	friend class iTensorFieldViewSubject;

public:
	
	iDataConsumerTypeMacroPass(iTensorFieldViewInstance,iFieldViewInstance);
		
	iObjectSlotMacro1SV(Method,int);
	iObjectSlotMacro1SV(Scaling,bool);
	iObjectSlotMacro1SV(GlyphType,int);

	virtual bool CanBeShown() const;

protected:
	
	iTensorFieldViewInstance(iTensorFieldViewSubject *owner);
	virtual ~iTensorFieldViewInstance();
	virtual void ConfigureBody();
	virtual void ConfigureMainPipeline(iViewSubjectPipeline *p, int id);

	virtual iViewSubjectPipeline* CreatePipeline(int id);
	virtual void ResetPipelineInput(vtkDataSet *input);

	virtual void ShowBody(bool s);

	virtual void UpdatePainting();
	virtual void UpdateGlyphSize();
	virtual void UpdateGlyphSampleRate();
};


class iTensorFieldViewSubject : public iFieldViewSubject
{
	
public:
	
	iViewSubjectTypeMacro2(iTensorFieldView,iFieldViewSubject);
		
	iType::vsp_int Method;
	iType::vsp_bool Scaling;
	iType::vsp_int GlyphType;

protected:
	
	iTensorFieldViewSubject(iViewObject *parent, const iDataType &type, const iDataType &stype);
	virtual ~iTensorFieldViewSubject();
};

#endif // ITENSORFIELDVIEWSUBJECT_H

