//LICENSE A


#ifndef ITENSORGLYPHFILTER_H
#define ITENSORGLYPHFILTER_H


#include "igenericfilter.h"
#include <vtkDataSetAlgorithm.h>


class vtkTensorGlyph;


class iTensorGlyphFilter : public iGenericFilter<vtkDataSetAlgorithm,vtkDataSet,vtkPolyData>
{

	iGenericFilterTypeMacro(iTensorGlyphFilter,vtkDataSetAlgorithm);

public:

	virtual ~iTensorGlyphFilter();

	void SetScaling(bool s);
	bool GetScaling() const;

	void SetScaleFactor(float s);
	float GetScaleFactor() const;

	void SetCurrentVar(int n);
	inline int GetCurrentVar() const { return mCurVar; }
	
	void SetGlyphConnection(vtkAlgorithmOutput *port);

protected:
	
	virtual void ProvideOutput();

	int mCurVar;
	vtkTensorGlyph *mWorker;
};

#endif  // ITENSORGLYPHFILTER_H


