//LICENSE A


#ifndef ITEXTACTOR_H
#define ITEXTACTOR_H


#include "igenericprop.h"
#include <vtkProp.h>


#include "istring.h"
#include "ipointermacro.h"

class iOverlayHelper;
class iRenderTool;
class iTextSubject;

class vtkTextProperty;


class iTextActor: public iGenericProp<vtkProp>
{

	IPOINTER_AS_PART(RenderTool);
	IPOINTER_AS_USER(OverlayHelper);

public:

	vtkTypeMacro(iTextActor,vtkProp);
	static iTextActor* New(iRenderTool *rv = 0);
	
	void SetBold(bool s);

	void SetJustification(int jx);
	void SetJustification(int jx, int jy);

	void MoveJustification(int jx);

	void SetPosition(float x, float y);
	inline const float* GetPosition() const { return mPos; }
	
	void SetAngle(float a);
	inline float GetAngle() const { return mAngle; }

	void SetText(const iString &s);
	inline const iString& GetText() const { return mText; }

	void GetSize(vtkViewport *vp, float s[2]) const;
	void GetBounds(vtkViewport *vp, float b[4]) const;
	void GetTextAnchor(vtkViewport *vp, float p[2]) const;

	vtkTextProperty* GetTextProperty() const { return mProperty; }

protected:
	
	iTextActor(iRenderTool *rv);
	virtual ~iTextActor();

	virtual void UpdateGeometry(vtkViewport *vp);

	void SetPadding(float p);

private:

	int mCurrentSubject;
	float mPos[2], mAngle, mPadding;
	iString mText;

	vtkTextProperty *mProperty;
	iTextSubject* mSubjects[2];
};

#endif // ITEXTACTOR_H
