//LICENSE A


#include "itextsubject.h"


#include "ioverlayhelper.h"
#include "irendertool.h"
#include "itextactor.h"

#include <vtkTextProperty.h>
#include <vtkViewport.h>

//
//  Templates
//
#include "iarray.tlh"
#include "igenericprop.tlh"


iTextSubject::iTextSubject(iTextActor *parent, iRenderTool *rv) : iGenericProp<vtkProp>(false), mOverlayHelper(rv), mParent(parent)
{
	IASSERT(parent);

	mPos[0] = mPos[1] = 0.0;

	this->PickableOff();
}


iTextSubject::~iTextSubject()
{
}


void iTextSubject::GetSize(vtkViewport *vp, float s[2])
{
#ifndef I_NO_CHECK
	int mag = mOverlayHelper->GetRenderTool()->GetRenderingMagnification();
	if(mag > 1)
	{
		IBUG_WARN("Incorrect call to iTextSubject::GetSize");
	}
#endif

	mOverlayHelper->UpdateTextProperty(vp,mParent->GetTextProperty());
	mParent->GetTextProperty()->SetFontSize(mOverlayHelper->GetFontSize(vp,mag));
	this->ComputeSize(vp,s);
}


void iTextSubject::UpdateGeometry(vtkViewport *vp)
{
	int mag = this->GetOverlayHelper()->GetRenderingMagnification();

	if(mag == 1)
	{
		this->GetSize(vp,mSize);
		mParent->GetTextAnchor(vp,mPos);
	}

	mParent->GetTextProperty()->SetFontSize(mOverlayHelper->GetFontSize(vp,mag));

	this->UpdateGeometryBody(vp,mag);
}

