//LICENSE A

//
//  Superclass for displaying text in VTK
//
#ifndef ITEXTSUBJECT_H
#define ITEXTSUBJECT_H


#include "igenericprop.h"
#include <vtkProp.h>


#include "ipointermacro.h"

class iTextActor;
class iOverlayHelper;
class iRenderTool;

class vtkViewport;


class iTextSubject : public iGenericProp<vtkProp>
{
	
	IPOINTER_AS_USER(OverlayHelper);

public:

	void GetSize(vtkViewport *v, float s[2]);
	
protected:
	
	iTextSubject(iTextActor *parent, iRenderTool *rv);
	virtual ~iTextSubject();

	virtual void ComputeSize(vtkViewport *vp, float s[2]) = 0;

	virtual void UpdateGeometry(vtkViewport *vp);
	virtual void UpdateGeometryBody(vtkViewport *vp, int mag) = 0;

	iTextActor *mParent;
	float mPos[2], mSize[2];
};

#endif // ITEXTSUBJECT_H
