//LICENSE A


#include "itransform.h"


#include <vtkMath.h>

#include "ivtk.h"


iTransform* iTransform::New()
{
	return new iTransform;
}


iTransform::iTransform()
{
}


iTransform::~iTransform()
{
}


//
// transform so that Z-axis becomes this direction 
//
void iTransform::SetDirection(double x, double y, double z)
{
	double dir[3];

	dir[0] = x;
	dir[1] = y;
	dir[2] = z;
	this->SetDirection(dir);
}


void iTransform::SetDirection(const float *fdir)
{
	double dir[3];

	dir[0] = fdir[0];
	dir[1] = fdir[1];
	dir[2] = fdir[2];
	this->SetDirection(dir);
}


void iTransform::SetDirection(const double *dir)
{
	const double base[3] = { 0.0, 0.0, 1.0 };
	double axis[3];

	vtkMath::Cross(base,dir,axis);
	float d = vtkMath::Dot(base,dir)/vtkMath::Norm(dir);
	if(vtkMath::Norm(axis) > 0.0)
	{
		this->RotateWXYZ(vtkMath::DegreesFromRadians(acos(d)),axis);
	}
	else
	{
		if(d < 0.0)
		{
			this->Scale(-1.0,-1.0,-1.0);
		}
	}
}
