//LICENSE A

//
//  A small wrapper around vtkTransform. It only adds one convenience function
//
#ifndef ITRANSFORM_H
#define ITRANSFORM_H


#include <vtkTransform.h>


class iTransform : public vtkTransform
{

public:

	vtkTypeMacro(iTransform,vtkTransform);
	static iTransform* New();

	//
	//  Transform so that Z-axis becomes this direction 
	//
	void SetDirection(double x, double y, double z);
	void SetDirection(const float *dir);
	void SetDirection(const double *dir);

protected:

	virtual ~iTransform();

private:

	iTransform();
};

#endif // ITRANSFORM_H
 

