//LICENSE A


#include "ivector3D.h"


//
//  3D vector as a type for the Calculator use
//
iVector3D::iVector3D()
{
	int i;
	for(i=0; i<3; i++) mData[i] = 0.0;  //  fastest initialization!!! (faster than memcpy or unrolling the loop)
}


iVector3D::iVector3D(double x, double y, double z)
{
	mData[0] = x;
	mData[1] = y;
	mData[2] = z;
}


iVector3D::iVector3D(const double *pos)
{
	int i;
	if(pos != 0)
	{
		for(i=0; i<3; i++) mData[i] = pos[i];  //  fastest initialization!!! (faster than memcpy or unrolling the loop)
	}
	else
	{
		for(i=0; i<3; i++) mData[i] = 0.0;  //  fastest initialization!!! (faster than memcpy or unrolling the loop)
	}
}


iVector3D::iVector3D(const iVector3D &v)
{
	int i;
	for(i=0; i<3; i++) mData[i] = v.mData[i];  //  fastest initialization!!! (faster than memcpy or unrolling the loop)
}


iVector3D::~iVector3D()
{
}


iVector3D& iVector3D::operator=(const double *pos)
{
	int i;
	if(pos != 0)
	{
		for(i=0; i<3; i++) mData[i] = pos[i];  //  fastest initialization!!! (faster than memcpy or unrolling the loop)
	}
	else
	{
		for(i=0; i<3; i++) mData[i] = 0.0;  //  fastest initialization!!! (faster than memcpy or unrolling the loop)
	}
	return *this;
}


iVector3D& iVector3D::operator=(const iVector3D &v)
{
	int i;
	for(i=0; i<3; i++) mData[i] = v.mData[i];
	return *this;
}


iVector3D& iVector3D::operator+=(const iVector3D &v)
{
	int i;
	for(i=0; i<3; i++) mData[i] += v.mData[i];
	return *this;
}


iVector3D& iVector3D::operator-=(const iVector3D &v)
{
	int i;
	for(i=0; i<3; i++) mData[i] -= v.mData[i];
	return *this;
}


iVector3D operator+(const iVector3D &v1, const iVector3D &v2)
{
	int i;
	iVector3D tmp;
	for(i=0; i<3; i++) tmp.mData[i] = v1.mData[i] + v2.mData[i];
	return tmp;
}


iVector3D operator-(const iVector3D &v1, const iVector3D &v2)
{
	int i;
	iVector3D tmp;
	for(i=0; i<3; i++) tmp.mData[i] = v1.mData[i] - v2.mData[i];
	return tmp;
}


iVector3D operator*(const iVector3D &v, double s)
{
	int i;
	iVector3D tmp;
	for(i=0; i<3; i++) tmp.mData[i] = v.mData[i]*s;
	return tmp;
}

