//LICENSE A


#include "ivectorfieldglyphpipeline.h"


#include "idatalimits.h"
#include "ierror.h"
#include "ireplicatedpolydata.h"
#include "iresampleimagedatafilter.h"
#include "ivectorglyphfilter.h"
#include "ivectorfieldviewsubject.h"

//
//  Templates (needed for some compilers)
//
#include "iarray.tlh"
#include "igenericfilter.tlh"
#include "iviewsubjectpipeline.tlh"


iPipelineKeyDefineMacro(iVectorFieldGlyphPipeline,GlyphBaseSize);


//
// iVectorFieldGlyphPipeline class
//
iVectorFieldGlyphPipeline::iVectorFieldGlyphPipeline(iVectorFieldViewInstance *owner) : iFieldGlyphPipeline(owner)
{
	mOwner = owner;

	//
	//  Do VTK stuff
	//	
	mGlyphFilter = this->CreateFilter<iVectorGlyphFilter>();
	mGlyphFilter->SetInputConnection(mResampleFilter->GetOutputPort());

	this->CompletePipeline(mGlyphFilter->GetOutputPort());
	this->UpdateContents();
}


iVectorFieldGlyphPipeline::~iVectorFieldGlyphPipeline()
{
}


void iVectorFieldGlyphPipeline::SetGlyphFilterInput(vtkDataSet *input)
{
	if(mGlyphFilter->InputData() != input)
	{
		mGlyphFilter->SetInputData(input);
	}
}


void iVectorFieldGlyphPipeline::SetGlyphFilterScale(double s)
{
	mGlyphFilter->SetScaleFactor(s);
}



void iVectorFieldGlyphPipeline::UpdateGlyphBaseSize()
{
	mGlyphFilter->SetIncludeVerts(mOwner->GetGlyphBaseSize() > 1);
	this->Modified();
}



