//LICENSE A


#ifndef IVECTORFIELDSTREAMLINEPIPELINE_H
#define IVECTORFIELDSTREAMLINEPIPELINE_H


#include "ireplicatedviewsubjectpipeline.h"


class iLineToBandFilter;
class iLineToTubeFilter;
class iStreamLineFilter;
class iVectorFieldViewInstance;


class iVectorFieldStreamLinePipeline : public iReplicatedViewSubjectPipeline
{

	friend class iVectorFieldViewInstance;

public:
	
	vtkTypeMacro(iVectorFieldStreamLinePipeline,iReplicatedViewSubjectPipeline);

	iPipelineKeyDeclareMacro(iVectorFieldStreamLinePipeline,Pipeline);
	iPipelineKeyDeclareMacro(iVectorFieldStreamLinePipeline,LineLength);
	iPipelineKeyDeclareMacro(iVectorFieldStreamLinePipeline,LineDirection);
	iPipelineKeyDeclareMacro(iVectorFieldStreamLinePipeline,LineQuality);
	iPipelineKeyDeclareMacro(iVectorFieldStreamLinePipeline,TubeSize);
	iPipelineKeyDeclareMacro(iVectorFieldStreamLinePipeline,TubeRangeFactor);
	iPipelineKeyDeclareMacro(iVectorFieldStreamLinePipeline,TubeVariationFactor);

protected:
	
	iVectorFieldStreamLinePipeline(iVectorFieldViewInstance *owner);
	virtual ~iVectorFieldStreamLinePipeline();

	virtual bool PrepareInput();

	iVectorFieldViewInstance *mOwner;
	double mCurSpacing;

	//
	//  VTK stuff
	//
	iStreamLineFilter *mLine;
	iLineToTubeFilter *mTubeFilter;
	iLineToBandFilter *mBandFilter;
};

#endif // IVECTORFIELDSTREAMLINEPIPELINE_H

