//LICENSE A

//
//  Class for displaying vector (3D) text in VTK
//
#ifndef IVECTORTEXTSUBJECT_H
#define IVECTORTEXTSUBJECT_H


#include "itextsubject.h"

class iTransform;

class vtkActor2D;
class vtkPolyDataMapper2D;
class vtkTransformPolyDataFilter;
class vtkVectorText;


class iVectorTextSubject : public iTextSubject
{
	
public:
	
	static iVectorTextSubject* New(iTextActor *parent, iRenderTool *rv);
	
protected:

	virtual ~iVectorTextSubject();

	virtual void ComputeSize(vtkViewport *vp, float s[2]);
	virtual void UpdateGeometryBody(vtkViewport *vp, int mag);

private:
	
	iVectorTextSubject(iTextActor *parent, iRenderTool *rv);
	
	void ComputeScaledSize(vtkViewport *vp, float s[2], int mag);

	vtkVectorText *mSource;
	iTransform *mTransform;
	vtkTransformPolyDataFilter *mFilter;
	vtkPolyDataMapper2D *mMapper;
	vtkActor2D *mActor, *mActorShadow;
};

#endif // IVECTORTEXTSUBJECT_H
