//LICENSE A


#include "iviewsubjectobserver.h"


#include "idata.h"
#include "idatareader.h"
#include "ierror.h"
#include "iviewmodule.h"
#include "iviewsubject.h"


using namespace iParameter;


iViewSubjectObserver *iViewSubjectObserver::New(iViewSubject *subject)
{
	IASSERT(subject);
	return new iViewSubjectObserver(subject);
}


iViewSubjectObserver::iViewSubjectObserver(iViewSubject *subject)
{
	mSubject = subject;
}


iViewSubjectObserver::~iViewSubjectObserver()
{
}


const iString& iViewSubjectObserver::GetSubjectName() const
{
	static const iString none("Unknown");
	if(mSubject != 0) return mSubject->LongName(); else return none;
}


const iDataType& iViewSubjectObserver::GetSubjectDataType() const
{
	if(mSubject != 0) return mSubject->GetDataType(); else return iDataType::Null();
}

