//LICENSE A


#ifndef IVIEWSUBJECTOBSERVER_H
#define IVIEWSUBJECTOBSERVER_H


#include <vtkCommand.h>


#include <vtkSetGet.h>

class iDataType;
class iString;
class iViewSubject;

//
//  This observer does not execute anything - it is just a place holder for object info
//
class iViewSubjectObserver : public vtkCommand
{

public:
	
	vtkTypeMacro(iViewSubjectObserver,vtkCommand);
	static iViewSubjectObserver* New(iViewSubject *subject = 0);

	iViewSubject* GetSubject() const { return mSubject; }
	const iString& GetSubjectName() const;
	const iDataType& GetSubjectDataType() const;

protected:

	virtual ~iViewSubjectObserver();

private:

	iViewSubjectObserver(iViewSubject *subject);

	virtual void Execute(vtkObject *, unsigned long, void *){}

	iViewSubject *mSubject;
};


#endif // IVIEWOBJECTOBSERVER_H

