//LICENSE A

//
//  Ifrit data filter: takes StructuredPoints data of type float and converts them into
//  StructuredPoints data of type char using lower and upper bounds.
//

#ifndef IVOLUMEDATACONVERTER_H
#define IVOLUMEDATACONVERTER_H


#include "igenericfilter.h"
#include <vtkImageAlgorithm.h>
#include "iparallelworker.h"


class iVolumeDataConverter : public iGenericImageDataFilter<vtkImageAlgorithm>, protected iParallelWorker
{

	iGenericFilterTypeMacro(iVolumeDataConverter,vtkImageAlgorithm);

public:

	inline int GetCurrentVar() const { return mCurVar; }
	void SetCurrentVar(int n);
	
protected:
	
	virtual void ProvideOutput();
	virtual int ExecuteStep(int step, iParallel::ProcessorInfo &p);

	virtual void OnLimitsChanged(int var, int mode);

private:

	int mCurVar;

	//
	//  Work variables
	//
	int wStretch, wNumComp;
	float *wInPtr, wFoffset, wFscale;
	unsigned char *wOutPtr;
	vtkIdType wSize;
};

#endif


