//LICENSE A


#include "ivtktype.h"


#include "ivtk.h"

#include <vtkImageData.h>
#include <vtkPointData.h>
#include <vtkPolyData.h>


namespace ivtkType
{
	template<> const char* Name<vtkDataSet>()
	{
		return "vtkDataSet";
	}

	template<> const char* Name<vtkImageData>()
	{
		return "vtkImageData";
	}

	template<> const char* Name<vtkPolyData>()
	{
		return "vtkPolyData";
	}


	bool IsThereScalarData(vtkDataSet *d)
	{
		return (d!=0 && d->GetPointData()!=0 && d->GetPointData()->GetScalars()!=0 &&
			d->GetPointData()->GetScalars()->GetSize()>0 &&
			d->GetPointData()->GetScalars()->GetDataType()==VTK_FLOAT);
	}


	bool IsThereVectorData(vtkDataSet *d)
	{
		return (d!=0 && d->GetPointData()!=0 && d->GetPointData()->GetVectors()!=0 &&
			d->GetPointData()->GetVectors()->GetSize()>0 &&
			d->GetPointData()->GetVectors()->GetDataType()==VTK_FLOAT &&
			d->GetPointData()->GetVectors()->GetNumberOfComponents()==3);
	}


	bool IsThereTensorData(vtkDataSet *d)
	{
		return (d!=0 && d->GetPointData()!=0 && d->GetPointData()->GetTensors()!=0 &&
			d->GetPointData()->GetTensors()->GetSize()>0 &&
			d->GetPointData()->GetTensors()->GetDataType()==VTK_FLOAT &&
			d->GetPointData()->GetTensors()->GetNumberOfComponents()==9);
	}
};

