//LICENSE A


#ifndef IPYOBJECT_H
#define IPYOBJECT_H


#include <Python.h>

#include "iarray.h"
#include "istring.h"


class iObject;
class iShell;


class ipyTypeObject
{

public:

	static ipyTypeObject* GetTypeObject(iObject *target, PyObject *module);

	inline PyTypeObject* PythonType() const { return mType; }

private:

	ipyTypeObject(iObject *target, PyObject *module, const iString &name);
	~ipyTypeObject();

	char* UseName(const iString& name);
	char* UseString(const iString& str);

	iString mName, mPythonName;
	PyTypeObject *mType;
	PyGetSetDef *mVariables;
	PyMethodDef *mFunctions; 
	PyMemberDef *mChildren;

	iLookupArray<iString> mNameCache;
	iLookupArray<iString> mStringCache;

	static iArray<ipyTypeObject*> mRegisteredTypes;
};


class ipyObject
{

public:

	static PyObject* New(iObject *target, PyObject *module);
};

#endif // IPYOBJECT_H
