//LICENSE A

//
//  Toolkit-independent base for a main window subject class.
//

#ifndef IBGMAINWINDOWSUBJECT_H
#define IBGMAINWINDOWSUBJECT_H


#include "ibgelement.h"


class iString;

class iggDialog;
class iggFrame;
class iggFrameTopParent;
class iggMainWindow;
class iggRenderWindow;

class ibgWidgetProgressBarSubject;


class ibgMainWindowSubject : public ibgElement
{

	friend class iggMainWindow;

public:

	virtual void AttachRenderWindow(iggRenderWindow *rw) = 0;

protected:

	ibgMainWindowSubject(iggMainWindow *owner);
	virtual ~ibgMainWindowSubject();

	//
	//  General members
	//
	virtual void ShowToolTips(bool s) = 0;
	virtual void SetTheme(const iString &name) = 0;
	virtual void StartTimer() = 0;

	//
	//  Construction helpers
	//
	virtual void SetTopParentSubjects(iggFrameTopParent *busyIndicatorFrame, iggFrameTopParent *visitedFileListFrame) = 0;
	virtual void PopulateStatusBar(iggFrame *busyIndicatorFrame, ibgWidgetProgressBarSubject *progressBarSubject, iggFrame *visitedFileListFrame) = 0;

	//
	//  Docking helpers
	//
	virtual void PlaceWindowsInDockedPositions() = 0;
	virtual void RestoreWindowsFromDockedPositions() = 0;
	
	//
	//  Helper variables
	//
	iggMainWindow *mMainWindow;
};

#endif  // IBGMAINWINDOWSUBJECT_H

