//LICENSE A

//
//  Toolkit-independent base for a subject window class that has menus and toolbars
//

#ifndef IBGMENUWINDOWSUBJECT_H
#define IBGMENUWINDOWSUBJECT_H


#include "ibgwindowsubject.h"


#include "imath.h"

class iggFrameTopParent;
class iggMenuHelperBase;
class iggMenuWindow;


class ibgMenuWindowSubject : public ibgWindowSubject
{

	friend class iggMenuWindow;

public:

	//
	//  Menu interaction (public to allow extensions to modify the menu)
	//
	virtual void BeginMenu(const iString &text, bool exclusive) = 0;
	virtual void EndMenu() = 0;
	virtual void AddMenuItem(int id, const iString &text, const iImage *icon, const iString &accel, bool toggle, bool on, const iggMenuHelperBase *enabler = 0, const iggMenuHelperBase *checker = 0) = 0;
	virtual void AddMenuSeparator() = 0;
	virtual void AddToolBarButton(int id, const iString &tooltip, const iImage *icon, bool toggle, const iggMenuHelperBase *enabler = 0, const iggMenuHelperBase *checker = 0) = 0;
	virtual void AddToolBarSeparator() = 0;
	virtual void CompleteMenu() = 0;

	virtual void SetToolBarIcon(int id, const iImage &icon) = 0;
	virtual void UpdateMenus() = 0;

	virtual void SetGlobalFrame(iggFrameTopParent *globalFrame, int cols) = 0;

	virtual iString GetFileName(const iString &header, const iString &file, const iString &selection, bool reading) = 0;

protected:

	ibgMenuWindowSubject(iggMenuWindow *owner, const iImage *icon, const iString &title);
	virtual ~ibgMenuWindowSubject();
	
	iggMenuWindow *mOwner;

private:

	ibgMenuWindowSubject(const ibgMenuWindowSubject&); // Not implemented.
	void operator=(const ibgMenuWindowSubject&);  // Not implemented.
};

#endif  // IBGMENUWINDOWSUBJECT_H

