//LICENSE A


//
//  A GUI toolkit-independent base shell subject
//

#ifndef IBGSHELLSUBJECT_H
#define IBGSHELLSUBJECT_H


#include "ibgelement.h"


#include "istring.h"

class iggShell;

class ibgWindowSubject;


class ibgShellSubject : public ibgElement
{

	friend class iggShell;

protected:

	ibgShellSubject(iggShell *owner);
	virtual ~ibgShellSubject();

	//
	//  System-level operations
	//
	virtual void GetDesktopDimensions(int &w, int &h) const = 0;
	virtual void ProcessEvents(bool sync) = 0;
	virtual void CompleteStartUp() = 0;
	virtual void EnterEventLoop() = 0;
	virtual void Exit() = 0;

	//
	//  User notification
	//
	virtual int PopupWindow(ibgWindowSubject *parent, const iString &text, int type, const char *button0, const char *button1, const char *button2) const = 0;

	iggShell *mOwner;
};

#endif  // IBGSHELLSUBJECT_H

