//LICENSE A

//
//  A combination of a slider with an LCD and/or line edit 
//
#ifndef IBGWIDGETENTRYSUBJECT_H
#define IBGWIDGETENTRYSUBJECT_H


#include "ibgwidgetsubject.h"


#include <vtkType.h>

class iString;

class iggWidget;
class ibgWidgetButtonSubject;


class ibgWidgetEntrySubject : public ibgWidgetSubject
{

public:

	ibgWidgetEntrySubject(iggWidget *owner, bool slider, int numdig, const iString &label);
	virtual ~ibgWidgetEntrySubject();

	virtual void FreezeNumberOfDigits(bool s);
	void IncrementNumDigits(int n){ if(mNumDigits>0 && mNumDigits+n>0) mNumDigits += n; }

	virtual void AddButton(ibgWidgetButtonSubject* button) = 0;
	virtual void SetEditable(bool s) = 0;

	//
	//  Decorator functions
	//
	virtual int GetValue() const = 0;
	virtual void GetRange(int &min, int &max) const = 0;
	virtual const iString GetText() const = 0;

	virtual void SetValue(int v) = 0;
	virtual void SetValue(int v, double dv) = 0;
	virtual void SetValue(int v, vtkIdType lv) = 0;
	virtual void SetNumberOfTicks(int n) = 0;
	virtual void SetRange(int smin, int smax, int pagestep = 0) = 0;
	virtual void SetText(const iString &text) = 0;
	virtual void SelectText(int start, int len = -1) = 0;

	virtual void ShowTail() = 0;

	virtual void SetStretch(int label, int slider, int number = 0) = 0;

protected:

	int mNumDigits;
	bool mNumDigitsFrozen;
};

#endif  // IBGWIDGETENTRYSUBJECT_H

