//LICENSE A


#include "iconfigure.h"
#if ISHELL_INCLUDED(ISHELL_GG)


#include "ibgwidgethelper.h"


#include "ierror.h"
#include "ihelpfactory.h"

#include "iggdialoghelp.h"
#include "iggmainwindow.h"
#include "iggwidget.h"


//
//  Main class
//
ibgWidgetHelper::ibgWidgetHelper(iggWidget *owner)
{
	IASSERT(owner);

	mOwner = owner;
}


ibgWidgetHelper::~ibgWidgetHelper()
{
}


void ibgWidgetHelper::OpenHelpPage(const iString &tag)
{
	mOwner->GetMainWindow()->GetDialogHelp()->Open(tag.ToCharPointer());
}


//
//  Generic slots
//
void ibgWidgetHelper::OnInt1Body(int v)
{
	mOwner->OnInt1Body(v);
	mOwner->UpdateDependents();
}


void ibgWidgetHelper::OnInt2Body(int v)
{
	mOwner->OnInt2Body(v);
	mOwner->UpdateDependents();
}


void ibgWidgetHelper::OnVoid1Body()
{
	mOwner->OnVoid1Body();
	mOwner->UpdateDependents();
}


void ibgWidgetHelper::OnVoid2Body()
{
	mOwner->OnVoid2Body();
	mOwner->UpdateDependents();
}


void ibgWidgetHelper::OnVoid3Body()
{
	mOwner->OnVoid3Body();
	mOwner->UpdateDependents();
}


void ibgWidgetHelper::OnBool1Body(bool v)
{
	mOwner->OnBool1Body(v);
	mOwner->UpdateDependents();
}

#endif
