//LICENSE A

//
//  A base class for widget helpers - classes that provide toolkit-dependent functionality and callbacks
//

#ifndef IBGWIDGETHELPER_H
#define IBGWIDGETHELPER_H


#include "ibgelement.h"


class iColor;
class iString;

class iggWidget;


class ibgWidgetHelper : public ibgElement
{

public:

	virtual ~ibgWidgetHelper();

	virtual void SetBaloonHelp(const iString &tooltip, const iString &whatsthis) = 0;
	virtual bool SupportsHTMLHelp() const = 0;
	virtual bool HasBaloonHelp() const = 0;

	virtual void Show(bool s) = 0;
	virtual bool IsVisible() const = 0;

	virtual void Enable(bool s) = 0;
	virtual bool IsEnabled() const = 0;

	virtual void SetBackgroundColor(const iColor &c) = 0;
	virtual void UnSetBackgroundColor() = 0;

	void OpenHelpPage(const iString &tag);

protected:

	ibgWidgetHelper(iggWidget *owner);

	//
	//  Generic slots
	//
	void OnInt1Body(int);
	void OnInt2Body(int);
	void OnVoid1Body();
	void OnVoid2Body();
	void OnVoid3Body();
	void OnBool1Body(bool);

	iggWidget *mOwner;
};

#endif  // IBGWIDGETHELPER_H

