//LICENSE A


#include "iconfigure.h"
#if ISHELL_INCLUDED(ISHELL_GG)


#include "ibgwindowhelper.h"


#include "ibgframesubject.h"


int ibgWindowHelper::mFontOffset = 0; // default value


ibgWindowHelper::ibgWindowHelper(const iImage *icon, const iString &title, bool disableClose) : mIcon(icon), mTitle(title), mDisableClose(disableClose)
{
	mSavedGeometry[0] = mSavedGeometry[1] = 100;
	mSavedGeometry[2] = mSavedGeometry[3] = 0;
}


//
//  Save and restore geometries for docking
//
void ibgWindowHelper::SaveWindowGeometry()
{
	this->GetWindowGeometry(mSavedGeometry,true);
}


void ibgWindowHelper::RestoreWindowGeometry()
{
	this->SetWindowGeometry(mSavedGeometry,true);
}


void ibgWindowHelper::ChangeFontSize(int s)
{
	if(s>-10 && s<10)
	{
		mFontOffset = s;
		if(s < 0)
		{
			ibgFrameSubject::mPaddingWidth = 2;
		}
		else
		{
			ibgFrameSubject::mPaddingWidth = 4;
		}
	}
}

#endif
