//LICENSE A


#include "iconfigure.h"
#if ISHELL_INCLUDED(ISHELL_GG)


#include "ibgwindowsubject.h"


#include "ierror.h"

#include "iggshell.h"

#include "ibgwindowhelper.h"


bool ibgWindowSubject::mIsBlocked = false;


ibgWindowSubject::ibgWindowSubject(iggShell *shell) : mShell(shell)
{
	mWindowHelper = 0;
	mIsBeingDeleted = false;
}


ibgWindowSubject::~ibgWindowSubject()
{
	IASSERT(mWindowHelper);
	delete mWindowHelper;
}


void ibgWindowSubject::Delete()
{
	mIsBeingDeleted = true;
	delete this;
}


void ibgWindowSubject::SetWindowGeometry(int wg[4], bool force)
{
	IASSERT(mWindowHelper);
	mWindowHelper->SetWindowGeometry(wg,force);
}


void ibgWindowSubject::GetWindowGeometry(int wg[4], bool force) const
{
	IASSERT(mWindowHelper);
	mWindowHelper->GetWindowGeometry(wg,force);
}


void ibgWindowSubject::GetFrameSize(int &w, int &h) const
{
	IASSERT(mWindowHelper);
	mWindowHelper->GetFrameSize(w,h);
}


void ibgWindowSubject::Show(bool s)
{
	IASSERT(mWindowHelper);
	mWindowHelper->Show(s);
}


bool ibgWindowSubject::IsVisible() const
{
	IASSERT(mWindowHelper);
	return mWindowHelper->IsVisible();
}


void ibgWindowSubject::Block(bool s)
{
	mIsBlocked = s;
}


bool ibgWindowSubject::IsBlocked() const
{
	return mIsBlocked || mIsBeingDeleted;
}

#endif
