//LICENSE A

//
//  Toolkit-independent subject for window subjects
//

#ifndef IBGWINDOWSUBJECT_H
#define IBGWINDOWSUBJECT_H


#include "ibgelement.h"


#include "ipointermacro.h"

class iImage;
class iString;

class iggShell;

class ibgWindowHelper;


class ibgWindowSubject : public ibgElement
{

public:

	void Delete();
	
	virtual void SetWindowGeometry(int wg[4], bool force = false);
	virtual void GetWindowGeometry(int wg[4], bool force = false) const;

	virtual void GetFrameSize(int &w, int &h) const;

	virtual void Show(bool s);
	virtual bool IsVisible() const;

	inline ibgWindowHelper* GetHelper() const { return mWindowHelper; }

	static void Block(bool s);

	inline iggShell* GetShell() const { return mShell; }

protected:

	ibgWindowSubject(iggShell *shell);
	virtual ~ibgWindowSubject();

	virtual bool IsBlocked() const;

	ibgWindowHelper *mWindowHelper;

private:

	iggShell *mShell;

	bool mIsBeingDeleted;
	static bool mIsBlocked;
};

#endif  // IBGWINDOWSUBJECT_H

