//LICENSE A


#ifndef ICLSHELL_H
#define ICLSHELL_H

//
//  A shell based on command line interface
//
#include "ishell.h"


class vtkRenderWindowInteractor;
class vtkTimerLog;


class iclShell : public iShell
{

	friend class iShell;

public:

	vtkTypeMacro(iclShell,iShell);

	iObjectPropertyMacro1S(Trace,Bool);

	//
	//  Factory methods
	//
	virtual vtkRenderWindow* CreateRenderWindow(iViewModule *vm, bool stereo) const;
	virtual vtkRenderWindowInteractor* CreateRenderWindowInteractor(iViewModule *vm) const;
	virtual iEventObserver* CreateViewModuleEventObserver(iParameter::ViewModuleObserver::Type type, iViewModule *vm) const;

	virtual bool IsInterrupted() const;

protected:

	iclShell(iRunner *runner, bool threaded, const iString &type, int argc, const char **argv);
	virtual ~iclShell();

	virtual void DisplayPrompt() const;
	virtual void OnInterrupt();

	virtual bool ConstructorBody();  
	virtual void DestructorBody();  
	virtual void StartBody();
	virtual void StopBody();

	virtual void OnLoadStateAtomBody(int prog);

	virtual iDataReaderObserver* CreateDataReaderObserver();
	virtual iEventObserver* CreateShellEventObserver(iParameter::ShellObserver::Type type);
	virtual iOutputChannel* CreateOutputChannel();

	int mTimerId;
	vtkRenderWindowInteractor *mDriver;

	int wCount;
};

#endif  // ICLSHELL_H
