//LICENSE A

//
//  Command line implementation of shell observers
//

#ifndef ICLSHELLEVENTOBSERVERS_H
#define ICLSHELLEVENTOBSERVERS_H


#include "ishelleventobservers.h"


class iPicker;


class iclExecutionEventObserver : public iExecutionEventObserver
{
	
	friend class iclShell;

protected:

	iclExecutionEventObserver(iShell *s);
	virtual ~iclExecutionEventObserver();

	virtual void OnStart();
	virtual void OnFinish();
	virtual void OnProgress(double fraction, bool &abort);
	virtual void OnSetLabel(const iString &label);

	iString mLabel;
};


class iclParallelUpdateEventObserver : public iParallelUpdateEventObserver
{
	
	friend class iclShell;

public:
	
	virtual void UpdateInformation();

protected:

	iclParallelUpdateEventObserver(iShell *s) : iParallelUpdateEventObserver(s){}
};

#endif // ICLSHELLEVENTOBSERVERS_H

