//LICENSE A

//
//  A static class that provides access to pre-loaded images
//

#ifndef IGGIMAGEFACTORY_H
#define IGGIMAGEFACTORY_H


#include "iarray.h"
#include "istring.h"

class iImage;


class iggImageFactoryHelper
{

public:

	iggImageFactoryHelper();
	~iggImageFactoryHelper();

	const iImage* FindImage(const iString &name);

private:

	struct Item
	{
		iImage* Image;
		iString Name;
		Item(){ Image = 0; }
	};

	iArray<Item> mItems;
};


class iggImageFactory
{
	
public:

	struct ByteData
	{
		int Depth;
		int Width;
		int Height;
		const char* Name;
		unsigned int* Data;  // we keep data in ints as the most efficient form
	};

	static const iImage* FindIcon(const iString &name);
	static const iImage* FindHelpChart(const iString &name);

private:

	static bool mInitialized;
	static iggImageFactoryHelper mHelper;
};

#endif // IGGIMAGEFACTORY_H

