//LICENSE A


#include "iconfigure.h"
#if ISHELL_INCLUDED(ISHELL_GG)


#include "iggdatareaderobserver.h"


#include "ierror.h"

#include "iggdialogloadfile.h"
#include "igghandle.h"
#include "iggmainwindow.h"
#include "iggshell.h"

#include "ibgmenuwindowsubject.h"


using namespace iParameter;


//
//  iggDataReaderObserver class
//
iggDataReaderObserver::iggDataReaderObserver(iggShell *s) : iDataReaderObserver(s)
{
	mMainWindow = 0;
	mDoNotOfferToReload = mStarted = false;
	mShell = s; IASSERT(s);
}


bool iggDataReaderObserver::AllowReload()
{
	if(mMainWindow == 0)
	{
		mMainWindow = mShell->GetMainWindow();
	}

	if(mMainWindow != 0)
	{
		if(!mDoNotOfferToReload)
		{
			int ret = iRequiredCast<iggShell>(INFO,this->GetShell())->PopupWindow("This control only takes effect when the data set is reloaded.",MessageType::Information,"Reload now","Later","Do not ask again");
			if(ret == 2) mDoNotOfferToReload = true;
			return (ret == 0);
		}
	}

	return false;
}


void iggDataReaderObserver::OnSetStart()
{
	if(mMainWindow == 0)
	{
		mMainWindow = mShell->GetMainWindow();
	}

	IASSERT(mMainWindow);

	mInfo.Clear();

	if(mMainWindow->GetSubject()->IsVisible())
	{
		mMainWindow->GetDialogLoadFile()->Start();
		mStarted = true; // just in case the MainWindow visibilty changes while we are loading file
	}
}


void iggDataReaderObserver::OnFileStart(const iString &fname, const iDataType &type)
{
	IASSERT(mMainWindow);

	if(mStarted)
	{
		mMainWindow->GetDialogLoadFile()->OnFileStart(fname,type);
	}
}


void iggDataReaderObserver::OnFileFinish(const iString &fname, const iDataInfo &info)
{
	IASSERT(mMainWindow);

	if(mStarted)
	{
		mMainWindow->GetDialogLoadFile()->OnFileFinish(fname,info);
	}

	mInfo += info;
}


void iggDataReaderObserver::OnSetFinish(bool error)
{
	IASSERT(mMainWindow);

	if(mStarted)
	{
		mStarted = false;
		mMainWindow->GetDialogLoadFile()->Finish();
	}

	if(!error)
	{
		iggDataTypeHandle::AfterFileLoad(mInfo);
	}
}

#endif
