//LICENSE A

//
//  Generic implementation of DataReader observers
//

#ifndef IGGDATAREADEROBSERVERS_H
#define IGGDATAREADEROBSERVERS_H


#include "idatareaderobserver.h"


#include "idata.h"

class iggMainWindow;
class iggShell;


class iggDataReaderObserver : public iDataReaderObserver
{
	
	friend class iggShell;

public:
	
	virtual bool AllowReload();

protected:

	iggDataReaderObserver(iggShell *s);

	virtual void OnSetStart();
	virtual void OnSetFinish(bool error);
	virtual void OnFileStart(const iString &fname, const iDataType &type);
	virtual void OnFileFinish(const iString &fname, const iDataInfo &info);

	iggMainWindow *mMainWindow;
	bool mDoNotOfferToReload, mStarted;
	iDataInfo mInfo;
	iggShell *mShell;
};

#endif // IGGDATAREADEROBSERVERS_H

