//LICENSE A


#ifndef IGGDIALOGIMAGECOMPOSER_H
#define IGGDIALOGIMAGECOMPOSER_H


#include "iggdialog.h"


class iImageComposer;

class iggFrame;
class iggIndexHandle;
class iggObjectHandle;
class iggWidget;
class iggWidgetInteractiveDrawArea;
class iggWidgetPropertyControlBase;


class iggDialogImageComposer : public iggDialog
{

public:

	iggDialogImageComposer(iggMainWindow *parent);
	virtual ~iggDialogImageComposer();

	void SetActiveBackgroundWindow(int w);
	inline int GetActiveBackgroundWindow() const { return mActiveBackgroundWindow; }
	inline const iggIndexHandle* GetBackgroundWindowHandle() const { mBackgroundWindowHandle; }

	void SetActiveForegroundWindow(int w);
	inline int GetActiveForegroundWindow() const { return mActiveForegroundWindow; }
	inline const iggIndexHandle* GetForegroundWindowHandle() const { mForegroundWindowHandle; }

	iImageComposer* GetImageComposer() const;

	void UpdateView();
	iggWidget* GetArea();

protected:

	virtual void CompleteConstructionBody();

	int mActiveBackgroundWindow, mActiveForegroundWindow;
	iggWidget *mArea, *mLabel, *mBackgroundWindowsList;
	iggIndexHandle *mBackgroundWindowHandle, *mForegroundWindowHandle;
	iggObjectHandle *mSelfHandle;
	iggFrame *mZoomFrame;
};

#endif  //  IGGDIALOGIMAGECOMPOSER_H
