//LICENSE A

//
//  A base class for all generic (toolkit-independent) GUI elements.
//  This is really a dummy to unite all gg... classes into a single hierarchy.
//

#ifndef IGGELEMENT_H
#define IGGELEMENT_H


#include "ishellcomponent.h"


class iggShell;


namespace iParameter
{
	namespace MouseButton
	{
		//
		//  Mouse interaction buttons
		//
		const int NoButton = 0;
		const int LeftButton = 1;
		const int MiddleButton = 2;
		const int RightButton = 4;
		const int AnyButton = 7;
		const int ControlKey = 8;
		const int ShiftKey = 16;
	};

	namespace Condition
	{
		//
		//  Running conditions
		//
		const int OldWindowManager =				1;
		const int SmallDesktopSize =				2;
		const int SlowRemoteConnection =			4;
		const int DisableDelayedInitialization =	8;
	};

};


class iggElement : public iShellComponent
{

public:

	virtual ~iggElement();

	int GetId() const { return mId; }

	inline iggShell* GetShell() const { return mTrueShell; } // to avoid extra casting

protected:

	iggElement(iggShell *shell);

private:

	int mId;
	static int mIdCounter;

	iggShell *mTrueShell;

	iggElement(const iggElement&);		// Not implemented.
	void operator=(const iggElement&);	// Not implemented.
};

#endif  // IGGELEMENT_H

