//LICENSE A

//
//  A frame with a ComboBox listing available DataTypes
//

#ifndef IGGFRAMEDATATYPESELECTOR_H
#define IGGFRAMEDATATYPESELECTOR_H


#include "iggframe.h"


class iDataInfo;
class iDataType;

class iggDataTypeHandle;


namespace iParameter
{
	//
	//  DataTypeSelector modes
	//
	namespace ListDataTypes
	{
		const int All =				0;
		const int WithData =		1;
		const int WithVariables =	2;
	};
};


class iggFrameDataTypeSelector : public iggFrame
{

public:

	iggFrameDataTypeSelector(iggDataTypeHandle *handle, const iString &title, iggFrameBase *parent, int mode = iParameter::ListDataTypes::All);
	virtual ~iggFrameDataTypeSelector();

	inline int GetMode() const { return mMode; }
	void SetMode(int m);

	const iDataInfo& GetListedInfo() const;
	iggDataTypeHandle* GetHandle() const { return mHandle; }

protected:

	virtual void UpdateWidgetBody();

	int mMode;
	bool mAutoPilot;
	iggFrame *mBase;
	iggDataTypeHandle *mHandle;
	mutable iDataInfo *mListedInfo;
};

#endif  // IGGFRAMEDATACHANNEL_H

