//LICENSE A


#include "iconfigure.h"
#if ISHELL_INCLUDED(ISHELL_GG)


#include "iggframedatatypewidgetlist.h"


#include "idata.h"
#include "idatareader.h"
#include "idatasubject.h"
#include "ishell.h"
#include "iviewmodule.h"

#include "iggwidget.h"
#include "iggwidgetarea.h"

//
//  Templates
//
#include "iarray.tlh"


iggFrameDataTypeWidgetList::iggFrameDataTypeWidgetList(const iString &title, iggFrame *parent) : iggFrame(title,parent)
{
	mBox = new iggFrameScroll(this);
	this->AddLine(mBox);
}


iggFrame* iggFrameDataTypeWidgetList::EntryParent() const
{
	return mBox->GetContents();
}


void iggFrameDataTypeWidgetList::UpdateList()
{
	int i;

	//
	//  This is expensive to update, make sure it does not update needlessly
	//
	if(!mNeedsUpdate) return;

	//
	//  This frame assumes that all readers have the same set of included DataType(s)
	//
	const iDataInfo &all(iDataInfo::Any());
	for(i=mEntries.Size(); i<all.Size(); i++)
	{
		mEntries.Add(this->CreateEntry(all.Type(i)));
		mBox->GetContents()->AddLine(mEntries.Last());
	}
}


void iggFrameDataTypeWidgetList::UpdateChildren()
{
	this->UpdateList();
	iggFrame::UpdateChildren();
}

#endif
