//LICENSE A

//
//  A frame that contains a list identical widgets - one for each existing DataType
//  (including those from the Extension). This class is abstract - a child should 
//  overwrite the factory method to create one widget.
//

#ifndef IGGFRAMEDATATYPEWIDGETLIST_H
#define IGGFRAMEDATATYPEWIDGETLIST_H


#include "iggframe.h"


#include "iarray.h"

class iDataType;

class iggWidget;


class iggFrameDataTypeWidgetList : public iggFrame
{

protected:

	iggFrameDataTypeWidgetList(const iString &title, iggFrame *parent);

	virtual void UpdateChildren();

	void UpdateList();
	iggFrame* EntryParent() const;

	//
	//  Factory method
	//
	virtual iggWidget* CreateEntry(const iDataType &type) const = 0;

	iggFrameScroll *mBox;
	iArray<iggWidget*> mEntries;
};

#endif  // IGGFRAMEDATATYPEWIDGETLIST_H

