//LICENSE A

//
//  A frame that controls limits for a single variable
//

#ifndef IGGFRAMEDATAVARIABLELIMITS_H
#define IGGFRAMEDATAVARIABLELIMITS_H


#include "iggframe.h"


class iggIndexHandle;
class iggObjectHandle;
class iggPropertyHandle;


class iggFrameDataVariableLimits : public iggFrame
{

public:

	iggFrameDataVariableLimits(int index, const iggObjectHandle *dsh, iggFrameBase *parent, const iggPropertyHandle* eh = 0, bool narrow = false);
	iggFrameDataVariableLimits(const iggPropertyHandle& ph, const iggObjectHandle *dsh, iggFrameBase *parent, const iggPropertyHandle* eh = 0, bool narrow = false);
	virtual ~iggFrameDataVariableLimits();

protected:

	virtual void UpdateWidgetBody();

	const iggIndexHandle *mIndexHandle;
	const iggObjectHandle *mDataSubjectHandle;
	const iggPropertyHandle *mEnablingHandle;

private:

	void Define(const iggObjectHandle *dsh, const iggPropertyHandle *eh, bool narrow);
};

#endif  // IGGFRAMEDATAVARIABLELIMITS_H

