//LICENSE A

//
//  A decorator for the ComboBox or RadioBox which contains data variables
//

#ifndef IGGFRAMEDATAVARIABLELIST_H
#define IGGFRAMEDATAVARIABLELIST_H


#include "iggframe.h"


class iggDataTypeHandle;
class iggObjectHandle;
class iggPropertyHandle;
class iggWidgetSimpleItemizedSelectionBox;


class iggFrameDataVariableList : public iggFrameFlip
{

public:

	iggFrameDataVariableList(const iString &title, const iggObjectHandle *dsh, iggFrame *parent, const iggPropertyHandle* eh = 0);
	iggFrameDataVariableList(const iString &title, const iggObjectHandle *dsh, const iggPropertyHandle& ph, iggFrame *parent, const iggPropertyHandle* eh = 0);
	iggFrameDataVariableList(const iString &title, const iggDataTypeHandle *dth, const iggPropertyHandle& ph, iggFrame *parent, const iggPropertyHandle* eh = 0);
	virtual ~iggFrameDataVariableList();

	//
	//  Decorator functions
	//
	virtual void InsertItem(const iString &text);
	virtual void Complete();

	int GetIndex() const;

protected:

	void UpdateList();
	virtual void UpdateChildren();

	void Define(const iString &title, const iggObjectHandle *dsh, const iggDataTypeHandle *dth, const iggPropertyHandle *ph, iggFrame *parent, const iggPropertyHandle* eh);

	int mOffset;
	bool mCompleted;
	const iggObjectHandle *mDataSubjectHandle;
	const iggDataTypeHandle *mDataTypeHandle;
	const iggPropertyHandle *mEnablingHandle;
	iggFrame *mLayers[2];
};

#endif  // IGGFRAMEDATAVARIABLELIST_H

