//LICENSE A


#include "iconfigure.h"
#if ISHELL_INCLUDED(ISHELL_GG)


#include "iggframedisplay.h"


#include "icolor.h"

#include "iggwidgetmisc.h"

#include "ibgwidgetareasubject.h"
#include "ibgwidgethelper.h"


using namespace iParameter;


namespace iggFrameNumberDisplay_private
{
	class NumberLabel : public iggWidgetNumberLabel
	{

	public:

		NumberLabel(iggFrame *parent) : iggWidgetNumberLabel(parent)
		{
			mSubject->ShowFrame(true);
			this->GetHelper()->SetBackgroundColor(iColor::IFrIT());
		}
	};

	class TextLabel : public iggWidgetTextLabel
	{

	public:

		TextLabel(iggFrame *parent) : iggWidgetTextLabel("",parent)
		{
			mSubject->ShowFrame(true);
			this->GetHelper()->SetBackgroundColor(iColor::IFrIT());
		}
	};
};


using namespace iggFrameNumberDisplay_private;


//
//  iggFrameNumberDisplay class
//
iggFrameNumberDisplay::iggFrameNumberDisplay(const iString &title, iggFrame *parent) : iggFrame(parent,2)
{
	mDisplay = new NumberLabel(this);

	if(title.IsEmpty())
	{
		this->AddLine(mDisplay,2);
	}
	else
	{
		this->AddLine(new iggWidgetTextLabel(title,this),mDisplay);
	}

	mNeedsBaloonHelp = false;
}


void iggFrameNumberDisplay::Display(double v, const char *format)
{
	mDisplay->SetNumber(v,format);
}


void iggFrameNumberDisplay::Display(int v, const char *format)
{
	mDisplay->SetNumber(v,format);
}


void iggFrameNumberDisplay::SetDisplayColor(const iColor& c)
{
	mDisplay->GetHelper()->SetBackgroundColor(c);
}


void iggFrameNumberDisplay::SetAlignment(int s)
{
	mDisplay->SetAlignment(s);
}


//
//  iggFrameTextDisplay class
//
iggFrameTextDisplay::iggFrameTextDisplay(const iString &title, iggFrame *parent) : iggFrame(parent,2)
{
	mDisplay = new TextLabel(this);

	if(title.IsEmpty())
	{
		this->AddLine(mDisplay,2);
	}
	else
	{
		this->AddLine(new iggWidgetTextLabel(title,this),mDisplay);
	}

	mNeedsBaloonHelp = false;
}


void iggFrameTextDisplay::Display(const iString &text)
{
	mDisplay->SetText("%b"+text);
}


void iggFrameTextDisplay::SetDisplayColor(const iColor& c)
{
	mDisplay->GetHelper()->SetBackgroundColor(c);
}


void iggFrameTextDisplay::SetAlignment(int s)
{
	mDisplay->SetAlignment(s);
}

#endif
