//LICENSE A

//
//  Frames that display text and numbers
//

#ifndef IGGFRAMEDISPLAY_H
#define IGGFRAMEDISPLAY_H


#include "iggframe.h"


class iggWidgetNumberLabel;
class iggWidgetTextLabel;


class iggFrameNumberDisplay : public iggFrame
{

public:

	iggFrameNumberDisplay(const iString &title, iggFrame *parent);

	void Display(double v, const char *format = "%lg");
	void Display(int v, const char *format = "%d");

	void SetDisplayColor(const iColor& c);
	void SetAlignment(int s);

protected:

	iggWidgetNumberLabel *mDisplay;
};


class iggFrameTextDisplay : public iggFrame
{

public:

	iggFrameTextDisplay(const iString &title, iggFrame *parent);

	void Display(const iString &text);

	void SetDisplayColor(const iColor& c);
	void SetAlignment(int s);

protected:

	iggWidgetTextLabel *mDisplay;
};

#endif  //  IGGFRAMEDISPLAY_H
