//LICENSE A


#ifndef IGGFRAMEDOUBLEBUTTON_H
#define IGGFRAMEDOUBLEBUTTON_H


#include "iggframe.h"


#include "ivector3D.h"

class iString;

class iggPropertyHandle;


class iggFrameDoubleButton : public iggFrame
{

public:

	virtual void OnButton1() = 0;
	virtual void OnButton2() = 0;

protected:

	iggFrameDoubleButton(iggFrame *parent, int cols);
	iggFrameDoubleButton(const iString &title, iggFrame *parent, int cols);
};


class iggFrameMoveFocalPointButton : public iggFrameDoubleButton
{

public:

	iggFrameMoveFocalPointButton(iggFrame *parent, bool withmarker = false, bool stretching = false);
	iggFrameMoveFocalPointButton(const iString &title, iggFrame *parent, bool withmarker = false, bool stretching = false);

	virtual iVector3D GetPosition() const = 0;
	virtual int GetWindowNumber() const { return -1; }

	void SetMoveInstantly(bool s);
	inline bool GetMoveInstantly() const { return mMoveInstantly; }

protected:

	virtual void OnButton1();
	virtual void OnButton2();

	bool mMoveInstantly;

private:

	void Define(bool withmarker, bool stretching);
};

#endif  // IGGFRAMEDOUBLEBUTTON_H

