//LICENSE A

//
//  A frame that displays controls for histogram widgets
//

#ifndef IGGFRAMEHISTOGRAMCONTROLS_H
#define IGGFRAMEHISTOGRAMCONTROLS_H


#include "iggframe.h"


#include "icolor.h"

class iHistogram;

class iggWidgetHistogramArea;
class iggWidgetNumberLabel;


class iggFrameHistogramControls : public iggFrame
{

public:

	iggFrameHistogramControls(bool withfull, bool withstretch, iggFrame *parent);

	inline int GetStretchId() const { return mStretchId; }
	void SetStretchId(int s);

	inline bool GetYLogScale() const { return mYLogScale; }
	void SetYLogScale(bool s);

	inline bool GetFullResolution() const { return mFullResolution; }
	void SetFullResolution(bool s);

	void DisplayRange(float min, float max);
	void Attach(iggWidgetHistogramArea *area);
	void UpdateArea();

protected:

	int mStretchId;
	bool mYLogScale, mFullResolution;
	iggWidgetNumberLabel *mDisplayMin, *mDisplayMax;
	iggWidgetHistogramArea *mHistogramArea;
};

#endif  // IGGFRAMEHISTOGRAMCONTROLS_H

