//LICENSE A


#include "iconfigure.h"
#if ISHELL_INCLUDED(ISHELL_GG)


#include "iggframeobjectcontrols.h"


#include "istring.h"
#include "iviewsubject.h"

#include "iggframeposition.h"
#include "iggframepushcontrols.h"
#include "iggwidgetpropertycontrolslider.h"
#include "iggwidgetpropertycontroltrackball.h"
#include "iggwidgetotherbutton.h"


using namespace iParameter;


iggFrameObjectControls::iggFrameObjectControls(const iString &name, const iggPropertyHandle& posph, const iggPropertyHandle& dirph, const iggPropertyHandle& sizph, iggFrame *parent) : iggFrame(parent,2)
{
	this->Define(name,posph,dirph,&sizph,parent);
}


iggFrameObjectControls::iggFrameObjectControls(const iString &name, const iggPropertyHandle& posph, const iggPropertyHandle& dirph, iggFrame *parent) : iggFrame(parent,2)
{
	this->Define(name,posph,dirph,0,parent);
}


void iggFrameObjectControls::Define(const iString &name, const iggPropertyHandle& posph, const iggPropertyHandle& dirph, const iggPropertyHandle* sizph, iggFrame *parent)
{
	iString ws;

	if(name.IsEmpty()) ws = "Position"; else ws = name+" position";
	mOP = new iggFramePosition(ws,posph,this);

	if(name.IsEmpty()) ws = "Direction"; else ws = name+" direction";
	mOD = new iggFrame(ws,this);
	mOD->AddLine(new iggWidgetPropertyControlTrackBall(false,dirph,mOD));
	this->AddLine(mOP,mOD);

	if(sizph != 0)
	{
		if(name.IsEmpty()) ws = "Size"; else ws = name+" size";
		mOS = new iggFrame(ws,this);
		iggWidgetPropertyControlSizeSlider *s = new iggWidgetPropertyControlSizeSlider(1.0e-4,5,"",*sizph,mOS);
		mOS->AddLine(s);
	}
	else
	{
		mOS = 0;
	}

	mPO = new iggFramePushControls(mOP,"Push "+name.Lower(),posph,dirph,this);
	this->AddLine(mOS,mPO);
	this->AddSpace(5);

	this->SetColStretch(0,5);
}


void iggFrameObjectControls::EnablePosition(bool s)
{
	mOP->Enable(s);
}


void iggFrameObjectControls::EnableDirection(bool s)
{
	mOD->Enable(s);
	mPO->Enable(s);
}


void iggFrameObjectControls::EnableSize(bool s)
{
	if(mOS != 0) mOS->Enable(s);
}

#endif
