//LICENSE A


#include "iconfigure.h"
#if ISHELL_INCLUDED(ISHELL_GG)


#include "iggframepaintingcontrols.h"


#include "ierror.h"

#include "iggframedatavariablelimits.h"
#include "iggframedatavariablelist.h"
#include "igghandle.h"


#ifdef I_DEBUG
#include "iggwidgetotherbutton.h"
namespace iggFramePaintingControls_Private
{
	class Toggle: public iggWidgetSimpleButton
	{

	public:

		Toggle(iggFrameDataVariableList *owner, iggFrame *parent) : iggWidgetSimpleButton("",parent,true)
		{
			mOwner = owner;
		}

	protected:

		virtual void Execute()
		{
			mOwner->ShowLayer((1+mOwner->GetActiveLayer())%2);
		}

		iggFrameDataVariableList *mOwner;
	};
};

using namespace iggFramePaintingControls_Private;
#endif

iggFramePaintingControls::iggFramePaintingControls(const iString &title, bool withnone, const iggObjectHandle *dsh, const iggPropertyHandle& ph, iggFrame *parent, const iggPropertyHandle* eh) : iggFrame(parent,2)
{
	IASSERT(dsh);

	iggFrameDataVariableList *list = new iggFrameDataVariableList(title,dsh,ph,this,eh);
	if(withnone) list->InsertItem("None");
	list->Complete();

	iggFrameDataVariableLimits *lims = new iggFrameDataVariableLimits(ph,dsh,this,eh,true);
	list->AddDependent(lims);
	this->AddLine(list,lims);
#ifdef I_DEBUG
	//this->AddLine(new Toggle(list,this));
#endif
	lims->Show(false);

	this->SetColStretch(0,0);
	this->SetColStretch(1,10);
}

#endif
