//LICENSE A

//
//  A frame with palette control. This class is abstract to allow for
//  various ways to specify the palette.
//

#ifndef IGGFRAMEPALETTESELECTIONBASE_H
#define IGGFRAMEPALETTESELECTIONBASE_H


#include "iggframe.h"


#include "iarray.h"

class iPalette;

class iggWidget;


class iggFramePaletteViewFrame : public iggFrame
{

public:

	iggFramePaletteViewFrame(const iString &title, iggFrame *parent);

	virtual iPalette* GetActivePalette() const = 0;

protected:

	iggWidget *mPaletteView;
};


class iggFramePaletteSelectionBase : public iggFramePaletteViewFrame
{

public:

	iggFramePaletteSelectionBase(bool witheditor, bool withbrightness, bool withreverse, iggFrame *parent);
	virtual ~iggFramePaletteSelectionBase();

	virtual iPalette* GetActivePalette() const;

	void SetReversedPalette(bool s);
	bool GetReversedPalette() const;

	void SetBrightnessPalette(bool s);
	bool GetBrightnessPalette() const;

	void SetActivePaletteIndex(int n);
	int GetActivePaletteIndex() const;

	static void UpdateAll();

protected:

	virtual int GetPaletteId() const = 0;
	virtual void SetPaletteId(int n) = 0;

	int mOldPaletteId;
	const bool mWithBrightness;

	static iLookupArray<iggFramePaletteSelectionBase*>& List();
};

#endif  // IGGFRAMEPALETTESELECTIONBASE_H

