//LICENSE A


#include "iconfigure.h"
#if ISHELL_INCLUDED(ISHELL_GG)


#include "iggframereplicate.h"


#include "idatalimits.h"
#include "idatasubject.h"
#include "ierror.h"
#include "iviewsubject.h"
#include "ishell.h"

#include "igghandle.h"
#include "iggwidgetmisc.h"
#include "iggwidgetpropertycontrolselectionbox.h"


iggFrameReplicate::iggFrameReplicate(const iggObjectHandle *oh, iggFrame *parent) : iggFrame("Periodic extensions",parent,2), mObjectHandle(oh)
{
	iggWidgetPropertyControlSpinBox *box1, *box2;

	iggFrame *tmp = new iggFrame(this,2);
	tmp->AddLine(new iggWidgetTextLabel("       Down",tmp),new iggWidgetTextLabel("Up",tmp));
	this->AddLine(tmp);

	mDirs[0] = new iggFrame(this,3);
	box1 = new iggWidgetPropertyControlSpinBox(0,2,"",0,iggPropertyHandle("ReplicationFactors",oh,0),mDirs[0]);
	box2 = new iggWidgetPropertyControlSpinBox(0,2,"",0,iggPropertyHandle("ReplicationFactors",oh,1),mDirs[0]);
	mDirs[0]->AddLine(new iggWidgetTextLabel("%b%+X",mDirs[0]),box1,box2);
	this->AddLine(mDirs[0]);

	mDirs[1] = new iggFrame(this,3);
	box1 = new iggWidgetPropertyControlSpinBox(0,2,"",0,iggPropertyHandle("ReplicationFactors",oh,2),mDirs[1]);
	box2 = new iggWidgetPropertyControlSpinBox(0,2,"",0,iggPropertyHandle("ReplicationFactors",oh,3),mDirs[1]);
	mDirs[1]->AddLine(new iggWidgetTextLabel("%b%+Y",mDirs[1]),box1,box2);
	this->AddLine(mDirs[1]);

	mDirs[2] = new iggFrame(this,3);
	box1 = new iggWidgetPropertyControlSpinBox(0,2,"",0,iggPropertyHandle("ReplicationFactors",oh,4),mDirs[2]);
	box2 = new iggWidgetPropertyControlSpinBox(0,2,"",0,iggPropertyHandle("ReplicationFactors",oh,5),mDirs[2]);
	mDirs[2]->AddLine(new iggWidgetTextLabel("%b%+Z",mDirs[2]),box1,box2);
	this->AddLine(mDirs[2]);

	this->SetColStretch(1,10);
}


void iggFrameReplicate::UpdateChildren()
{
	this->iggFrame::UpdateChildren();
	
	const iViewSubject *sub = iDynamicCast<const iViewSubject>(INFO,mObjectHandle->Object());
	
	int i;
	for(i=0; i<3; i++)
	{
		mDirs[i]->Enable(sub->GetSubject()->IsDirectionPeriodic(i));
	}
}

#endif
