//LICENSE A

//
//  Wrapper for all menu item actions
//

#ifndef IGGMENUHELPER_H
#define IGGMENUHELPER_H


#include "iggelement.h"


#include "imath.h"

class iggObjectHandle;
class iggPropertyHandle;


//
//  Abstract base class
//
class iggMenuHelperBase
{

public:

	virtual ~iggMenuHelperBase();

	virtual iggMenuHelperBase* Clone() const = 0;
	virtual bool IsSet() const = 0;

protected:

	iggMenuHelperBase();

private:

	void operator=(const iggMenuHelperBase& other);  // not implemented
	iggMenuHelperBase(const iggMenuHelperBase& other);
};


//
//  MenuHelper that directly accesses class method
//
template<class Object, class Type>
class iggMenuHelper : public iggMenuHelperBase
{

public:

	typedef Type (Object::*Method)() const;

	iggMenuHelper(const iggObjectHandle *oh, Method method, Type val);

	virtual iggMenuHelperBase* Clone() const;
	virtual bool IsSet() const;

private:

	iggMenuHelper(const iggMenuHelper<Object,Type> *other);

	void Define(const iggObjectHandle *oh, Method method, Type val);

	Type mValue;
	const iggObjectHandle *mObjectHandle;
	Method mMethod;
};

#endif  // IGGMENUHELPER_H

