//LICENSE A

//
//  A window with menus and toolsbars
//

#ifndef IGGMENUWINDOW_H
#define IGGMENUWINDOW_H


#include "iggrenderingelement.h"


#include "istring.h"

class iggFrameTopParent;
class iggMainWindow;

class ibgMenuWindowSubject;


class iggMenuWindow : public iggRenderingElement
{

	friend class iggSubjectFactory;

public:

	virtual ~iggMenuWindow();

	virtual void Show(bool s);
	ibgMenuWindowSubject* GetSubject() const { return mMenuSubject; }
	inline iggMainWindow* GetMainWindow() const { return mMainWindow; }

	iString GetFileName(const iString &header, const iString &file, const iString &selection, bool reading = true);

	inline const iggFrameTopParent* GetGlobalFrame() const { return mGlobalFrame; }
	virtual bool CanBeClosed();

	//
	//  Update components
	//
	void UpdateAll();
	void UpdateMenus();

	//
	//  Do all menu work here
	//
	void OnMenu(int id, bool on);

protected:

	iggMenuWindow(iggShell *shell);
	iggMenuWindow(iggMainWindow *mainWindow);

	void AttachSubject(ibgMenuWindowSubject *subject, int cols);

	virtual void OnMenuBody(int id, bool on) = 0;
	virtual void UpdateContents() = 0;

	iggFrameTopParent *mGlobalFrame;

	iggMainWindow *mMainWindow;

private: 

	//
	//  MenuSubject must be attached using AttachSubject call.
	//
	ibgMenuWindowSubject *mMenuSubject;
};

#endif  // IGGMENUWINDOW_H

