//LICENSE A

//
//  A page containing data widgets
//

#ifndef IGGPAGEDATA_H
#define IGGPAGEDATA_H


#include "iggpagemain.h"


class iDataType;
class iDataInfo;
class iDataSubject;
class iParticleDataSubject;

class iggDataTypeHandle;
class iggObjectHandle;
class iggPropertyHandle;


class iggPageData : public iggPageMain
{

public:

	iggPageData(iggFrameBase *parent);
	virtual ~iggPageData();

	iDataSubject* GetScalarSubject(int mod) const;
	iParticleDataSubject* GetParticleSubject(int mod) const;

	//void UpdateOnDataLoad();

	const iggObjectHandle* GetScalarSubjectHandle() const { return mScalarSubjectHandle; }
	const iggObjectHandle* GetParticleSubjectHandle() const { return mParticleSubjectHandle; }

protected:

	virtual iggFrame* CreateFlipFrame(iggFrameBase *parent);

	virtual void OnInt1Body(int i); // Feedback from the main book

	iggObjectHandle *mScalarSubjectHandle, *mParticleSubjectHandle;
	iggDataTypeHandle *mDataTypeHandle;

	//iDataInfo *mInfoBuffer;
};

#endif  // IGGPAGEDATA_H

