//LICENSE A


#include "iconfigure.h"
#if ISHELL_INCLUDED(ISHELL_GG)


#include "iggpageobjectextension.h"


#include "idata.h"
#include "ierror.h"
#include "iviewobject.h"
#include "iviewsubject.h"

#include "igghandle.h"
#include "iggmainwindow.h"
#include "iggshell.h"
#include "iggpageobject.h"


namespace iggPageObjectExtension_Private
{
	//
	//  Returns the current VS
	//
	class ViewSubjectHandle : public iggObjectHandle
	{

	public:

		ViewSubjectHandle(iggPageObjectExtension *owner) : iggObjectHandle(owner)
		{
			mOwner = owner; IASSERT(mOwner);
		}

		virtual const iObject* Object(int mod = -1) const
		{
			return mOwner->GetViewSubject(mod);
		}

	private:

		iggPageObjectExtension *mOwner;
	};
};


using namespace iggPageObjectExtension_Private;


iggPageObjectExtension::iggPageObjectExtension(iggFrameBase *parent, int pageId, const iDataType &type, int flags) : iggPage(parent,flags), mPageId(pageId), mDataType(type)
{
	mOwner = this->GetMainWindow()->GetPage(mPageId); IASSERT(mOwner);

	mSubjectHandle = new ViewSubjectHandle(this);
}


iggPageObjectExtension::~iggPageObjectExtension()
{
	delete mSubjectHandle;
}


const iggPropertyHandle iggPageObjectExtension::CreatePropertyHandle(const iString &name) const
{
	return iggPropertyHandle(name,mSubjectHandle,mOwner->GetInstanceHandle());
}


iViewSubject* iggPageObjectExtension::GetViewSubject(int mod) const
{
	iViewSubject *sub = mOwner->GetViewSubject(mod);

	if(mDataType == sub->GetDataType())
	{
		return sub;
	}
	else
	{
		return mOwner->GetViewObject(mod)->GetSubject(mDataType);
	}
}


int iggPageObjectExtension::GetActiveInstance() const
{
	return mOwner->GetActiveInstance();
}


const iImage* iggPageObjectExtension::Icon() const
{
	return mOwner->Icon();
}


void iggPageObjectExtension::UpdateWidgetBody()
{
	if(this->GetViewSubject(-1) == mOwner->GetViewSubject(-1))
	{
		this->Enable(true);
		this->iggPage::UpdateWidgetBody();
	}
	else this->Enable(false);
}

#endif
