//LICENSE A

//
//  A base class for pages for object extensions
//
#ifndef IGGPAGEOBJECTEXTENSION_H
#define IGGPAGEOBJECTEXTENSION_H


#include "iggpage.h"


class iDataType;
class iImage;
class iViewSubject;

class iggObjectHandle;
class iggPageObject;
class iggPropertyHandle;


class iggPageObjectExtension : public iggPage
{

public:

	const iDataType& GetDataType() const { return mDataType; }

	iViewSubject* GetViewSubject(int mod) const;
	const iggObjectHandle* GetSubjectHandle() const { return mSubjectHandle; }
	const iggPropertyHandle CreatePropertyHandle(const iString &name) const;

	int GetActiveInstance() const;
	const iImage* Icon() const;

protected:

	iggPageObjectExtension(iggFrameBase *parent, int pageId, const iDataType &type, int flags);
	virtual ~iggPageObjectExtension();

	virtual void UpdateWidgetBody();

private:

	const int mPageId;
	const iDataType& mDataType;
	const iggPageObject *mOwner;
	iggObjectHandle *mSubjectHandle;
};

#endif  // IGGPAGEOBJECTEXTENSION_H

