//LICENSE A

//
//  A widget that updates its parent when RenderWindow is modified
//
#ifndef IGGRENDERWINDOWOBSERVER_H
#define IGGRENDERWINDOWOBSERVER_H


#include "ieventobserver.h"


class iggFrame;
class iggRenderWindowObserverHelper;

class vtkRenderWindow;


class iggRenderWindowObserver
{

	friend class iggFrameBase;
	friend class iggRenderWindowObserverHelper;

public:

	virtual ~iggRenderWindowObserver();

protected:

	iggRenderWindowObserver(iggFrame *parent, bool disabled = false);

	void UpdateConnection();
	virtual void OnRenderWindowModified() = 0;

	iggFrame *mParent;
	iggRenderWindowObserverHelper *mHelper;
};


class iggRenderWindowObserverHelper : public iEventObserver
{

	friend class iggRenderWindowObserver;

public:
	
	vtkTypeMacro(iggRenderWindowObserverHelper,iEventObserver);

protected:

	iggRenderWindowObserverHelper(iggRenderWindowObserver *owner, iggFrame *frame);
	virtual ~iggRenderWindowObserverHelper();

	virtual void ExecuteBody(vtkObject *caller, unsigned long event, void *data);

	void UpdateConnection();
	void Detach();

private:

	iggFrame *mFrame;
	iggRenderWindowObserver *mOwner;
	vtkRenderWindow *mWindow;
};

#endif
