//LICENSE A


#ifndef IGGSCRIPTWINDOW_H
#define IGGSCRIPTWINDOW_H


#include "iggmenuwindow.h"


#include "istring.h"

class iScript;

class iggDialog;
class iggFrame;
class iggWidgetScriptEditor;
class iggWidgetSimpleButton;
class iggWidgetTextBrowser;


class iggScriptWindow : public iggMenuWindow
{

public:

	iggScriptWindow(iggMainWindow *parent);
	virtual ~iggScriptWindow();

	virtual void Show(bool s);
	virtual bool CanBeClosed();

	inline int GetRunState() const { return mRunState; }

	void DebugLine(int line, const iString& file);
	inline bool IsDebugging() const { return mIsDebugging; }

protected:

	bool ImmediateConstruction() const; 
	void CompleteConstruction();
	virtual void CompleteConstructionBody();

	virtual void UpdateContents();
	virtual void OnMenuBody(int id, bool on);

	void BuildMenus();
	void LoadFromFile(const iString &fn);
	bool LoadFromFileBody(const iString &fn, bool silent);
	void SaveToFile(const iString &fn);
	void SetContents(const iString &text);
	void CheckModified();

	iScript *mScript;
	iggFrame *mDebugFrame;
	iggDialog *mFindDialog;
	iggWidgetScriptEditor *mEditor;
	iggWidgetTextBrowser *mOutput;

	int mRunState;
	bool mCompleteConstructionCalled, mFirstShow, mIsDebugging;
	iString mCurrentFileName, mHistory, mLastExecutedSegment, mDebuggedFile;
};

#endif  //  IGGSCRIPTWINDOW_H
