//LICENSE A


#include "iconfigure.h"
#if ISHELL_INCLUDED(ISHELL_GG)


#include "iggshelleventobservers.h"


#include "ierror.h"
#include "iviewmodule.h"

#include "iggdialogparallelcontroller.h"
#include "iggmainwindow.h"
#include "iggshell.h"
#include "iggwidgetprogressbar.h"

#include "ibgmenuwindowsubject.h"


using namespace iParameter;


//
//  iggExecutionEventObserver class
//
iggExecutionEventObserver::iggExecutionEventObserver(iggShell *s) : iExecutionEventObserver(s)
{
	mCurrentProgressBar = 0;
	mShell = s; IASSERT(s);
}


void iggExecutionEventObserver::OnStart()
{
	if(mCurrentProgressBar==0 && mShell->GetMainWindow()!=0 && mShell->GetMainWindow()->GetProgressBar()!=0) 
	{
		mCurrentProgressBar = mShell->GetMainWindow()->GetProgressBar();
	}
	if(mCurrentProgressBar != 0)
	{
		mCurrentProgressBar->Reset();
	}
}


void iggExecutionEventObserver::OnSetLabel(const iString &label)
{
	if(mCurrentProgressBar != 0)
	{
		mCurrentProgressBar->SetLabel(label);
	}
}


void iggExecutionEventObserver::OnProgress(double f, bool &abort)
{
	if(mCurrentProgressBar != 0)
	{
		mCurrentProgressBar->SetProgress(iMath::Round2Int(f*100.0));
		abort = mCurrentProgressBar->IsAborted();
	}
	else
	{
		abort = false;
	}
}


void iggExecutionEventObserver::OnFinish()
{
	if(mCurrentProgressBar != 0)
	{
		mCurrentProgressBar->Reset();
		mCurrentProgressBar = 0;
	}
}


void iggExecutionEventObserver::SetProgressBar(iggWidgetProgressBar *pb)
{
	mCurrentProgressBar = pb;
}


//
//  iggParallelUpdateEventObserver class
//
iggParallelUpdateEventObserver::iggParallelUpdateEventObserver(iggShell *s) : iParallelUpdateEventObserver(s)
{
	mShell = s; IASSERT(s);
}


void iggParallelUpdateEventObserver::UpdateInformation()
{
	if(mShell->GetMainWindow()!=0 && mShell->GetMainWindow()->GetDialogParallelController()!=0) 
	{
		mShell->GetMainWindow()->GetDialogParallelController()->UpdateDisplay();
	}
}

#endif
