//LICENSE A

//
//  Generic implementation of shell event observers
//

#ifndef IGGSHELLEVENTOBSERVERS_H
#define IGGSHELLEVENTOBSERVERS_H


#include "ishelleventobservers.h"


class iggShell;
class iggWidgetProgressBar;


class iggExecutionEventObserver : public iExecutionEventObserver
{
	
	friend class iggShell;

public:
	
	vtkTypeMacro(iggExecutionEventObserver,iExecutionEventObserver);

	void SetProgressBar(iggWidgetProgressBar *pb);

protected:

	iggExecutionEventObserver(iggShell *s);

	virtual void OnStart();
	virtual void OnFinish();
	virtual void OnProgress(double fraction, bool &abort);
	virtual void OnSetLabel(const iString &label);

	iggWidgetProgressBar *mCurrentProgressBar;
	iggShell *mShell;
};


class iggParallelUpdateEventObserver : public iParallelUpdateEventObserver
{
	
	friend class iggShell;

public:
	
	vtkTypeMacro(iggParallelUpdateEventObserver,iParallelUpdateEventObserver);

protected:

	iggParallelUpdateEventObserver(iggShell *s);

	virtual void UpdateInformation();

	iggShell *mShell;
};

#endif // IGGSHELLEVENTOBSERVERS_H

