//LICENSE A


#include "iconfigure.h"
#if ISHELL_INCLUDED(ISHELL_GG)


#include "iggviewmoduleeventobservers.h"


#include "ierror.h"
#include "iviewmodule.h"

#include "iggdialogpickerwindow.h"
#include "iggdialogrenderingprogress.h"
#include "iggmainwindow.h"
#include "iggshell.h"


using namespace iParameter;


//
//  iggRenderEventObserver class
//
bool iggRenderEventObserver::CheckAbort()
{
	iggShell *s = iRequiredCast<iggShell>(INFO,this->GetViewModule()->GetShell());
	if(s!=0 && s->GetMainWindow()!=0 && s->GetMainWindow()->GetDialogRenderingProgress()!=0) 
	{
		s->GetMainWindow()->GetDialogRenderingProgress()->KeepWorking(); 
		return s->GetMainWindow()->GetDialogRenderingProgress()->IsCancelled();
	}
	else return false;
}


void iggRenderEventObserver::OnStart()
{ 
	iggShell *s = iRequiredCast<iggShell>(INFO,this->GetViewModule()->GetShell());
	if(s!=0 && s->GetMainWindow()!=0 && s->GetMainWindow()->GetDialogRenderingProgress()!=0) 
	{
		s->GetMainWindow()->GetDialogRenderingProgress()->Start(this->IsInteractive()); 
	}
}


void iggRenderEventObserver::OnFinish()
{ 
	iggShell *s = iRequiredCast<iggShell>(INFO,this->GetViewModule()->GetShell());
	if(s!=0 && s->GetMainWindow()!=0) 
	{
		if(s->GetMainWindow()->GetDialogRenderingProgress() != 0) s->GetMainWindow()->GetDialogRenderingProgress()->Finish();
		if(s->GetMainWindow()->GetDialogPerformanceMeter() != 0) s->GetMainWindow()->GetDialogPerformanceMeter()->UpdateDialog();
	}
}


void iggRenderEventObserver::PostFinished()
{ 
	iggShell *s = iRequiredCast<iggShell>(INFO,this->GetViewModule()->GetShell());
	if(s!=0 && s->GetMainWindow()!=0 && s->GetMainWindow()->GetDialogPerformanceMeter()!=0) 
	{
		s->GetMainWindow()->GetDialogPerformanceMeter()->UpdateDialog();
	}
}


//
//  iggPickEventObserver class
//
void iggPickEventObserver::OnStart()
{
	iggShell *s = iRequiredCast<iggShell>(INFO,this->GetViewModule()->GetShell());
	if(s!=0 && s->GetMainWindow()!=0 && s->GetMainWindow()->GetDialogPickerWindow()!=0) 
	{
		s->GetMainWindow()->GetDialogPickerWindow()->CollectData(true);
		s->GetMainWindow()->GetDialogPickerWindow()->Show(true);
	}
}


void iggPickEventObserver::OnFinish()
{
	iggShell *s = iRequiredCast<iggShell>(INFO,this->GetViewModule()->GetShell());
	if(s!=0 && s->GetMainWindow()!=0 && s->GetMainWindow()->GetDialogPickerWindow()!=0) 
	{
		s->GetMainWindow()->GetDialogPickerWindow()->CollectData(false);
		s->GetMainWindow()->GetDialogPickerWindow()->DisplayData(this->GetViewModule()->GetPicker());
	}
}

#endif
