//LICENSE A


#ifndef IGGWIDGETAREA_H
#define IGGWIDGETAREA_H


#include "iggwidget.h"


#include "icolor.h"
#include "iimage.h"

class iHistogram;

class iggFrameHistogramControls;

class ibgWidgetDrawAreaSubject;


class iggWidgetDrawArea : public iggWidget
{

public:

	void DrawBackground();
	void DrawForeground();

	virtual void OnMousePress(int /*x*/, int /*y*/, int /*b*/){}
	virtual void OnMouseRelease(int /*x*/, int /*y*/, int /*b*/){}
	virtual void OnMouseMove(int /*x*/, int /*y*/, int /*b*/){}

protected:

	iggWidgetDrawArea(iggFrame *parent, bool interactive);

	virtual void DrawBackgroundBody() = 0;
	virtual void DrawForegroundBody() = 0;

	virtual void UpdateWidgetBody();

	ibgWidgetDrawAreaSubject *mSubject;
};


class iggWidgetImageArea : public iggWidgetDrawArea
{

public:

	iggWidgetImageArea(iggFrame *parent);
	iggWidgetImageArea(const iImage& image, bool scaled, iggFrame *parent);

	void SetImage(const iImage& image, bool scaled);
	void SetFixedSize(int w, int h);

	const iImage& GetImage() const { return mImage; }

protected:

	virtual void DrawBackgroundBody();
	virtual void DrawForegroundBody(){}

	iImage mImage;
	bool mScaled;
};


//
//  An interactive drawing area with the histogram plotted as a background
//
class iggWidgetHistogramArea : public iggWidgetDrawArea
{

public:

	iggWidgetHistogramArea(iggFrameHistogramControls *controls, iggFrame *parent);

protected:

	void DrawHistogram(const iHistogram& h, const iColor &color = iColor(160,160,160));
	void DrawHistogram(const iHistogram& h, float range[2], const iColor &color = iColor(160,160,160));

	iggFrameHistogramControls *mControls;
};

#endif  // IGGWIDGETAREA_H

