//LICENSE A


#ifndef IGGWIDGETOTHERBUTTON_H
#define IGGWIDGETOTHERBUTTON_H


#include "iggwidget.h"


#include "iarray.h"

class iImage;

class iggDialog;
class iggMenuWindow;
class iggObjectHandle;
class iggPage;
class iggPageObject;
class iggWidgetPropertyControlBase;
class iggWidgetPropertyControlSizeSlider;

class ibgWidgetButtonSubject;


class iggWidgetShowButton : public iggWidget
{

public:

	iggWidgetShowButton(iggPageObject *page, iggFrame *parent);

protected:

	virtual void UpdateWidgetBody();
	virtual void OnVoid1Body();

	ibgWidgetButtonSubject *mSubject;
	iggPageObject *mPage;
};


class iggWidgetLaunchButton : public iggWidget
{

public:

	iggWidgetLaunchButton(iggDialog *dialog, const iString &text, iggFrame *parent, bool destructive = false);
	iggWidgetLaunchButton(iggMenuWindow *window, const iString &text, iggFrame *parent, bool destructive = false);
	virtual ~iggWidgetLaunchButton();

protected:

	void Define(const iString &text, bool destructive = false);

	virtual void UpdateWidgetBody();
	virtual void OnVoid1Body();

	ibgWidgetButtonSubject *mSubject;
	iggDialog *mDialog;
	iggMenuWindow *mWindow;
	bool mDestructive;
};


class iggWidgetAllInstancesCheckBox : public iggWidget
{
	
public:
	
	iggWidgetAllInstancesCheckBox(iggFrame *parent);
	
protected:
	
	virtual void UpdateWidgetBody();
	virtual void OnVoid1Body();

	ibgWidgetButtonSubject *mSubject;
};


class iggWidgetSimpleButton : public iggWidget
{

public:

	iggWidgetSimpleButton(const iString &text, iggFrame *parent, bool tool = false, int minsize = 0);

protected:

	virtual void UpdateWidgetBody();
	virtual void OnVoid1Body();
	virtual void Execute() = 0;

	ibgWidgetButtonSubject *mSubject;
};


class iggWidgetDialogCloseButton : public iggWidgetSimpleButton
{

public:

	iggWidgetDialogCloseButton(iggDialog *dialog, iggFrame *parent, const char *text = "Close");

protected:

	virtual void Execute();

	iggDialog *mDialog;
};

#endif  // IGGWIDGETOTHERBUTTON_H

