//LICENSE A


#include "iconfigure.h"
#if ISHELL_INCLUDED(ISHELL_GG)


#include "iggwidgetprogressbar.h"


#include "iggframe.h"

#include "ibgwidgetprogressbarsubject.h"

#include "iggsubjectfactory.h"


iggWidgetProgressBar::iggWidgetProgressBar(iggFrame *parent, bool unlaid) : iggWidget(parent)
{
	mSubject = iggSubjectFactory::CreateWidgetProgressBarSubject(this);

	if(unlaid) mWasLaidOut = true;
	mNeedsBaloonHelp = false;
	mAborted = false;
}


iggWidgetProgressBar::~iggWidgetProgressBar()
{
}


void iggWidgetProgressBar::SetLabel(const iString &label)
{
	if(!mAborted) mSubject->SetLabel(label);
}


void iggWidgetProgressBar::SetProgress(int p)
{
	if(!mAborted)
	{
		if(p < 0)
		{
			this->Reset();
		}
		else
		{
			mSubject->SetProgress(p);
			this->OnSetProgress();
		}
	}
}


void iggWidgetProgressBar::Reset()
{
	mAborted = false;
	mSubject->Reset();
}


void iggWidgetProgressBar::UpdateWidgetBody()
{
}


bool iggWidgetProgressBar::IsAborted() const
{
	return mAborted;
}


void iggWidgetProgressBar::Abort()
{
	mAborted = true;
}


void iggWidgetProgressBar::OnSetProgress()
{
	//
	//  Default implementation does nothing
	//
}

#endif
