//LICENSE A

//
//  A generic ProgressBar class
//
#ifndef IGGWIDGETPROGRESSBAR_H
#define IGGWIDGETPROGRESSBAR_H


#include "iggwidget.h"


class ibgWidgetProgressBarSubject;


class iggWidgetProgressBar : public iggWidget
{

public:

	iggWidgetProgressBar(iggFrame *parent, bool unlaid = false);
	virtual ~iggWidgetProgressBar();

	void SetLabel(const iString &label);
	void SetProgress(int p);
	void Reset();

	void Abort();
	bool IsAborted() const;

	inline ibgWidgetProgressBarSubject* GetSubject() const { return mSubject; } // needed for re-parenting

protected:

	virtual void UpdateWidgetBody();
	virtual void OnSetProgress();

	ibgWidgetProgressBarSubject *mSubject;
	bool mAborted;
};

#endif // IGGWIDGETPROGRESSBAR_H
