//LICENSE A


#ifndef IGGWIDGETPROPERTYCONTROLBUTTON_H
#define IGGWIDGETPROPERTYCONTROLBUTTON_H

//
//  Non-abstract classes defined in this file
//
// iggWidgetPropertyControlCheckBox;
// iggWidgetPropertyControlExecButton;
// iggWidgetPropertyControlToggleButton;
// iggWidgetPropertyControlFileNameButton;
// iggWidgetPropertyControlIntExecButton;
//
#include "iggwidgetpropertycontrol.h"


#include "istring.h"

class iImage;

class ibgWidgetButtonSubject;


class iggWidgetPropertyControlButton : public iggWidgetPropertyControl<iType::Bool>
{

public:

	iggWidgetPropertyControlButton(int type, const iString &text, const iggPropertyHandle& ph, iggFrame *parent);

	void SetReverse(bool s);

	virtual void QueryValue(bool &val) const;

protected:

	virtual void UpdateValue(bool val);

	virtual void OnVoid1Body();

	bool mReverse;
	ibgWidgetButtonSubject *mSubject;
};


class iggWidgetPropertyControlCheckBox : public iggWidgetPropertyControlButton
{

public:

	iggWidgetPropertyControlCheckBox(const iString &text, const iggPropertyHandle& ph, iggFrame *parent);
};


class iggWidgetPropertyControlExecButton : public iggWidgetPropertyControlButton
{

public:

	iggWidgetPropertyControlExecButton(const iString &text, const iggPropertyHandle& ph, iggFrame *parent);

	virtual void QueryValue(bool &val) const;

protected:

	virtual void UpdateWidgetBody();
};


class iggWidgetActionControlExecButton : public iggWidgetPropertyControlExecButton
{

public:

	iggWidgetActionControlExecButton(const iString &text, const iggPropertyHandle& ph, iggFrame *parent);

	virtual bool ExecuteControl(bool final, bool val);
};


class iggWidgetPropertyControlToolButton : public iggWidgetPropertyControlButton
{

public:

	iggWidgetPropertyControlToolButton(const iString &text, const iggPropertyHandle& ph, iggFrame *parent);

	virtual void QueryValue(bool &val) const;

protected:

	virtual void UpdateWidgetBody();
};


class iggWidgetPropertyControlToggleButton : public iggWidgetPropertyControlButton
{

public:

	iggWidgetPropertyControlToggleButton(const iImage *icon, const iString &text, const iggPropertyHandle& ph, iggFrame *parent);

protected:

	const iImage *mIcon;
};


class iggWidgetPropertyControlFileNameButton : public iggWidgetPropertyControl<iType::String>
{

public:

	iggWidgetPropertyControlFileNameButton(const iString &text, const iString &header, const iString &selection, const iggPropertyHandle& ph, iggFrame *parent);

	void SetDefaut(const iString &s);

	virtual void QueryValue(iString &val) const;

protected:

	virtual void UpdateWidgetBody();
	virtual void UpdateValue(const iString& val);

	virtual void OnVoid1Body();

	ibgWidgetButtonSubject *mSubject;
	iString mHeader, mSelection, mDefault;
};


class iggWidgetPropertyControlExecIntButton : public iggWidgetPropertyControl<iType::Int>
{

public:

	iggWidgetPropertyControlExecIntButton(int value, const iString &text, const iggPropertyHandle& ph, iggFrame *parent);

	virtual void QueryValue(int &val) const;

protected:

	virtual void UpdateWidgetBody();
	virtual void UpdateValue(int val);

	virtual void OnVoid1Body();

	int mValue;
	ibgWidgetButtonSubject *mSubject;
};

#endif  // IGGWIDGETPROPERTYCONTROLBUTTON_H

