//LICENSE A


#ifndef IGGWIDGETRENDERMODEBUTTON_H
#define IGGWIDGETRENDERMODEBUTTON_H


#include "iggwidget.h"


class iImage;
template<class T> class iLookupArray;

class iggWidgetPropertyControlBase;

class ibgWidgetButtonSubject;
class ibgWidgetEntrySubject;
class ibgWidgetTrackBallSubject;


class iggWidgetRenderModeButton : public iggWidget
{

public:

	iggWidgetRenderModeButton(iggWidgetPropertyControlBase *parent, bool registered = true);
	virtual ~iggWidgetRenderModeButton();

	static void ShowAll(bool s);
	static void UpdateAll();

	ibgWidgetButtonSubject* GetSubject() const { return mSubject; }

	//
	//  Allow selected subjects to clear the laid-out flag
	//
	void ClearLaidOutFlag(const ibgWidgetEntrySubject *e); 
	void ClearLaidOutFlag(const ibgWidgetTrackBallSubject *t); 

protected:

	virtual void UpdateWidgetBody();
	virtual void OnVoid1Body();

	ibgWidgetButtonSubject *mSubject;
	iggWidgetPropertyControlBase *mParent;
	const iImage *mDelayIcon, *mReadyIcon;
	//
	//  Registry functionality
	//
	static iLookupArray<iggWidgetRenderModeButton*> &List();
};

#endif  // IQTWIDGETRENDERMODEBUTTON_H

