//LICENSE A


#ifndef IOSSHELL_H
#define IOSSHELL_H

//
//  A off-screen rendering shell
//
#include "ishell.h"


class iScript;


class iosShell : public iShell
{

	friend class iShell;

public:

	vtkTypeMacro(iosShell,iShell);

	//
	//  Factory methods
	//
	virtual vtkRenderWindow* CreateRenderWindow(iViewModule *vm, bool stereo) const;
	virtual vtkRenderWindowInteractor* CreateRenderWindowInteractor(iViewModule *vm) const;
	virtual iEventObserver* CreateViewModuleEventObserver(iParameter::ViewModuleObserver::Type type, iViewModule *vm) const;

protected:

	iosShell(iRunner *runner, const iString &type, int argc, const char **argv);
	virtual ~iosShell();

	virtual bool ConstructorBody();  
	virtual void DestructorBody();  
	virtual void StartBody();
	virtual void StopBody();

	virtual bool OnCommandLineArguments(iArray<iString> &argv);

	virtual iDataReaderObserver* CreateDataReaderObserver();
	virtual iEventObserver* CreateShellEventObserver(iParameter::ShellObserver::Type);
	virtual iOutputChannel* CreateOutputChannel();

private:

	iString mScriptText;
	iScript *mScript;
};

#endif  // IOSSHELL_H
