//LICENSE A


#include "iconfigure.h"
#if ISHELL_INCLUDED(ISHELL_QT)


#include "iqtdialogsubject.h"


#include "ierror.h"

#include "iggdialog.h"
#include "iggframe.h"
#include "iggmainwindow.h"

#include "iqtframesubject.h"
#include "iqthelper.h"
#include "iqtmainwindowsubject.h"
#include "iqtwindowhelper.h"

#ifdef IQT_3
#include <qdialog.h>
#include <qlayout.h>
#include <qpushbutton.h>
#include <qtooltip.h>
#else
#include <QtGui/QCloseEvent>
#ifdef IQT_4
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QPushButton>
#include <QtGui/QToolTip>
#else
#include <QtWidgets/QDialog>
#include <QtWidgets/QGridLayout>
#include <QtWidgets/QPushButton>
#include <QtWidgets/QToolTip>
#endif
#endif


using namespace iParameter;


//
//  Main class
//
iqtDialogSubject::iqtDialogSubject(iggDialog *owner, const ibgWindowSubject *base, unsigned int mode, const iImage *icon, const iString &title) : 
#ifdef IQT_3
	QDialog((mode&DialogFlag::Unattached)?0:iDynamicCast<iqtWindowHelper,ibgWindowHelper>(INFO,base->GetHelper())->GetWidget(),"",false,iqtHelper::GetFlags(WindowType::Dialog,mode)), 
#else
	QDialog((mode&DialogFlag::Unattached)?0:iDynamicCast<iqtWindowHelper,ibgWindowHelper>(INFO,base->GetHelper())->GetWidget(),iqtHelper::GetFlags(WindowType::Dialog,mode)), 
#endif
	ibgDialogSubject(owner,base,mode,icon,title)
{
	mWindowHelper = new iqtWindowHelper(this,icon,title); IERROR_CHECK_MEMORY(mWindowHelper);

	mMode = mode;
	QGridLayout *layout = iqtHelper::NewLayout(this,1);

	if((mode & DialogFlag::Blocking) == 0) this->setSizeGripEnabled(true); else
	{
#ifndef IQT_3
		 this->setAttribute(Qt::WA_ShowModal); 
#endif
	}
	if((mode & DialogFlag::NoTitleBar) != 0)
	{
		this->setFocusPolicy(QFocus::NoFocus);
		iqtHelper::SetBackground(this,0);
	}
}


iqtDialogSubject::~iqtDialogSubject()
{
}


void iqtDialogSubject::Show(bool s)
{
	if(s)
	{
		if(mMode & DialogFlag::WithEventLoop)
		{
			this->exec();
		}
		else
		{
			this->show();
			if(!this->isHidden()) this->raise();
		}
	}
	else this->hide();
}


void iqtDialogSubject::SetFrame(ibgFrameSubject *frame0)
{
	iqtFrameSubject *frame = iDynamicCast<iqtFrameSubject,ibgFrameSubject>(INFO,frame0);

	if(frame->parentWidget() != this)
	{
		iqtHelper::SetParent(frame,this);
		iDynamicCast<QGridLayout,QLayout>(INFO,this->layout())->addWidget(frame,0,0);
	}
	if((mMode & DialogFlag::NoTitleBar) != 0)
	{
#ifdef IQT_3
		frame->setFrameShape(QFrame::Box);
		frame->setFrameShadow(QFrame::Raised);
		frame->setLineWidth(3);
		frame->setMidLineWidth(2);
#else
		frame->setFlat(false);
#endif
		frame->layout()->setMargin(5);
	}
}


void iqtDialogSubject::closeEvent(QCloseEvent *e)
{
	this->OnClose();
	e->ignore();
}


void iqtDialogSubject::keyPressEvent(QKeyEvent *e)
{
	//
	//  Block closing of dialogs on Enter
	//
	if(e->key() == Qt::Key_Return) e->accept(); else QDialog::keyPressEvent(e);
}

#endif
