//LICENSE A

//
//  Qt-implementation of ibgDialogBase
//

#ifndef IQTDIALOGSUBJECT_H
#define IQTDIALOGSUBJECT_H


#include "iqt.h"

#ifdef IQT_3
#include <qdialog.h>
#elif defined(IQT_4)
#include <QtGui/QDialog>
#else
#include <QtWidgets/QDialog>
#endif
#include "ibgdialogsubject.h"


class QCloseEvent;
class QHBoxLayout;
class QKeyEvent;


class iqtDialogSubject : public QDialog, public ibgDialogSubject
{

	friend class iggSubjectFactory;

public:

	virtual ~iqtDialogSubject();

	virtual void Show(bool s);

protected:

	iqtDialogSubject(iggDialog *owner, const ibgWindowSubject *base, unsigned int mode, const iImage *icon, const iString &title);

	virtual void SetFrame(ibgFrameSubject *frame);

	//
	//  QT specific
	//
	virtual void keyPressEvent(QKeyEvent *e);
	virtual void closeEvent(QCloseEvent *e);
};

#endif  // IQTDIALOGSUBJECT_H

