//LICENSE A

//
//  Qt-implementation of ibgFrameSubject with explicit parent (used in iqtMainWindow)
//

#ifndef IQTEXPLICITFRAMESUBJECT_H
#define IQTEXPLICITFRAMESUBJECT_H


#include "iqt.h"

#ifdef IQT_3
#include <qgroupbox.h>
#elif defined(IQT_4)
#include <QtGui/QGroupBox>
#else
#include <QtWidgets/QGroupBox>
#endif
#include "ibgframesubject.h"


class QGridLayout;


class iqtExplicitFrameSubject : public QGroupBox, public ibgFrameSubject
{

	friend class iqtExtensionWindow;
	friend class iqtMainWindow;

public:

	iqtExplicitFrameSubject(QWidget *qparent, iggFrame *owner, int cols); // public, so that it can be created by other classes
	virtual ~iqtExplicitFrameSubject();
	
	virtual void SetTitle(const iString &title);
	virtual void ShowFrame(bool s);

	virtual void SetPadding(bool s);
	virtual void SetColStretch(int col, int s);
	virtual void SetRowStretch(int row, int s);
	virtual void PlaceWidget(int col, int row, ibgWidgetSubject *child, int nc, bool expand);

	QGridLayout* GetLayout() const { return mLayout; }
	virtual void GetFrameGeometry(int wg[4]) const;

	//
	//  QT-specific
	//
	virtual void show();

protected:

	virtual void showEvent(QShowEvent *e);
	virtual void paintEvent(QPaintEvent *e);

	QGridLayout *mLayout;
	int mNumCols, mNumRows;

private:

	void Qt3Fix();
};

#endif  // IQTEXPLICITFRAMESUBJECT_H

