//LICENSE A

//
//  A Qt-ased implementation for the MainWindowSubject class
//

#ifndef IQTMAINWINDOWSUBJECT_H
#define IQTMAINWINDOWSUBJECT_H


#include "iqtmenuwindowsubject.h"
#include "ibgmainwindowsubject.h"


#ifdef IQT_3
class QWorkspace;
#else
class QMdiArea;
#define QWorkspace	QMdiArea
#endif


class iqtMainWindowSubject : public iqtMenuWindowSubject, public ibgMainWindowSubject
{

	Q_OBJECT

	friend class iggSubjectFactory;

public:

	virtual void AttachRenderWindow(iggRenderWindow *rw);

protected:

	iqtMainWindowSubject(iggMainWindow *owner);
	virtual ~iqtMainWindowSubject();

	//
	//  General members
	//
	virtual void ShowToolTips(bool s);
	virtual void SetTheme(const iString &name);
	virtual void StartTimer();

	//
	//  Construction helpers
	//
	virtual void SetTopParentSubjects(iggFrameTopParent *busyIndicatorFrame, iggFrameTopParent *visitedFileListFrame);
	virtual void PopulateStatusBar(iggFrame *busyIndicatorFrame, ibgWidgetProgressBarSubject *progressBarSubject, iggFrame *visitedFileListFrame);

	//
	//  Docking helpers
	//
	virtual void PlaceWindowsInDockedPositions();
	virtual void RestoreWindowsFromDockedPositions();

	//
	//  Qt-specific
	//
	virtual bool event(QEvent *e);
	virtual void moveEvent(QMoveEvent *e);
	virtual void closeEvent(QCloseEvent *e);
	virtual void timerEvent(QTimerEvent *e);
	virtual void resizeEvent(QResizeEvent *e);
//	virtual void keyPressEvent(QKeyEvent *e); 
//	virtual void keyReleaseEvent(QKeyEvent *e); 
//	virtual void focusInEvent(QFocusEvent *e);
//	virtual void focusOutEvent(QFocusEvent *e);

private:

	int mTimerId;
	QWidget *mMainFrame;
	QWorkspace *mDockingWorkspace;

	iqtMainWindowSubject(const iqtMainWindowSubject&); // Not implemented.
	void operator=(const iqtMainWindowSubject&);  // Not implemented.
};

#endif  // IQTMAINWINDOWSUBJECT_H
