//LICENSE A


#ifndef IQTSHELLSUBJECT_H
#define IQTSHELLSUBJECT_H

//
//  A shell subject based on QT GUI interface
//
#include "ibgshellsubject.h"


class iqtShellSubject : public ibgShellSubject
{

	friend class iggSubjectFactory;

public:

	virtual ~iqtShellSubject();

protected:

	iqtShellSubject(iggShell *owner);

	//
	//  System-level operations
	//
	virtual void GetDesktopDimensions(int &w, int &h) const;
	virtual void ProcessEvents(bool sync);
	virtual void CompleteStartUp();
	virtual void EnterEventLoop();
	virtual void Exit();

	//
	//  User notification
	//
	virtual int PopupWindow(ibgWindowSubject *parent, const iString &text, int type, const char *button0, const char *button1, const char *button2) const;
};

#endif  // IQTSHELLSUBJECT_H

