//LICENSE A

//
//  Qt-bases button
//
#ifndef IQTWIDGETBUTTONSUBJECT_H
#define IQTWIDGETBUTTONSUBJECT_H


#include "iqt.h"

#ifdef IQT_3
#include <qwidget.h>
#elif defined(IQT_4)
#include <QtGui/QWidget>
#else
#include <QtWidgets/QWidget>
#endif
#include "ibgwidgetbuttonsubject.h"


class QLabel;


class iqtWidgetButtonSubject : public QWidget, public ibgWidgetButtonSubject
{

	friend class iggSubjectFactory;

public:

	virtual ~iqtWidgetButtonSubject();

	//
	//  Decorator functions
	//
	virtual bool IsDown() const;

	virtual void SetDown(bool s);
	virtual void SetIcon(const iImage &icon);
	virtual void SetText(const iString &text);

	virtual void SetAutoRepeat(bool s);

	virtual void SetSize(int w, int h);
	virtual void SetFlat(bool s);

protected:

	iqtWidgetButtonSubject(iggWidget *owner, int type, const iString &text, int slot, int minsize);

	QAbstractButton *mButton;
};

#endif  // IQTWIDGETBUTTONSUBJECT_H

