//LICENSE A

//
//  Qt-based color selection widget
//
#ifndef IQTWIDGETCOLORSELECTIONSUBJECT_H
#define IQTWIDGETCOLORSELECTIONSUBJECT_H


#include "iqt.h"

#ifdef IQT_3
#include <qwidget.h>
#elif defined(IQT_4)
#include <QtGui/QWidget>
#else
#include <QtWidgets/QWidget>
#endif
#include "ibgwidgetcolorselectionsubject.h"


class QLabel;
class QPushButton;


class iqtWidgetColorSelectionSubject : public QWidget, public ibgWidgetColorSelectionSubject
{

	friend class iggSubjectFactory;

public:

	virtual ~iqtWidgetColorSelectionSubject();

	virtual const iColor GetColor() const;
	virtual void SetColor(const iColor &c);

	virtual void SetText(const iString &text);

protected:

	iqtWidgetColorSelectionSubject(iggWidget *owner);

	void DisplayColor() const;

	QPushButton *mButton;
	mutable QColor mColor;
	const int mSize;
};

#endif  // IQTWIDGETCOLORSELECTIONSUBJECT_H

