//LICENSE A

//
//  A combination of a slider with an LCD and/or line edit 
//
#ifndef IQTWIDGETENTRYSUBJECT_H
#define IQTWIDGETENTRYSUBJECT_H


#include "iqt.h"

#ifdef IQT_3
#include <qwidget.h>
#elif defined(IQT_4)
#include <QtGui/QWidget>
#else
#include <QtWidgets/QWidget>
#endif
#include "ibgwidgetentrysubject.h"


class QLineEdit;
class QMouseEvent;
class QSlider;


class iqtWidgetEntrySubject : public QWidget, public ibgWidgetEntrySubject
{

	friend class iggSubjectFactory;

public:

	virtual ~iqtWidgetEntrySubject();

	virtual void AddButton(ibgWidgetButtonSubject* button);
	virtual void SetEditable(bool s);

	//
	//  Decorator functions
	//
	virtual int GetValue() const;
	virtual void GetRange(int &min, int &max) const;
	virtual const iString GetText() const;

	virtual void SetValue(int v);
	virtual void SetValue(int v, double dv);
	virtual void SetValue(int v, vtkIdType lv);
	virtual void SetNumberOfTicks(int n);
	virtual void SetRange(int smin, int smax, int pagestep = 0);
	virtual void SetText(const iString &text);
	virtual void SelectText(int start, int len = -1);

	virtual void ShowTail();

	virtual void SetStretch(int label, int slider, int number = 0);

	void OnKeyUpDown(bool up);

protected:

	iqtWidgetEntrySubject(iggWidget *owner, bool slider, int numdig, const iString &label);

	int mNumButtons;

	QLineEdit *mDisplay;
	QSlider *mSlider;
};

#endif  // IQTWIDGETENTRYSUBJECT_H
