//LICENSE A

//
//  Qt-based HTML Browser widget subject
//
#ifndef IQTWIDGETHELPBROWSERSUBJECT_H
#define IQTWIDGETHELPBROWSERSUBJECT_H


#include "iqt.h"

#ifdef IQT_3
#include <qtextbrowser.h>
#elif defined(IQT_4)
#include <QtGui/QTextBrowser>
#else
#include <QtWidgets/QTextBrowser>
#endif
#include "ibgwidgethelpbrowsersubject.h"


class iqtWidgetHelpBrowserSubject : public QTextBrowser, public ibgWidgetHelpBrowserSubject
{

	friend class iggSubjectFactory;

public:

	virtual ~iqtWidgetHelpBrowserSubject();

	virtual void SetText(const iString &text);
	virtual iString GetText() const;

	virtual void AddImage(const iString &name, const iImage &image);

protected:

	iqtWidgetHelpBrowserSubject(iggWidgetHelpBrowser *owner);

	//
	//  Qt specific
	//
#ifdef IQT_3
	virtual void setSource(const QString &name);
	virtual void contentsMouseReleaseEvent(QMouseEvent *e);
#else
	virtual void setSource(const QUrl &name);
	virtual void mouseReleaseEvent(QMouseEvent *e);
	virtual QVariant loadResource(int type, const QUrl &name);
#endif
};

#endif  //  IQTWIDGETHELPBROWSERSUBJECT_H
