//LICENSE A

//
//  A Qt-based widget helper
//

#ifndef IQTWIDGETHELPER_H
#define IQTWIDGETHELPER_H


#include "iqt.h"

#ifdef IQT_3
#include <qobject.h>
#else
#include <QtCore/QObject>
class QAbstractButton;
#endif
#include "ibgwidgethelper.h"


class iqtWidgetBaloonHelp;

class QWidget;


class iqtWidgetHelper : public QObject, public ibgWidgetHelper
{

	Q_OBJECT

	friend class iqtWidgetBaloonHelp;

public:

	iqtWidgetHelper(QWidget *widget, iggWidget *owner);
	virtual ~iqtWidgetHelper();

	virtual void SetBaloonHelp(const iString &tooltip, const iString &whatsthis);
	virtual bool SupportsHTMLHelp() const;
	virtual bool HasBaloonHelp() const;

	virtual void Show(bool s);
	virtual bool IsVisible() const;

	virtual void Enable(bool s);
	virtual bool IsEnabled() const;

	virtual void SetBackgroundColor(const iColor &c);
	virtual void UnSetBackgroundColor();

	inline QWidget* GetWidget() const { return mWidget; }

	void SetDisabling(bool s){ mIsDisabling = s; }

protected:
	
	iqtWidgetBaloonHelp  *mBaloonHelp;
	QWidget *mWidget;

public slots:

	//
	//  Generic slots
	//
	virtual void OnInt1(int);
	virtual void OnInt2(int);
	virtual void OnVoid1();
	virtual void OnVoid2();
	virtual void OnVoid3();
	virtual void OnBool1(bool);
	virtual void OnButtonClicked(QAbstractButton * );

private:

	bool mIsDisabling;

	iqtWidgetHelper(const iqtWidgetHelper &);
	void operator=(const iqtWidgetHelper &);
};

#endif  // IQTWIDGETHELPER_H

