//LICENSE A

//
//  A simple decorator over the Qt QProgressBar class
//
#ifndef IQTWIDGETPROGRESSBARSUBJECT_H
#define IQTWIDGETPROGRESSBARSUBJECT_H


#include "iqt.h"

#ifdef IQT_3
#include <qprogressbar.h>
#elif defined(IQT_4)
#include <QtGui/QProgressBar>
#else
#include <QtWidgets/QProgressBar>
#endif
#include "ibgwidgetprogressbarsubject.h"


class iqtWidgetProgressBarSubject : public QProgressBar, public ibgWidgetProgressBarSubject
{

	friend class iggSubjectFactory;

public:

	virtual ~iqtWidgetProgressBarSubject();

	virtual void SetProgress(int p);

protected:

	iqtWidgetProgressBarSubject(iggWidget *owner);

	virtual void ResetBody();

	//
	//  Qt specific
	//
#ifdef IQT_3
	virtual bool setIndicator(QString & indicator, int progress, int totalSteps);
#else
	virtual QString text() const;
#endif
};

#endif // IQTWIDGETPROGRESSBARSUBJECT_H
