//LICENSE A

//
//  Qt-based trackball
//
#ifndef IQTWIDGETTRACKBALLSUBJECT_H
#define IQTWIDGETTRACKBALLSUBJECT_H


#include "iqt.h"

#ifdef IQT_3
#include <qwidget.h>
#elif defined(IQT_4)
#include <QtGui/QWidget>
#else
#include <QtWidgets/QWidget>
#endif
#include "ibgwidgettrackballsubject.h"

#include "iarray.h"

class QBitmap;
class QMouseEvent;
class QPainter;
class QPaintEvent;
class QPixmap;
class QTimerEvent;


class iqtWidgetTrackBallSubject : public QWidget, public ibgWidgetTrackBallSubject
{

	friend class iggSubjectFactory;

public:

	virtual ~iqtWidgetTrackBallSubject();

protected:

    iqtWidgetTrackBallSubject(iggWidget *owner, bool followCamera);

	virtual void AddButton(ibgWidgetButtonSubject* button);
	virtual void GetSizes(int &w0, int &h0, int &rad, int &cor);
	virtual void Repaint();

	QPainter *mPainter;
	QPixmap *mPixmap;
	QBitmap *mPixmapMask;

	bool mInUpdate;
	iArray<int> mTimerIds;

	//
	//  Qt specific
	//
    virtual void mouseMoveEvent(QMouseEvent *e);
    virtual void mousePressEvent(QMouseEvent *e);
    virtual void mouseReleaseEvent(QMouseEvent *e);
	virtual void paintEvent(QPaintEvent *e);
	virtual void timerEvent(QTimerEvent *e);
};

#endif // IQTWIDGETTRACKBALLSUBJECT_H
