//LICENSE A

//
//  A Qt-based window helper
//

#ifndef IQTWINDOWHELPER_H
#define IQTWINDOWHELPER_H


#include "ibgwindowhelper.h"


class iImage;
class iString;

class QWidget;


class iqtWindowHelper : public ibgWindowHelper
{

public:

	iqtWindowHelper(QWidget *widget, const iImage *icon, const iString &title, bool disableClose = false);

	virtual void SetWindowGeometry(int wg[4], bool force);
	virtual void GetWindowGeometry(int wg[4], bool force) const;

	virtual void GetFrameSize(int &w, int &h) const;

	virtual void Show(bool s);
	virtual bool IsVisible() const;

	virtual void ShowAsWindow();
	virtual void ShowAsIcon();

	virtual void RestoreDecoration();

	inline QWidget* GetWidget() const { return mWidget; }

protected:

	QWidget *mWidget;

private:

	iqtWindowHelper(const iqtWindowHelper &);
	void operator=(const iqtWindowHelper &);
};

#endif  // IQTWINDOWHELPER_H
